//---------------------------------------------------------------------------
//#include <Windows.hpp>
#include <vcl.h>
#include "AboutProgWindowUnit.h"
#pragma hdrstop
//---------------------------------------------------------------------------
//#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------


const char sErrorCaption[] ="";

TAboutBoxForm *AboutBox;
HHOOK hWindowAboutProgHook = NULL;

LRESULT CALLBACK HookAboutBoxProc(int code,WPARAM wParam,LPARAM lParam)
{
const char sFuncError[] = "     \" \". ";
	try
	{
		CWPSTRUCT WinMessage;
		PCWPSTRUCT PointWinMsg;

		if(code < 0)
			return CallNextHookEx(hWindowAboutProgHook , code , wParam, lParam);

		PointWinMsg = reinterpret_cast<PCWPSTRUCT>(lParam);
		WinMessage = *PointWinMsg;

		if((WinMessage.hwnd == Application->Handle) && ((WinMessage.message == WM_ENABLE) && WinMessage.wParam))
		{
			EnableWindow(Application->Handle , false);

			LRESULT result = CallNextHookEx(hWindowAboutProgHook , code , wParam , lParam);
			UnhookWindowsHookEx(hWindowAboutProgHook);
			hWindowAboutProgHook = 0;
			return result;
		}
		return CallNextHookEx(hWindowAboutProgHook , code , wParam , lParam);
	}
	catch(Exception & e)
	{
		e.Message = sFuncError + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
		return CallNextHookEx(hWindowAboutProgHook, code, wParam, lParam);
	}
	catch(...)
	{
		Application->MessageBox(sFuncError, sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
		return CallNextHookEx(hWindowAboutProgHook, code, wParam, lParam);
	}
}
//---------------------------------------------------------------------------

__fastcall TAboutBoxForm::TAboutBoxForm(TComponent* Owner)
		: TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TAboutBoxForm::OKButtonClick(TObject *Sender)
{
Close();
}
//---------------------------------------------------------------------------

void __fastcall TAboutBoxForm::FormCreate(TObject *Sender)
{
const char sFuncError[] ="     \" \". ";
	try
	{
		DWORD winproc;

		try
		{
			if(FTaskWindowList)
				EnableTaskWindows(FTaskWindowList);
			FTaskWindowList = DisableTaskWindows(this->Handle);
		}
		catch(...)
		{
			FTaskWindowList = DisableTaskWindows(this->Handle);
		}

		if(hWindowAboutProgHook != 0)
			UnhookWindowsHookEx(hWindowAboutProgHook);
		hWindowAboutProgHook = SetWindowsHookEx(WH_CALLWNDPROC, reinterpret_cast<HOOKPROC>(&HookAboutBoxProc),0,GetWindowThreadProcessId(this->Handle,&winproc));
	}
	catch(Exception & e)
	{
		e.Message = sFuncError + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(...)
	{
		Application->MessageBox(sFuncError, sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
}
//---------------------------------------------------------------------------

void __fastcall TAboutBoxForm::FormClose(TObject *Sender,
		TCloseAction &Action)
{
const char sFuncError[] = "     \" \". ";
	try
	{
		Action = caFree;
		SetActiveWindow(Application->Handle);
	}
	catch(Exception & e)
	{
		e.Message = sFuncError + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(...)
	{
		Application->MessageBox(sFuncError, sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
}
//---------------------------------------------------------------------------

void __fastcall TAboutBoxForm::FormDestroy(TObject *Sender)
{
const char sFuncError[] = "     \" \". ";
	try
	{
		try
		{
			SetActiveWindow(Application->Handle);

			if(hWindowAboutProgHook)
				UnhookWindowsHookEx(hWindowAboutProgHook);
			hWindowAboutProgHook = 0;

			if(FTaskWindowList)
				EnableTaskWindows(FTaskWindowList);
			EnableWindow(Application->Handle, true);
			SetActiveWindow(Application->Handle);
			FTaskWindowList = NULL;
		}
		catch(...)
		{
			EnableWindow(Application->Handle, true);
			SetActiveWindow(Application->Handle);
			FTaskWindowList = NULL;
		}
	}
	catch(Exception & e)
	{
		e.Message = sFuncError + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(...)
	{
		Application->MessageBox(sFuncError, sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
}
//---------------------------------------------------------------------------

void __fastcall TAboutBoxForm::FormKeyPress(TObject *Sender, char &Key)
{
const char sFuncError[] = "       \" \". ";
	try
	{
		switch(Key)
		{
		case char(VK_TAB):
			Key =(char)0;
			break;
		}
	}
	catch(Exception & e)
	{
		e.Message = sFuncError + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(...)
	{
		Application->MessageBox(sFuncError, sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
}
//---------------------------------------------------------------------------

extern "C"__declspec(dllexport) APIENTRY void ViewAboutProg(LPSTR lpProductName) //stdcall;
{
const char sFuncError[] = "     \" \". ";
	try
	{
		DestroyAboutWindow();
		AboutBox = new TAboutBoxForm(Application);
		AboutBox->ProductName->Caption = lpProductName;
		AboutBox->Show();
	}
	catch(Exception & e)
	{
		e.Message = sFuncError + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(...)
	{
		Application->MessageBox(sFuncError, sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
}

//---------------------------------------------------------------------------

extern "C" void __declspec(dllexport) APIENTRY  DestroyAboutWindow()
//    ' ' 
//  
// !       
//      FormClose (Action:=caFree)
//      ,   
//     ,      ,
//         
{
	try
	{
		if(AboutBox)
			AboutBox->Release();
		AboutBox = NULL;
	}
	catch(...)
	{
		AboutBox = NULL;
	}
}
//---------------------------------------------------------------------------




