//---------------------------------------------------------------------------

#include <vcl.h>
#include <ddeml.hpp>
#include <strutils.hpp>
#pragma hdrstop

#include "BulsDdeErrorsUnit.h"
#include "BulsFileOptionsUnit.h"
#include "InfoToolParametersUnit.h"
#include "InfoToolWindowUnit.h"
#include "WindowDivider.h"
#include "time.h"
#include "CheckBoxSize.h"
//---------------------------------------------------------------------------
//#pragma package(smart_init)
#pragma link "BorderBitBtn"
#pragma link "WindowDivider"
#pragma resource "*.dfm"

const char sErrorCaption[] = "";

TInfoToolWindow *InfoToolWindow;
bool IsInfoToolWindowCreated = false;
HHOOK hSelTableHook = NULL;

AnsiString CheckSavedValue(TViewLines::iterator & VLIterator/*     */)
//  ,      
{
	AnsiString sSavedValue/* */;

	if(VLIterator->cViewType == 1)
	//    1 (      ), 
	{
		TInfoToolComboBox * ComboBox = dynamic_cast<TInfoToolComboBox*>(VLIterator->WorkControl);//     

		if(ComboBox != NULL)//    
		{
			if (VLIterator->bFullListValuesCreated)
			//     , ...
			{
				if (ComboBox->ItemIndex >= 0 && ComboBox->ItemIndex < ComboBox->Items->Count)
					sSavedValue = *(reinterpret_cast<AnsiString *>(ComboBox->Items->Objects[ComboBox->ItemIndex]));
				else
					sSavedValue = "";
			}
			else
				sSavedValue = ComboBox->SavedValue;//   
		}
	}
	else if(VLIterator->cViewType == 2)
	//    1 (    ), 
	{
		TInfoToolComboBox * ComboBox = dynamic_cast<TInfoToolComboBox*>(VLIterator->WorkControl);//     

		if(ComboBox != NULL)//    
		{
			if((ComboBox->ItemIndex >= 0) && (static_cast<size_t>(ComboBox->ItemIndex) < VLIterator->ListValues.size()))//  ,              , 
				sSavedValue = VLIterator->ListValues[ComboBox->ItemIndex].sSavedValue; //   
			else //    , 
				sSavedValue = ""; //  
		}
	}
	//           1,2

	switch(VLIterator->ucColumnType)
	//       
	//     ,     
	//    0
	{
		case COL_TYPE_LOGICAL:
		{//    , ...

			if(VLIterator->cViewType == 0)
			//    0 ( ,      MapInfo),
			{
				TBorderCheckBox * CheckBox = dynamic_cast<TBorderCheckBox*>(VLIterator->WorkControl);//     

				if(CheckBox != NULL)//    
				{
				//    
					if(CheckBox->Checked)
						sSavedValue = "1";
					else
						sSavedValue = "0";
				}
			}
			sSavedValue = TrimLeft(TrimRight(sSavedValue));

			if(!(sSavedValue == "0" || sSavedValue == "1"))
				sSavedValue = "0";
			if(sSavedValue == VLIterator->sValue)
				sSavedValue = "";
			break;
		}
		case COL_TYPE_SMALLINT:
		case COL_TYPE_INTEGER:
		case COL_TYPE_FLOAT:
		case COL_TYPE_DECIMAL:
		{

			if(VLIterator->cViewType == 0)
			//    0 ( ,      MapInfo),
			{
				TBorderEdit * EditText = dynamic_cast<TBorderEdit*>(VLIterator->WorkControl);

				if(EditText != NULL)
					sSavedValue =TrimLeft(TrimRight(EditText->Text));
			}

			sSavedValue = TrimLeft(TrimRight(sSavedValue));

			if(sSavedValue.Length() == 0)
				sSavedValue = "0";
			if(VLIterator->sValue.Length() == 0)
				VLIterator->sValue = "0";
			if(sSavedValue == VLIterator->sValue)
				sSavedValue = "";
			break;
		}
		case COL_TYPE_DATE:
		{
			if(VLIterator->cViewType == 0)
			//    0 ( ,      MapInfo),
			{
				TBorderDateEdit * DateEdit = dynamic_cast<TBorderDateEdit*>(VLIterator->WorkControl);

				if(DateEdit != NULL)
				{
					try
					{
						if((DateEdit->Checked))
							if((DateEdit->IsTouched))
								sSavedValue = DateToStr(DateEdit->Date);
							else
								sSavedValue =VLIterator->sValue;
						else
							sSavedValue ="";
					}
					catch(...)
					{
						sSavedValue ="";
					}
				}
			}
			if(!(sSavedValue==VLIterator->sValue))
				sSavedValue ="\""+sSavedValue+"\"";
			else
				sSavedValue ="";
			break;
		}
		default:
		{
			if(VLIterator->cViewType == 0)
			//    0 ( ,      MapInfo),
			{
				TBorderEdit * EditText = dynamic_cast<TBorderEdit*>(VLIterator->WorkControl);

				if(EditText != NULL)
					sSavedValue = EditText->Text;
			}
			sSavedValue = TrimRight(sSavedValue);

			if(!(sSavedValue == VLIterator->sValue))
				sSavedValue = "\""+AnsiReplaceStr(sSavedValue,"\"","\"\"")+"\"";
			else
				sSavedValue = "";
		}
	}
	return TrimRight(sSavedValue);
}

//---------------------------------------------------------------------------
LRESULT CALLBACK HookSelTableProc(int code, WPARAM wParam, LPARAM lParam)
//   - 
{
const char * const sFuncErr = "   HookSelTableProc: ";
	try
	{
		if((code < 0))
		{
			CallNextHookEx(hSelTableHook , code , wParam , lParam);
			return 0;
		}
		PCWPStruct PointWinMsg = reinterpret_cast<PCWPSTRUCT>(lParam);

		if((PointWinMsg->message==WM_ENABLE) && PointWinMsg->wParam)
		{
			if((PointWinMsg->hwnd == Application->Handle))
				EnableWindow(Application->Handle, false);
		}

		return CallNextHookEx(hSelTableHook , code , wParam, lParam);
	}
	catch(Exception & e)
	{
		UnhookWindowsHookEx(hSelTableHook);
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
		return 0;
	}
	catch(...)
	{
		UnhookWindowsHookEx(hSelTableHook);
		Application->MessageBox(sFuncErr, sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
		return 0;
	}
}

//---------------------------------------------------------------------------
__fastcall TInfoToolWindow::TInfoToolWindow(TComponent* Owner,HCONV NewMapInfoDDEConv, HCONV NewApplicationDDEConv, int NewDdeInstId)
	: TForm(Owner)
{
const char * const sFuncErr = "     TInfoToolWindow. ";
	try
	{
		IsInfoToolWindowCreated = true;
		FMapInfo.SetValues(NewMapInfoDDEConv, NewApplicationDDEConv, NewDdeInstId);
		FSelValueWndInstance = MakeObjectInstance(SelValueWndProc);
		AnsiString sBuffer;
		sBuffer = "Dim ";
		sBuffer += MapInfo_CurrentRowId;
		sBuffer += " as Integer Dim ";
		sBuffer += MapInfo_CurrentTableName;
		sBuffer += " as String";
		FMapInfo.Execute(sBuffer);
	}
	catch(DdeError & e)
	{
		Application->MessageBox(GetDdeMessageFormatErr(sFuncErr,e.ErrorCode).c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
}
//---------------------------------------------------------------------------
__fastcall TInfoToolWindow::TInfoToolWindow(TComponent* Owner)
	: TForm(Owner)
{
const char * const sFuncErr = "     TInfoToolWindow. ";
	try
	{
		IsInfoToolWindowCreated = true;
		FMapInfo.SetValues(0, 0, 0);
		FSelValueWndInstance = MakeObjectInstance(SelValueWndProc);
		AnsiString sBuffer;
		sBuffer = "Dim ";
		sBuffer += MapInfo_CurrentRowId;
		sBuffer += " as Integer Dim ";
		sBuffer += MapInfo_CurrentTableName;
		sBuffer += " as String";
		FMapInfo.Execute(sBuffer);
	}
	catch(DdeError & e)
	{
		Application->MessageBox(GetDdeMessageFormatErr(sFuncErr,e.ErrorCode).c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
}

__fastcall TInfoToolWindow::~TInfoToolWindow()
{
const char * const sFuncErr = "     TInfoToolWindow. ";
	try
	{
		bool bOldPrinting;
		IsInfoToolWindowCreated = false;

		SetActiveWindow(Application->Handle); //    

		try
		{
			AnsiString sBuffer;
			bOldPrinting = PrintingMapInfoError(false);
			sBuffer = "UnDim ";
			sBuffer += MapInfo_CurrentRowId;
			sBuffer += " UnDim ";
			sBuffer += MapInfo_CurrentTableName;
			FMapInfo.Execute(sBuffer);
			PrintingMapInfoError(bOldPrinting);
		}
		catch(Exception & e)
		{
			e.Message = "       MapInfo. " + e.Message;
			Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
			PrintingMapInfoError(bOldPrinting);
		}

		try
		{
			if(IsWindow(FAdditionalWindow) && (FAdditionalWindowId != 0)) //         
				if(FMapInfo.Execute("Close Window "+IntToStr(FAdditionalWindowId))) //       , 
					FAdditionalWindowId = 0; //     
		}
		catch(Exception & e)
		{
			e.Message = "      . " + e.Message;
			Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
			SendMessage(FAdditionalWindow, WM_CLOSE,0,0);
		}

		try
		{
			if(IsWindow(FSelValueWnd)) //     , 
				SendMessage(FSelValueWnd, WM_CLOSE, 0, 0); //  
		}
		catch(Exception & e)
		{
			e.Message = "      . " + e.Message;
			Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
			SendMessage(FSelValueWnd, WM_CLOSE,0,0);
		}

		FViewLines.clear(); //     

		if(hSelTableHook != 0) //            , 
			UnhookWindowsHookEx(hSelTableHook); //  
		hSelTableHook = 0; //  ,  handle 

		if(FQueryExpressionsName.Length() > 0) //          , 
			FMapInfo.CloseTable(FQueryExpressionsName); //   
		FQueryExpressionsName = ""; //   
	}
	catch(DdeError & e)
	{
		Application->MessageBox(GetDdeMessageFormatErr(sFuncErr,e.ErrorCode).c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
}
//---------------------------------------------------------------------------

void __fastcall TInfoToolWindow::FormCreate(TObject *Sender)
{
const char * const sFuncErr ="     . ";
	try
	{
		ButtonSave =  new TBorderBitBtn(this);
		ButtonSave->Parent = this;
		ButtonSave->Anchors.Clear();
		ButtonSave->Anchors << akRight << akBottom;
		ButtonSave->Left = 380;
		ButtonSave->Top = 249;
		ButtonSave->Width = 28;
		ButtonSave->Height = 28;
		ButtonSave->Hint = "    ";
		ButtonSave->TabOrder = 0;
		ButtonSave->OnClick = &ButtonSaveClick;
		ButtonSave->OnKeyPress = &AllKeyPress;
		ButtonSave->Kind = bkOK;
		ButtonSave->Caption = "";

		ButtonClose = new TBorderBitBtn(this);
		ButtonClose->Parent = this;
		ButtonClose->Anchors.Clear();
		ButtonClose->Anchors <<akRight << akBottom;
		ButtonClose->Left = 414;
		ButtonClose->Top = 249;
		ButtonClose->Width = 28;
		ButtonClose->Height = 28;
		ButtonClose->Hint = "     ";
		ButtonClose->TabOrder = 1;
		ButtonClose->OnClick = &ButtonCloseClick;
		ButtonClose->OnKeyPress = &AllKeyPress;
		ButtonClose->Kind = bkCancel;
		ButtonClose->Caption = "";

		FEditValueWindow = new TEditValueWindow(this);
		FEditValueWindow->OkButton->OnClick = EditValueWindow_OkButtonClick;
		FEditValueWindow->OnClose = EditValueWindow_Close;
		Constraints-> MinWidth = Width / 2;
		this->ScrollBox->DoubleBuffered = true;
	}
	catch(DdeError & e)
	{
		Application->MessageBox(GetDdeMessageFormatErr(sFuncErr,e.ErrorCode).c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
}
//---------------------------------------------------------------------------

void __fastcall TInfoToolWindow::FormDestroy(TObject *Sender)
{
const char * const sFuncErr = "      . ";
	try
	{
		if (FEditValueWindow) //      , 
			FEditValueWindow->Free(); //   
		ButtonClose->Free();
		ButtonSave->Free();
	}
	catch(DdeError & e)
	{
		Application->MessageBox(GetDdeMessageFormatErr(sFuncErr,e.ErrorCode).c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
}
//---------------------------------------------------------------------------

void __fastcall TInfoToolWindow::AllKeyPress(TObject *Sender, char &Key)
{
	switch (Key)
	{
	case Char(VK_TAB):
		Key = NULL;
		break;
	}
}
//---------------------------------------------------------------------------

void __fastcall TInfoToolWindow::ButtonSaveClick(TObject *Sender)
{
const char * const sFuncErr = "    . ";
	try
	{
		AnsiString sSavedValue; AnsiString sSaveTableName;
		int iSaveRowId;

		for(TViewLines::iterator VLIterator = FViewLines.begin(); VLIterator != FViewLines.end() ; ++VLIterator)
		{
			sSaveTableName = "";
			sSavedValue ="";

			if(VLIterator->sColumnName.Length() > 0)
			{
				sSaveTableName = this->FTableName;
				iSaveRowId = this->FRowId;
			}
			else if(VLIterator->sExpression.Length() > 0)
			{
				sSaveTableName = this->FQueryExpressionsName;
				iSaveRowId = 1;
			}

			if((VLIterator->siColumnNumber > 0)
			&& (VLIterator->bColumnEditable)
			&& !(sSaveTableName.Length() == 0)
			&& (iSaveRowId > 0))
			{
				sSavedValue = CheckSavedValue(VLIterator);

				if(!(sSavedValue.Length() == 0))
				{
					try
					{

						FSavingStarted =true;
						FMapInfo.Execute("update \""+sSaveTableName+"\" Set COL"+IntToStr(VLIterator->siColumnNumber)+"="+sSavedValue+" where RowId="+IntToStr(iSaveRowId));
						FSavingStarted =false;
					}
					catch(Exception & e)
					{
						FSavingStarted =false;
						e.Message = "        '"+VLIterator->sColumnName + "'  "+sSavedValue+" . " +e.Message;
						throw;
					}
				}
			}
			VLIterator->WorkControl->Free();
			VLIterator->WorkControl = NULL;
		}
		FViewLines.clear();
		Close();
	}
	catch(DdeError & e)
	{
		Application->MessageBox(GetDdeMessageFormatErr(sFuncErr,e.ErrorCode).c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(Exception & e)
	{
		e.Message = sFuncErr+e.Message;
		Application->MessageBox(e.Message.c_str() ,sErrorCaption,MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(...)
	{
		Application->MessageBox(sFuncErr,sErrorCaption,MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
}
//---------------------------------------------------------------------------

void __fastcall TInfoToolWindow::ButtonCloseClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------

void __fastcall TInfoToolWindow::EditValueWindow_OkButtonClick(TObject *Sender)
// ,    OK   
{
const char * const sFuncErr = "          . ";
	try
    {
		int iTableCountRows, iQueryCountRows, iNewRowId, iSelValueWndInstance, iOldWindowBrowseId;
		HWND hOldWindowBrowse;
		AnsiString sSelTemp,sBuffer,sNewIdentifierValue,sSavedValue;
		LPSTR lpstrCaption;
		TRect WinRect;
		TWinControl *WCSender;
		unsigned char IdentifierColumnType,ChangeableColumnType;
	// :    ,
	//         
	//    CurrentTableRowComboBox,   
	//      
		if(Sender)
			WCSender = dynamic_cast<TWinControl*>(Sender);

		if (WCSender
		 && WCSender->Owner
		 && WCSender->Owner == FEditValueWindow
		 && FCurrentComboBox
		 && FMapInfo.IsOpenedTab(FCurrentComboBox->SourceTable)
		 && FMapInfo.IsColumnPresence(FCurrentComboBox->SourceTable, FCurrentComboBox->ExpressionValue)
		 && FMapInfo.IsColumnPresence(FCurrentComboBox->SourceTable, FCurrentComboBox->ExpressionIdentifier)
		   )
		{
			EditValueWindow->Hide();
			//     ,   
			//  -   ,       
			iQueryCountRows = FMapInfo.RequestInt("TableInfo(\""+FCurrentComboBox->CurrentValuesQuery+"\","+TAB_INFO_NROWS+")");
			iTableCountRows = FMapInfo.RequestInt("TableInfo(\""+FCurrentComboBox->SourceTable+"\","+TAB_INFO_NROWS+")");

			sBuffer = "ColumnInfo(\""+FCurrentComboBox->SourceTable+"\",\""+FCurrentComboBox->ExpressionValue+"\","+COL_INFO_TYPE+")";
			ChangeableColumnType = FMapInfo.RequestInt(sBuffer);

			if (ChangeableColumnType == COL_TYPE_DATE)
			{
				if(FEditValueWindow->DateValue->Checked)
					sSavedValue = DateToStr(FEditValueWindow->DateValue->Date);
				else
					sSavedValue ="";
			}
			else
				sSavedValue = AnsiReplaceStr(FEditValueWindow->Value->Text, "\"", "\"\"");

			if (FEditValueWindow->UpdatingRow > 0)//     , ...
			{
				FMapInfo.Execute("update \""+FCurrentComboBox->SourceTable+"\" set "+FCurrentComboBox->ExpressionValue+"=\""+sSavedValue+"\" where RowId="+IntToStr(FEditValueWindow->UpdatingRow));//     ValueColumnName  
			}
			else if(FMapInfo.Execute("Insert Into \""+FCurrentComboBox->SourceTable+"\" ("+FCurrentComboBox->ExpressionValue+") values(\""+sSavedValue+"\")"))
			//    ,      ,
			//    , ...
			{
				iNewRowId = FMapInfo.RequestInt("TableInfo(\""+FCurrentComboBox->SourceTable+"\","+TAB_INFO_NROWS+")");

				//     
				if (AnsiLowerCase(TrimLeft(TrimRight(FMapInfo.Request("columninfo(\""+FCurrentComboBox->SourceTable+"\",\""+FCurrentComboBox->ExpressionIdentifier+"\","+COL_INFO_EDITABLE+")"))))=="t"
				 && iNewRowId > iTableCountRows)
				{
					sBuffer = "ColumnInfo(\""+FCurrentComboBox->SourceTable+"\",\""+FCurrentComboBox->ExpressionIdentifier+"\","+COL_INFO_TYPE+")";
					IdentifierColumnType = FMapInfo.RequestInt(sBuffer);
					if (IdentifierColumnType==COL_TYPE_INTEGER ||
						IdentifierColumnType==COL_TYPE_SMALLINT ||
						IdentifierColumnType==COL_TYPE_FLOAT ||
						IdentifierColumnType==COL_TYPE_DECIMAL)
					{
						sSelTemp = FMapInfo.SelCustomTemp("SelMaxId");
						if(FMapInfo.Execute("Select Max("+FCurrentComboBox->ExpressionIdentifier+") from \""+FCurrentComboBox->SourceTable+"\" into \""+sSelTemp+"\" noselect"))
						{
							if(FMapInfo.Execute("Fetch First From \""+sSelTemp+"\""))
								try
								{
									//int iNewIdValue;
									//double dNewIdValue;
									if (IdentifierColumnType==COL_TYPE_INTEGER ||
										IdentifierColumnType==COL_TYPE_SMALLINT)
										sNewIdentifierValue = IntToStr(FMapInfo.RequestInt(sSelTemp+".COL1")+1);
									else if (IdentifierColumnType==COL_TYPE_FLOAT)
									{
										DecimalSeparator = '.';
										sNewIdentifierValue = FloatToStr(StrToFloatDef(FMapInfo.GetFloatValue(sSelTemp+".COL1"),0)+1);
									}
									else if (IdentifierColumnType==COL_TYPE_DECIMAL)
									{
										DecimalSeparator = '.';
										sNewIdentifierValue = FloatToStr(StrToFloatDef(FMapInfo.GetDecimalValue(sSelTemp+".COL1"),0)+1);
									}
									//iNewIdValue = FMapInfo.RequestInt(sSelTemp+".COL1")+1;
									//sNewIdentifierValue = IntToStr(iNewIdValue);
									FMapInfo.Execute("Update \""+FCurrentComboBox->SourceTable+"\" Set \""+FCurrentComboBox->ExpressionIdentifier+"\"="+sNewIdentifierValue+" where RowId="+IntToStr(iNewRowId));
								}
								catch(...)
								{
									Application->MessageBox("       .   .", sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
								}
							FMapInfo.CloseTable(sSelTemp);
						}
					}
					else if(IdentifierColumnType==COL_TYPE_DATE)
						try
						{
							sNewIdentifierValue = DateToStr(Date());
							FMapInfo.Execute("Update \""+FCurrentComboBox->SourceTable+"\" Set \""+FCurrentComboBox->ExpressionIdentifier+"\"=\""+sNewIdentifierValue+"\" where RowId="+IntToStr(iNewRowId));
						}
						catch(...)
						{
							Application->MessageBox("       .   .", sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
						}
				}
				//       ,
				//   
				if(iQueryCountRows == FMapInfo.RequestInt("TableInfo(\""+FCurrentComboBox->CurrentValuesQuery+"\","+TAB_INFO_NROWS+")"))
				{
					//       
					if(IsWindow(FSelValueWnd))
						GetWindowRect(FSelValueWnd , &WinRect);
					try
					{
						hOldWindowBrowse = this->FSelValueWnd;
						iOldWindowBrowseId = FSelValueWindowId;
						iSelValueWndInstance = SetWindowLong(hOldWindowBrowse, GWL_WNDPROC, reinterpret_cast<int>(this->FOldSelValueWndProc));
						this->FSelValueWnd = 0;
						//     
						if(!this->CreateNewSelValueWindow(!reinterpret_cast<TInfoToolComboBox::TBoundLabel*>(FCurrentComboBox->EditLabel)->SelectNewTableRow,sNewIdentifierValue))
						//    ,     
						{
							this->FSelValueWnd = hOldWindowBrowse;
							this->FOldSelValueWndProc = reinterpret_cast<FARPROC>(SetWindowLong(hOldWindowBrowse, GWL_WNDPROC, iSelValueWndInstance));
						}
						else
						//   ,    
						{
							//    
							lpstrCaption = StrAlloc(GetWindowTextLength(hOldWindowBrowse)+1);
							GetWindowText(hOldWindowBrowse, lpstrCaption, GetWindowTextLength(hOldWindowBrowse) +1);
							FMapInfo.CloseTable(FMapInfo.Request("WindowInfo("+IntToStr(iOldWindowBrowseId)+","+WIN_INFO_TABLE+")", 31));
							FMapInfo.Execute("Set Window "+IntToStr(FSelValueWindowId)+" title \""+lpstrCaption+"\"");
							StrDispose(lpstrCaption);
							//      
							MoveWindow(FSelValueWnd , WinRect.Left , WinRect.Top , WinRect.Right - WinRect.Left , WinRect.Bottom - WinRect.Top , true);

							if(iQueryCountRows == FMapInfo.RequestInt("TableInfo(\""+FCurrentComboBox->CurrentValuesQuery+"\","+TAB_INFO_NROWS+")"))
							{
								sBuffer = "  \'"+FCurrentComboBox->SourceTable+"\'    ,     "+
								"   ,         ,      .";
								Application->MessageBox(sBuffer.c_str(), "!", MB_OK | MB_ICONWARNING | MB_TASKMODAL);
							}
							else
							{
								FCurrentComboBox->SavedValue = sNewIdentifierValue;
								//sSelTemp = FMapInfo.SelCustomTemp("SelTemp");
								//FMapInfo.Execute("Select * from \"" + FCurrentComboBox->SourceTable + "\" where RowId=" + IntToStr(iNewRowId) + " into \"" + sSelTemp + "\"");
								//FMapInfo.CloseTable(sSelTemp);
								//FindValueInBrowse();
							}
							SetActiveWindow(Application->Handle);
							SetForegroundWindow(FSelValueWnd);
						}
					}
					catch(Exception & e)
					{
						if (this->FSelValueWnd == 0)
						{
							this->FSelValueWnd = hOldWindowBrowse;
							this->FOldSelValueWndProc = reinterpret_cast<FARPROC>(SetWindowLong(hOldWindowBrowse,GWL_WNDPROC,iSelValueWndInstance));
						}
						e.Message = "          . "+e.Message;
						Application->MessageBox(e.Message.c_str(),sErrorCaption,MB_OK | MB_ICONERROR | MB_TASKMODAL);
					}
				}
				else
				{
					//    ,    
					//     
					FCurrentComboBox->SavedValue = sNewIdentifierValue;
					sSelTemp = FMapInfo.SelCustomTemp("SelTemp");
					FMapInfo.Execute("Select * from \"" + FCurrentComboBox->SourceTable + "\" where RowId=" + IntToStr(iNewRowId) + " into \"" + sSelTemp + "\"");
					FMapInfo.CloseTable(sSelTemp);
					FindValueInBrowse();
				}
			}
			FEditValueWindow->Close();
		}
	}
	catch(DdeError & e)
	{
		Application->MessageBox(GetDdeMessageFormatErr(sFuncErr,e.ErrorCode).c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
    catch(Exception & e)
    {
		e.Message = sFuncErr+e.Message;
		Application->MessageBox(e.Message.c_str() ,sErrorCaption,MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
    catch(...)
    {
		Application->MessageBox(sFuncErr,sErrorCaption,MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}

}
//---------------------------------------------------------------------------

void __fastcall TInfoToolWindow::EditValueWindow_Close(TObject * Sender,  TCloseAction & Action)
{
const char * const sFuncErr = "     . ";
	try
    {
		SetActiveWindow(Application->Handle);
		if(IsWindow(FSelValueWnd))
			EnableWindow(FSelValueWnd, true);
	}
    catch(Exception & e)
    {
		e.Message = sFuncErr+e.Message;
		Application->MessageBox(e.Message.c_str() ,sErrorCaption,MB_OK | MB_ICONERROR | MB_TASKMODAL);
    	if (IsWindow(FSelValueWnd))
			EnableWindow(FSelValueWnd,true);
	}
    catch(...)
    {
		Application->MessageBox(sFuncErr,sErrorCaption,MB_OK | MB_ICONERROR | MB_TASKMODAL);
    	if (IsWindow(FSelValueWnd))
			EnableWindow(FSelValueWnd,true);
	}
}
//---------------------------------------------------------------------------


void __fastcall TInfoToolWindow::FormClose(TObject *Sender,
	  TCloseAction &Action)
{
const char * const sFuncErr = "      . ";
	try
	{
		Action = caFree; //      
		Hide(); //    
		SetActiveWindow(Application->Handle); //    
		if(!IsWindowEnabled(Application->Handle)) //     , 
			EnableWindow(Application->Handle, true); //   
	}
	catch(DdeError & e)
	{
		Application->MessageBox(GetDdeMessageFormatErr(sFuncErr,e.ErrorCode).c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
}
//---------------------------------------------------------------------------

void __fastcall TInfoToolWindow::ComboBoxLabelMouseUp(TObject *Sender,
	  TMouseButton Button, TShiftState Shift, int X, int Y)
//    
{
const char * const sFuncErr = "   ComboBoxLabelMouseUp. ";
	try
	{
		DWORD winproc;
		TInfoToolComboBox::TBoundLabel * ELabel;

		if(Sender == NULL)
			return;
		if(Button != mbLeft)
		//      ,    
			return;
		ELabel = dynamic_cast<TInfoToolComboBox::TBoundLabel*>(Sender);
		if (ELabel == NULL)
			return;
		ELabel->Font->Style = TFontStyles() >> fsUnderline;

		if((this->FSelValueWnd !=0) && IsWindow(this->FSelValueWnd))
		//      ,    
			return;

//    
		if(ELabel->Owner)
		{
			FCurrentComboBox = dynamic_cast<TInfoToolComboBox*>(ELabel->Owner);
			if(FCurrentComboBox == NULL)
				return;
		}
		else
			return;

	//     
		if(!this->CreateNewSelValueWindow(ELabel->SelectNewTableRow,FCurrentComboBox->SavedValue))
		//    ,    
			return;

		if(hSelTableHook != 0)
			UnhookWindowsHookEx(hSelTableHook);
		hSelTableHook = 0;
		if((FSelValueWnd != 0) && IsWindow(FSelValueWnd))
			hSelTableHook = SetWindowsHookEx(WH_CALLWNDPROC,reinterpret_cast<HOOKPROC>(&HookSelTableProc),0,GetWindowThreadProcessId(Application->Handle,  &winproc));

		if(FSelValueWnd != 0)
		{
			FMapInfo.Execute("Set Window "+IntToStr(FSelValueWindowId)+" title \""+LeftStr(ELabel->Caption, ELabel->Caption.Length()-1)+"\"");
			SetActiveWindow(FSelValueWnd);
		}
		if(!ELabel->SelectNewTableRow || AnsiLowerCase(TrimLeft(TrimRight(FMapInfo.Request("ColumnInfo(\""+FCurrentComboBox->CurrentValuesQuery+"\",\"COL3\","+COL_INFO_EDITABLE+")", 1))))=="t")
		{
			FMapInfo.Execute(MapInfo_InternalProcedureAddCreationOfValue);
			FMapInfo.Execute(MapInfo_InternalProcedureAddUpdatingOfValue);
		}
		EnableWindow(Application->Handle, false);
		this->Enabled = false;
	}
	catch(DdeError & e)
	{
		Application->MessageBox(GetDdeMessageFormatErr(sFuncErr,e.ErrorCode).c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
}

void __fastcall TInfoToolWindow::WMSizing(TMessage & Message)
{
TForm::Dispatch(&Message);
PRECT PointToRect = (PRECT) Message.LParam;

	if(PointToRect != NULL)
	{
		if((this->Constraints->MaxHeight > 0) && (PointToRect->bottom - PointToRect->top >= this->Constraints->MaxHeight))
		{
			if((Message.WParam == WMSZ_TOP) || (Message.WParam == WMSZ_TOPLEFT) || (Message.WParam == WMSZ_TOPRIGHT))
				PointToRect->top = PointToRect->bottom - this->Constraints->MaxHeight;else
		PointToRect->bottom = PointToRect->top + this->Constraints->MaxHeight;
		}
		else if((this->Constraints->MinHeight > 0) && (PointToRect->bottom - PointToRect->top <= this->Constraints->MinHeight))
		{
			if((Message.WParam == WMSZ_TOP) || (Message.WParam == WMSZ_TOPLEFT) || (Message.WParam == WMSZ_TOPRIGHT))
				PointToRect->top = PointToRect->bottom - this->Constraints->MinHeight;else
			PointToRect->bottom = PointToRect->top + this->Constraints->MinHeight;
		}

		if((this->Constraints->MaxWidth > 0) && (PointToRect->right - PointToRect->left >= this->Constraints->MaxWidth))
		{
			if((Message.WParam == WMSZ_RIGHT) || (Message.WParam == WMSZ_TOPRIGHT) || (Message.WParam == WMSZ_BOTTOMRIGHT))
				PointToRect->right = PointToRect->left + this->Constraints->MaxWidth;else
			PointToRect->left = PointToRect->right - this->Constraints->MaxWidth;
		}
		else if((this->Constraints->MinWidth > 0) && (PointToRect->right - PointToRect->left <= this->Constraints->MinWidth))
		{
			if((Message.WParam == WMSZ_RIGHT) || (Message.WParam == WMSZ_TOPRIGHT) || (Message.WParam == WMSZ_BOTTOMRIGHT))
				PointToRect->right = PointToRect->left + this->Constraints->MinWidth;else
			PointToRect->left = PointToRect->right - this->Constraints->MinWidth;
		}
	}
}

void __fastcall TInfoToolWindow::WMSetCursor(TWMSetCursor & Message)
{
	Enabled = IsWindowEnabled(Application->Handle);
	TForm::Dispatch(&Message);
}

void __fastcall TInfoToolWindow::WMPaint(TWMPaint & Message)
{
	Enabled = IsWindowEnabled(Application->Handle);
	TForm::Dispatch(&Message);
}

void __fastcall TInfoToolWindow::WMWindowPosChanging(TWMWindowPosChanging & Message)
{
	TForm::Dispatch(&Message);
	Enabled = IsWindowEnabled(Application->Handle);
}

void __fastcall TInfoToolWindow::CreateParams(TCreateParams & Params)
{
	inherited:: CreateParams(Params);
	Params.Style = Params.Style | WS_POPUP | WS_DLGFRAME | !(WS_CAPTION | WS_SYSMENU);
}


void __fastcall TInfoToolWindow::SelValueWndProc(TMessage & Msg)
//  - MapInfo
//       
{
const char * const sFuncErr = "   -     . ";
	try
	{
		AnsiString sSelTemp; AnsiString sCurrentQuery; AnsiString sBuffer,sBuffer2;
		short siNumTables;
		bool bCloseQuery; bool bTruly;
		unsigned char ucColumnType;
		int i;

		if((Msg.Msg == WM_CLOSE))
		{
			SetActiveWindow(Application->Handle);
			if(FCurrentComboBox != NULL)
			{
				FMapInfo.Execute(MapInfo_InternalProcedureRemoveCreationOfValue);
				FMapInfo.Execute(MapInfo_InternalProcedureRemoveUpdatingOfValue);
				sBuffer = "SelectionInfo(";
				sBuffer2 = sBuffer;
				sBuffer += SEL_INFO_NROWS;
				sBuffer2 += SEL_INFO_TABLENAME;
				sBuffer += ")";
				sBuffer2 += ")";
				if (FMapInfo.RequestInt(sBuffer)>0
				 && AnsiLowerCase(FCurrentComboBox->SourceTable) == AnsiLowerCase(FMapInfo.Request(sBuffer2, 31))
				   )
				{
					siNumTables = FMapInfo.NumTables();
					sBuffer = "SelectionInfo(";
					sBuffer += SEL_INFO_SELNAME;
					sBuffer += ")";
					sCurrentQuery = FMapInfo.Request(sBuffer , 31);
					if(siNumTables < FMapInfo.NumTables())
						bCloseQuery = true;

					if(FMapInfo.IsColumnPresence(sCurrentQuery, FCurrentComboBox->ExpressionIdentifier))
					{
						FMapInfo.Execute("Fetch First From \""+sCurrentQuery+"\"");
						ucColumnType = FMapInfo.RequestInt("ColumnInfo(\""+sCurrentQuery+"\",\""+FCurrentComboBox->ExpressionIdentifier+"\","+COL_INFO_TYPE+")");
						if (ucColumnType==COL_TYPE_DATE)
						//       ""
							FCurrentComboBox->SavedValue = FMapInfo.GetDateValue(sCurrentQuery+"."+FCurrentComboBox->ExpressionIdentifier);
						else if (ucColumnType==COL_TYPE_FLOAT)
							FCurrentComboBox->SavedValue = FMapInfo.GetFloatValue(sCurrentQuery+"."+FCurrentComboBox->ExpressionIdentifier);
						else if (ucColumnType==COL_TYPE_DECIMAL)
							FCurrentComboBox->SavedValue = FMapInfo.GetDecimalValue(sCurrentQuery+"."+FCurrentComboBox->ExpressionIdentifier);
						else
						//       
							FCurrentComboBox->SavedValue = FMapInfo.Request(sCurrentQuery+"."+FCurrentComboBox->ExpressionIdentifier);

						sBuffer =FCurrentComboBox->SavedValue;
						if((sBuffer.Length() == 0))
						{
							/*if((ucColumnType==COL_TYPE_DATE) || (ucColumnType==COL_TYPE_CHAR))
								sBuffer ="\"\"";
							else */
							if((ucColumnType==COL_TYPE_LOGICAL)
							|| (ucColumnType==COL_TYPE_FLOAT)
							|| (ucColumnType==COL_TYPE_DECIMAL)
							|| (ucColumnType==COL_TYPE_INTEGER)
							|| (ucColumnType==COL_TYPE_SMALLINT))
								sBuffer ="0";
							else
								sBuffer ="\"\"";
						}
						else
						{
							if (ucColumnType == COL_TYPE_CHAR || ucColumnType == COL_TYPE_DATE)
								sBuffer= "\""+ sBuffer +"\"";
						}
						sSelTemp =FMapInfo.SelCustomTemp("SelExpressions");
						/*bTruly =false;*/

						if(FCurrentComboBox->AdditionalCondition.Length() > 0)
							bTruly =FMapInfo.Execute("Select "+FCurrentComboBox->ExpressionViewedValue+","+FCurrentComboBox->ExpressionIdentifier+" from \""+FCurrentComboBox->SourceTable+"\" where "+FCurrentComboBox->AdditionalCondition+" into \""+sSelTemp+"\" noselect");
						else
							bTruly =FMapInfo.Execute("Select "+FCurrentComboBox->ExpressionViewedValue+","+FCurrentComboBox->ExpressionIdentifier+" from \""+FCurrentComboBox->SourceTable+"\" into \""+sSelTemp+"\" noselect");

						if(bTruly)
						{
							if(FMapInfo.Execute("Select * from \""+sSelTemp+"\" where COL2="+sBuffer+" into \""+sSelTemp+"\" noselect"))
							{
								FCurrentComboBox->Clear();
								for(i = 1 ; i <= FMapInfo.RequestInt("TableInfo(\""+sSelTemp+"\","+TAB_INFO_NROWS+")") ; ++i)
								{
									FMapInfo.Execute("Fetch Rec "+IntToStr(i)+" from \""+sSelTemp+"\"");
									if(FMapInfo.RequestInt("ColumnInfo(\""+sSelTemp+"\",\"COL1\","+COL_INFO_TYPE+")")==COL_TYPE_DATE)
										sBuffer =FMapInfo.Request("Str$("+sSelTemp+".COL1)");
									else
										sBuffer =FMapInfo.Request(sSelTemp+".COL1");
									FCurrentComboBox->AddItem(sBuffer, NULL);
								}
								FCurrentComboBox->ItemIndex =0;
								FCurrentComboBox->DefaultValue = FCurrentComboBox->Items->Strings[0];
							}
							FMapInfo.CloseTable(sSelTemp);
						}
					}
					if(bCloseQuery)
						FMapInfo.CloseTable(sCurrentQuery);
					FMapInfo.Execute("Close Table \"Selection\"");
				}

				if(reinterpret_cast<HWND>(MapInfo.RequestInt("WindowInfo("+IntToStr(this->FSelValueWindowId)+","+WIN_INFO_WND+")"))==this->FSelValueWnd)
				{
					sBuffer = FMapInfo.Request("WindowInfo("+IntToStr(this->FSelValueWindowId)+","+WIN_INFO_TABLE+")", 31);
					if((sBuffer==FCurrentComboBox->SourceTable) || (sBuffer==FCurrentComboBox->CurrentValuesQuery))
					{
						FMapInfo.CloseTable(FCurrentComboBox->CurrentValuesQuery);
						FCurrentComboBox->CurrentValuesQuery ="";
					}
				}

				if((this->FTableName.Length() > 0) && (this->FRowId>0) && bToSelectObjectInMap)
					FMapInfo.Execute("Select * from \""+this->FTableName+"\" where RowId="+IntToStr(this->FRowId)+" into Selection");
			}
        }
		else if((Msg.Msg == WM_DESTROY))
		{
			UnhookWindowsHookEx(hSelTableHook);
			hSelTableHook = 0;

			this->Enabled = true;
			EnableWindow(Application->Handle , true);
		}
		Msg.Result =CallWindowProc(FOldSelValueWndProc, FSelValueWnd, Msg.Msg, Msg.WParam, Msg.LParam);
	}
	catch(DdeError & e)
	{
		Application->MessageBox(GetDdeMessageFormatErr(sFuncErr,e.ErrorCode).c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
}

bool TInfoToolWindow::CreateNewSelValueWindow(bool ReadOnly, AnsiString & FoundValue)
{
const char * const sFuncErr = "   CreateNewSelValueWindow. ";
	try
	{
		bool bTruly;
		unsigned char ucColumnType;
		AnsiString sBuffer; AnsiString sSelTemp,sNewValuesQuery;

		if(FCurrentComboBox &&
		   ((FCurrentComboBox->SourceTable.Length() > 0) && (FCurrentComboBox->ExpressionIdentifier.Length() > 0) && (FCurrentComboBox->ExpressionViewedValue.Length() > 0))
		  )
		{
			sNewValuesQuery= FMapInfo.SelCustomTemp("SelValues");
			//  
			sBuffer = "Select "+FCurrentComboBox->ExpressionViewedValue+","+FCurrentComboBox->ExpressionIdentifier+","+FCurrentComboBox->ExpressionValue;

			sBuffer += " From \""+FCurrentComboBox->SourceTable+"\"";

			if(FCurrentComboBox->AdditionalCondition.Length() > 0)
				sBuffer += " Where "+FCurrentComboBox->AdditionalCondition;
			sBuffer += " Into \""+sNewValuesQuery+"\" Order By Col1 NoSelect";
			bTruly = FMapInfo.Execute(sBuffer);

			if(bTruly)
			{
				sBuffer = "Set Next Document Style ";
				sBuffer += WIN_STYLE_POPUP;
				if (FMapInfo.Execute(sBuffer)
				 && FMapInfo.Execute("Browse COL1 \""+LeftStr(FCurrentComboBox->EditLabel->Caption, FCurrentComboBox->EditLabel->Caption.Length() -1)+"\",COL2 \"Id\" From \""+sNewValuesQuery+"\"")
				   )
				{
					sBuffer = "WindowInfo(NumWindows(),";
					sBuffer += WIN_INFO_WND;
					sBuffer += ")";
					FSelValueWnd = reinterpret_cast<HWND>(FMapInfo.RequestInt(sBuffer));
					FSelValueWindowId = FMapInfo.RequestInt("WindowID(NumWindows())");
					FOldSelValueWndProc = reinterpret_cast<FARPROC>(SetWindowLong(FSelValueWnd, GWL_WNDPROC, int(this->FSelValueWndInstance)));

					DeleteMenu(GetSystemMenu(FSelValueWnd, false), SC_MINIMIZE, MF_BYCOMMAND);
					DeleteMenu(GetSystemMenu(FSelValueWnd, false), SC_MAXIMIZE, MF_BYCOMMAND);
					DeleteMenu(GetSystemMenu(FSelValueWnd, false), SC_RESTORE, MF_BYCOMMAND);
					FMapInfo.Execute("Set Window "+IntToStr(FSelValueWindowId)+" ReadOnly");

					ucColumnType = FMapInfo.RequestInt("ColumnInfo(\""+sNewValuesQuery+"\",\"COL2\","+COL_INFO_TYPE+")");
					sBuffer = FoundValue;
					if((sBuffer.Length() == 0))
					{
						/*if((ucColumnType==COL_TYPE_DATE) || (ucColumnType==COL_TYPE_CHAR))
							sBuffer ="\"\"";
						else */
						if((ucColumnType==COL_TYPE_LOGICAL)
						|| (ucColumnType==COL_TYPE_FLOAT)
						|| (ucColumnType==COL_TYPE_DECIMAL)
						|| (ucColumnType==COL_TYPE_INTEGER)
						|| (ucColumnType==COL_TYPE_SMALLINT))
							sBuffer ="0";
						else
							sBuffer ="\"\"";
					}
					else
					{
						if (FCurrentComboBox->SavedValueType == COL_TYPE_CHAR || ucColumnType == COL_TYPE_DATE)
							sBuffer= "\""+ sBuffer +"\"";
					}

				sSelTemp =FMapInfo.SelCustomTemp("SelTemp");
					if(FMapInfo.Execute("Select * from \""+sNewValuesQuery+"\" where COL2="+sBuffer+" into \""+sSelTemp+"\""))
					{
						AnsiString s="Select * from \""+sNewValuesQuery+"\" where COL2="+sBuffer+" into \""+sSelTemp+"\"";
 						if(FMapInfo.RequestInt("TableInfo("+sSelTemp+","+TAB_INFO_NROWS+")")>1)
							FMapInfo.Execute("Select * from \""+sSelTemp+"\" where RowId=1 into \""+sSelTemp+"\"");

						if(FMapInfo.RequestInt("TableInfo("+sSelTemp+","+TAB_INFO_NROWS+")")>0)
							this->FindValueInBrowse();
						FMapInfo.CloseTable(sSelTemp);
	  				}
					FCurrentComboBox->CurrentValuesQuery = sNewValuesQuery;
				}
				else
				{
					FSelValueWnd =0;
					sBuffer = "Set Next Document Parent Systeminfo(";
					sBuffer += SYS_INFO_MDICLIENTWND;
					sBuffer += ") Style ";
					sBuffer += WIN_STYLE_STANDARD;
					FMapInfo.Execute(sBuffer);
					FMapInfo.CloseTable(sNewValuesQuery);
				}
				return true;
			}
  		}
	}
	catch(Exception &e)
	{
		e.Message = sFuncErr + e.Message;
		throw;
	}
	catch(...)
	{
		throw;
	}
return false;
}

void TInfoToolWindow::FindValueInBrowse()
{
const char * const sFuncErr = "   FindValueInBrowse. ";
	if (bToFindValueInBrowse)
		try
		{
			AnsiString sBuffer;
			FFindingStarted =true;
			FMapInfo.Execute("Set Map Window "+IntToStr(this->FCurrentMapWindowId)+" Redraw Off");
			sBuffer = "Run Menu Command ";
			sBuffer += M_QUERY_FIND_SELECTION;
			FMapInfo.Execute(sBuffer);
			FFindingStarted =false;
		}
		catch(Exception &e)
		{
			e.Message = sFuncErr + e.Message;
			throw;
		}
		catch(...)
		{
			FFindingStarted =false;
			throw;
		}
}

bool TInfoToolWindow::StartInfoToolWindow()
{

BorderStyle = bsSizeToolWin;
	if(
	  CreateAdditionalWindow() &&
	  TakeParametersInfoFields() &&
	  CreateInfoFields()
	  )
		return true;
	else
		return false;
}

bool TInfoToolWindow::CreateAdditionalWindow()
{
const char * const sFuncErr = "    CreateAdditionalWindow. ";
	try
	{
		short si;
		AnsiString sBuffer;
		//     .
		//     ,    
		//    MapInfo,        
		//   Parent '+IntToStr(AdditionalWindowFrame.Handle)+'
		sBuffer = "Set Next Document Style ";
		sBuffer += WIN_STYLE_POPUP;
		FMapInfo.Execute(sBuffer);
		si = FMapInfo.NumWindows();
		if (FMapInfo.Execute("Map from \""+FTableName+"\" position (-100,-100) width 1 height 1")
		 && si<FMapInfo.NumWindows()
		   )
		{
			FAdditionalWindowId = FMapInfo.RequestInt("WindowId(NumWindows())");
			FAdditionalWindow = reinterpret_cast<HWND>(FMapInfo.RequestInt("WindowInfo("+IntToStr(FAdditionalWindowId)+","+WIN_INFO_WND+")"));
			FMapInfo.Execute("Set Map Window "+IntToStr(FAdditionalWindowId)+" Redraw Off");
			FMapInfo.Execute("Set Window "+IntToStr(FAdditionalWindowId)+" title \""+IntToStr(FAdditionalWindow)+"\"");
			return true;
		}
		return false;
	}
	catch(Exception &e)
	{
		e.Message = sFuncErr + e.Message;
		throw;
	}
	catch(...)
	{
		throw;
	}
}

bool TInfoToolWindow::TakeParametersInfoFields()
//      
{
const char * const sFuncErr = "    TakeParametersInfoFields. ";
	try
	{
		AnsiString sSelName; AnsiString sTableName;
		TBorderEdit * LineEdit;

		if(!ToTakeParametersOfAttributes(FMapInfo, this->FTableName, this->FRowId, FViewLines, sSelName, false)) //     
			throw Exception("      ."); //   -     ,   
		//      
		//    ,       MapInfo
		//        (  )
		if(sSelName.Length() > 0)
		{
			FMapInfo.Execute("Set Table \""+sSelName+"\" UserClose Off UserMap Off UserBrowse Off UserEdit Off UserDisplayMap Off");
			FQueryExpressionsName = sSelName;
		}
		//     
		LineEdit = new TBorderEdit(this);
		LineEdit->Parent =this;
		LineEdit->AutoSize =true;
		//    
		FAverageLineHeight =LineEdit->Height;
		//      
//MessageBox(0,"111","TakeParametersInfoFields",0);
		if(FViewLines.size() >0)
			for(TViewLines::iterator VLIterator = FViewLines.begin(); VLIterator != FViewLines.end(); ++VLIterator)
				if (VLIterator->cViewType >= 0)
				{
					LineEdit->EditLabel->Caption = VLIterator->sLineName+":";
					sTableName ="";

					if(VLIterator->sColumnName.Length()>0)
						sTableName =this->FTableName;
					else
					sTableName =this->FQueryExpressionsName;

					if(FMaxCaptionLength < LineEdit->EditLabel->Width)
						FMaxCaptionLength = LineEdit->EditLabel->Width;

					if(VLIterator->bColumnEditable)
						VLIterator->bColumnEditable = static_cast<bool>(FMapInfo.RequestInt("format$(Columninfo(\""+sTableName+"\",\"COL"+IntToStr(VLIterator->siColumnNumber)+"\","+COL_INFO_EDITABLE+"),\"0\")"));

					if(this->FTableName.Length() > 0)
						FMapInfo.Execute("fetch rec "+IntToStr(this->FRowId)+" from \""+this->FTableName+"\"");

					if(this->FQueryExpressionsName.Length() > 0)
						FMapInfo.Execute("Fetch first from \""+this->FQueryExpressionsName+"\"");

					if((VLIterator->ucColumnType==COL_TYPE_LOGICAL)
					|| (VLIterator->ucColumnType==COL_TYPE_INTEGER)
					|| (VLIterator->ucColumnType==COL_TYPE_SMALLINT))
					{
						VLIterator->sValue =FMapInfo.Request("format$("+sTableName+".COL"+IntToStr(VLIterator->siColumnNumber)+",\"0\")");
					}
					else if((VLIterator->ucColumnType==COL_TYPE_FLOAT))
					{
						//       float
						// ,   
						//format$(),    "" ( ),
						//MapInfo   
						VLIterator->sValue = FMapInfo.GetFloatValue(sTableName+".COL"+IntToStr(VLIterator->siColumnNumber));
					}
					else if((VLIterator->ucColumnType==COL_TYPE_DECIMAL))
					{
						VLIterator->ValueWidth = FMapInfo.RequestInt("ColumnInfo("+sTableName+",\"COL"+IntToStr(VLIterator->siColumnNumber)+"\","+COL_INFO_WIDTH+")");
						VLIterator->ValueDecimals = FMapInfo.RequestInt("ColumnInfo("+sTableName+",\"COL"+IntToStr(VLIterator->siColumnNumber)+"\","+COL_INFO_DECPLACES+")");
						VLIterator->sValue = FMapInfo.GetDecimalValue(sTableName+".COL"+IntToStr(VLIterator->siColumnNumber));
					}
					else if(VLIterator->ucColumnType==COL_TYPE_DATE)
					{
						/*VLIterator->sValue =FMapInfo.Request(sTableName+".COL"+IntToStr(VLIterator->siColumnNumber));
						if(TrimLeft(VLIterator->sValue).Length() >0)*/
						VLIterator->sValue = FMapInfo.GetDateValue(sTableName+".COL"+IntToStr(VLIterator->siColumnNumber));
						//	VLIterator->sValue =FMapInfo.Request("str$("+sTableName+".COL"+IntToStr(VLIterator->siColumnNumber)+")");
					}
					else if(VLIterator->ucColumnType==COL_TYPE_CHAR)
					{
						VLIterator->ValueWidth = FMapInfo.RequestInt("ColumnInfo("+sTableName+",\"COL"+IntToStr(VLIterator->siColumnNumber)+"\","+COL_INFO_WIDTH+")");
						VLIterator->sValue =FMapInfo.Request(sTableName+".COL"+IntToStr(VLIterator->siColumnNumber));
					}
					else
						VLIterator->sValue =FMapInfo.Request(sTableName+".COL"+IntToStr(VLIterator->siColumnNumber));

					VLIterator->sValue = TrimRight(VLIterator->sValue);
					if(VLIterator->cViewType==1 && !this->FMapInfo.IsOpenedTab(VLIterator->sListTable))
						VLIterator->cViewType =0;
				}
//MessageBox(0,"555","TakeParametersInfoFields",0);
		LineEdit->Free();
//MessageBox(0,"666","TakeParametersInfoFields",0);
		return true;
	}
	catch(Exception &e)
	{
		e.Message = sFuncErr + e.Message;
		throw;
	}
	catch(...)
	{
		throw;
	}
}

bool TInfoToolWindow::CreateInfoFields()
//     
{
const char * const sFuncErr = "    CreateInfoFields. ";
	try
	{
		TViewLines::iterator VLIterator;
		short siLineHeight = 0; short siy = 0; short six = 0; short siFrameHeight = 0; short siMinFrameHeight = 0; short siMaxFrameHeight = 0;
		AnsiString sBuffer; AnsiString sSelValues,sSelCurrentValue; AnsiString sQueryString;
		bool bTruly;
		bool bOldPrinting;
		unsigned char byIdentifierType,byValueType;
		HDC HDCwin;
		SIZE TextSIZE;

		if (FViewLines.empty())
			return false;

		try
		{
			//      MapInfo
			bOldPrinting = PrintingMapInfoError(false);
			sBuffer = MapInfo_CurrentRowId;
			sBuffer += "="+IntToStr(FRowId);
			FMapInfo.Execute(sBuffer);

			sBuffer = MapInfo_CurrentTableName;
			sBuffer += "=\""+FTableName+"\"";
			FMapInfo.Execute(sBuffer);
			PrintingMapInfoError(bOldPrinting);
		}
		catch(Exception & e)
		{
			PrintingMapInfoError(bOldPrinting);
			e.Message = "        MapInfo " + e.Message;
			Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
		}

		this->ScrollBox->VertScrollBar->Visible =false;
		//      
		VLIterator = FViewLines.begin();
		while(VLIterator != FViewLines.end())
		{
			if (VLIterator->cViewType < 0)
			{
				if (VLIterator->cViewType< -1)
					VLIterator->cViewType = -1;
				VLIterator->WorkControl = new TWindowDivider(this);
				TWindowDivider * Divider = static_cast<TWindowDivider *>(VLIterator->WorkControl);
				Divider->AutoSize = true;
				Divider->Parent = ScrollBox;
				Divider->Layout = tlCenter;

				if (VLIterator->bCaptionViewed)
				{
					Divider->Alignment = (TAlignment)(VLIterator->ucJustify);
					Divider->Caption = VLIterator->sLineName;
				}
				else
					Divider->Caption = "";
				Divider->AutoSize = false;
				siLineHeight = Divider->Height;
				Divider->Anchors << akTop << akBottom << akRight <<akBottom;
				Divider->Anchors >> akBottom;
				Divider->Top = siy;
				Divider->Left = 0;
				Divider->Width = ScrollBox->Width;
				Divider->Transparent = true;
			}
			else if(VLIterator->cViewType == 1)
			{
				sBuffer = TrimRight(VLIterator->sValue);
				AnsiString sCurrentIdentifier = sBuffer;

				if(sBuffer.Length() > 0)
				{
					if((VLIterator->ucColumnType == COL_TYPE_DATE) || (VLIterator->ucColumnType == COL_TYPE_GRAPHIC) || (VLIterator->ucColumnType == COL_TYPE_CHAR))
						sBuffer = "\"" + sBuffer + "\"";
				}
				else
				{
					if((VLIterator->ucColumnType == COL_TYPE_DATE) || (VLIterator->ucColumnType == COL_TYPE_CHAR))
						sBuffer = "\"\"";
					else if((VLIterator->ucColumnType == COL_TYPE_LOGICAL)
					|| (VLIterator->ucColumnType == COL_TYPE_FLOAT)
					|| (VLIterator->ucColumnType == COL_TYPE_DECIMAL)
					|| (VLIterator->ucColumnType == COL_TYPE_INTEGER)
					|| (VLIterator->ucColumnType == COL_TYPE_SMALLINT))
						sBuffer = "0";
					else
						sBuffer = "\"\"";
				}

				sSelValues = FMapInfo.SelCustomTemp("SelValues");//   

				if(VLIterator->sAdditionalCondition.Length() >0)
				//     
					bTruly = FMapInfo.Execute("Select "+VLIterator->sExpressionViewedValue+","+VLIterator->sExpressionIdentifier+" from \""+VLIterator->sListTable+"\" where "+VLIterator->sAdditionalCondition+" into "+sSelValues+" Order By Col1 NoSelect");
				else
				//     
					bTruly = FMapInfo.Execute("Select "+VLIterator->sExpressionViewedValue+","+VLIterator->sExpressionIdentifier+" from \""+VLIterator->sListTable+"\" into "+sSelValues+" Order By Col1 NoSelect");

				if(bTruly)
				//   , ...
				{
					byIdentifierType = FMapInfo.RequestInt("Columninfo(\""+sSelValues+"\",\"COL2\","+COL_INFO_TYPE+")");
					byValueType = FMapInfo.RequestInt("Columninfo(\""+sSelValues+"\",\"COL1\","+COL_INFO_TYPE+")");

					sSelCurrentValue = FMapInfo.SelCustomTemp("SelCurrentValue");//   
					sQueryString ="Select * from \""+sSelValues+"\" where ";

					if((VLIterator->ucColumnType==byIdentifierType)
					|| (((VLIterator->ucColumnType==COL_TYPE_INTEGER)
					|| (VLIterator->ucColumnType==COL_TYPE_SMALLINT)
					|| (VLIterator->ucColumnType==COL_TYPE_FLOAT)
					|| (VLIterator->ucColumnType==COL_TYPE_DECIMAL)) && ((byIdentifierType==COL_TYPE_INTEGER)
					|| (byIdentifierType==COL_TYPE_SMALLINT)
					|| (byIdentifierType==COL_TYPE_FLOAT)
					|| (byIdentifierType==COL_TYPE_DECIMAL))))
						sQueryString =sQueryString+"COL2="+sBuffer;
					else if(((VLIterator->ucColumnType==COL_TYPE_CHAR) && (byIdentifierType!=COL_TYPE_CHAR)))
						sQueryString =sQueryString+"str$(COL2)="+sBuffer;
					else if(((byIdentifierType==COL_TYPE_DATE) && (VLIterator->ucColumnType!=COL_TYPE_CHAR)))
						sQueryString =sQueryString+"str$(COL2)=str$("+sBuffer+")";
					else if(((byIdentifierType==COL_TYPE_CHAR) && (VLIterator->ucColumnType!=COL_TYPE_CHAR)))
						sQueryString =sQueryString+"COL2=str$("+sBuffer+")";
					else
						sQueryString = sQueryString+"str$(COL2)=str$("+sBuffer+")";
					sQueryString = sQueryString+" into "+sSelCurrentValue+" noselect";

					if(!FMapInfo.Execute(sQueryString))
					//      , ...
					{
						FMapInfo.CloseTable(sSelValues);
						VLIterator->cViewType = 0;//  
						continue;//   
					}
					else
					{
						VLIterator->WorkControl = new TInfoToolComboBox(this);
						TInfoToolComboBox * ComboBox = static_cast<TInfoToolComboBox *>(VLIterator->WorkControl);
						ComboBox->Parent =ScrollBox;
						ComboBox->OnKeyPress =this->AllKeyPress;
						ComboBox->TabStop = true;
						ComboBox->AutoDropDown = true;
						ComboBox->SavedValue = VLIterator->sValue;
						ComboBox->SavedValueType = VLIterator->ucColumnType;
						ComboBox->Height =FAverageLineHeight;
						siLineHeight =ComboBox->Height;

						ComboBox->EditLabel->Caption = VLIterator->sLineName+":";
						ComboBox->Top =siy;
						ComboBox->Left =six+3+FMaxCaptionLength;
						ComboBox->Width =ScrollBox->ClientWidth-ComboBox->Left;
						ComboBox->Anchors << akTop << akBottom << akLeft << akRight;
						ComboBox->Anchors >> akBottom ;

						if (VLIterator->bFullListValuesCreated)
						//      , ...
						{
//							AnsiString sCurentValue;
//							if(FMapInfo.RequestInt("columninfo(\""+sSelCurrentValue+"\",\"COL1\","+COL_INFO_TYPE+")") == COL_TYPE_DATE)
//								sCurentValue =FMapInfo.Request("Str$("+sSelCurrentValue+".COL1)", 512);
//							else
//								sCurentValue =FMapInfo.Request(sSelCurrentValue+".COL1", 512);
							ComboBox->StringsInObjects = true;
							for(int i = 1 ; i <= FMapInfo.RequestInt("TableInfo(\""+sSelValues+"\","+TAB_INFO_NROWS+")") ; ++i)
							//   
							{
								AnsiString sValue,*sIdentifier = new AnsiString();
								FMapInfo.Execute("Fetch Rec "+IntToStr(i)+" from \""+sSelValues+"\"");

								if (byValueType == COL_TYPE_DATE)
								//      Date
									sValue = FMapInfo.GetDateValue(sSelValues+".COL1");
								else if (byValueType == COL_TYPE_FLOAT)
									sValue = FMapInfo.GetFloatValue(sSelValues+".COL1");
								else if (byValueType == COL_TYPE_DECIMAL)
								{
									sValue = FMapInfo.GetDecimalValue(sSelValues+".COL1");
								}
								else
									sValue =FMapInfo.Request(sSelValues+".COL1");


								if(byIdentifierType == COL_TYPE_DATE)
								//      Date  
									*sIdentifier = FMapInfo.GetDateValue(sSelValues+".COL2");
								else if (byIdentifierType == COL_TYPE_FLOAT)
								{
									*sIdentifier = FMapInfo.GetFloatValue(sSelValues+".COL2");
								}
								else if (byIdentifierType == COL_TYPE_DECIMAL)
								{
									*sIdentifier = FMapInfo.GetDecimalValue(sSelValues+".COL2");
								}
								else
									*sIdentifier =FMapInfo.Request(sSelValues+".COL2");
								ComboBox->AddItem(sValue, reinterpret_cast<TObject*>(sIdentifier));
								if (ComboBox->ItemIndex < 0 && *sIdentifier == sCurrentIdentifier)
								{
									ComboBox->ItemIndex = ComboBox->Items->Count-1;
									ComboBox->DefaultValue =ComboBox->Items->Strings[ComboBox->Items->Count-1];
								}
							}
						}
						else
						{
							ComboBox->ReadOnly = true;
							for(int i = 1 ; i <= FMapInfo.RequestInt("TableInfo(\""+sSelCurrentValue+"\","+TAB_INFO_NROWS+")") ; ++i)
							{
								FMapInfo.Execute("Fetch Rec "+IntToStr(i)+" from \""+sSelCurrentValue+"\"");

								if(FMapInfo.RequestInt("columninfo(\""+sSelCurrentValue+"\",\"COL1\","+COL_INFO_TYPE+")") == COL_TYPE_DATE)
									sBuffer =FMapInfo.Request("Str$("+sSelCurrentValue+".COL1)", 512);
								else
									sBuffer =FMapInfo.Request(sSelCurrentValue+".COL1", 512);
								ComboBox->AddItem(sBuffer, NULL);
							}
							ComboBox->ItemIndex =0;
							ComboBox->DefaultValue =ComboBox->Items->Strings[ 0 ];
						}
						ComboBox->SourceTable =VLIterator->sListTable;
						ComboBox->ExpressionIdentifier =VLIterator->sExpressionIdentifier;
						ComboBox->ExpressionValue =VLIterator->sExpressionValue;
						ComboBox->ExpressionViewedValue =VLIterator->sExpressionViewedValue;
						ComboBox->AdditionalCondition =VLIterator->sAdditionalCondition;
						TInfoToolComboBox::TBoundLabel * EditLabel = dynamic_cast<TInfoToolComboBox::TBoundLabel *>(ComboBox->EditLabel);

						if (VLIterator->bColumnEditable && !VLIterator->bFullListValuesCreated)
						{
							EditLabel->SelectNewTableRow = true;
							ComboBox->EditLabel->OnMouseUp = this->ComboBoxLabelMouseUp;
						}
						else
						{
							EditLabel->SelectNewTableRow = false;
							ComboBox->EditLabel->OnMouseUp = NULL;
						}
						FMapInfo.CloseTable(sSelCurrentValue);
						FMapInfo.CloseTable(sSelValues);
						ComboBox->Show();
					}
				}
				else
				//   , ...
				{
					VLIterator->cViewType =0;//  
					continue;//   
				}
			}
			else if(VLIterator->cViewType==2)
			{
				VLIterator->WorkControl = new TInfoToolComboBox(this);
				TInfoToolComboBox * ComboBox = static_cast<TInfoToolComboBox *>(VLIterator->WorkControl);
				ComboBox->Parent =ScrollBox;
				ComboBox->OnKeyPress =this->AllKeyPress;
				ComboBox->TabStop =true;
				ComboBox->AutoDropDown = true;
				ComboBox->SavedValue =VLIterator->sValue;
				ComboBox->Height =FAverageLineHeight;
				siLineHeight =ComboBox->Height;

				if(!VLIterator->bColumnEditable)
					ComboBox->ReadOnly =true;

				ComboBox->EditLabel->Caption =VLIterator->sLineName+":";
				ComboBox->Top =siy;
				ComboBox->Left =six+3+FMaxCaptionLength;
				ComboBox->Show();
				ComboBox->Width =ScrollBox->ClientWidth-ComboBox->Left;
				ComboBox->Anchors << akTop << akBottom << akLeft << akRight;
				ComboBox->Anchors >> akBottom;

				for(TListValues::iterator ValuesIterator = VLIterator->ListValues.begin() ; ValuesIterator != VLIterator->ListValues.end() ; ++ValuesIterator)
				{
					if(ValuesIterator->sViewedValue.Length() == 0)
						ValuesIterator->sViewedValue =" ";
					ComboBox->AddItem(ValuesIterator->sViewedValue, NULL);

					if(VLIterator->sValue==ValuesIterator->sSavedValue)
					{
						ComboBox->DefaultValue = ValuesIterator->sViewedValue;
						ComboBox->ItemIndex =std::distance(VLIterator->ListValues.begin(),ValuesIterator);
					}
				}
				ComboBox->Show();
			}
			else
			{
				if((VLIterator->ucColumnType==COL_TYPE_LOGICAL))
				{
					VLIterator->WorkControl = new TBorderCheckBox(this);
					TBorderCheckBox * CheckBox = static_cast<TBorderCheckBox *>(VLIterator->WorkControl);
					CheckBox->Parent =ScrollBox;
					CheckBox->OnKeyPress =this->AllKeyPress;
					CheckBox->Alignment =taLeftJustify;
					CheckBox->TabStop =true;
					CheckBox->Caption =VLIterator->sLineName+":";
					CheckBox->Checked =bool(StrToIntDef(VLIterator->sValue, 0));

					if(!VLIterator->bColumnEditable)
						CheckBox->ReadOnly =true;
					HDCwin =GetDC(CheckBox->Handle);
					SelectObject(HDCwin, CheckBox->Font->Handle);
					sBuffer = VLIterator->sLineName+":";
					GetTextExtentPoint32(HDCwin, sBuffer.c_str(), sBuffer.Length() , &TextSIZE);
					ReleaseDC(CheckBox->Handle, HDCwin);

					if(TextSIZE.cy> DefaultCheckBoxSize.Height)
						CheckBox->Height =TextSIZE.cy;
					else
						CheckBox->Height =DefaultCheckBoxSize.Height;
					siLineHeight = CheckBox->Height;
					CheckBox->Left =FMaxCaptionLength-TextSIZE.cx-2;
					CheckBox->Width =TextSIZE.cx+3+2+DefaultCheckBoxSize.Width;
					CheckBox->Top =siy;
					CheckBox->Anchors << akTop << akLeft << akRight << akBottom ;
					CheckBox->Anchors >> akRight >> akBottom;
					CheckBox->Show();
				}
				else if((VLIterator->ucColumnType==COL_TYPE_DATE))
				{
					VLIterator->WorkControl = new TBorderDateEdit(this);
					TBorderDateEdit * DateEdit = static_cast<TBorderDateEdit *>(VLIterator->WorkControl);
					DateEdit->Parent =this->ScrollBox;
					DateEdit->OnKeyPress =AllKeyPress;
					DateEdit->DateFormat =dfLong;
					DateEdit->Height =FAverageLineHeight;
					siLineHeight =DateEdit->Height;
					DateEdit->TabStop =true;
					DateEdit->EditLabel->Caption =VLIterator->sLineName+":";
					DateEdit->Anchors << akTop << akBottom << akLeft << akRight;
					DateEdit->Anchors >> akBottom;
					DateEdit->Top =siy;
					DateEdit->Left =six+3+FMaxCaptionLength;
					DateEdit->Width =ScrollBox->ClientWidth-DateEdit->Left;
					DateEdit->Format =VLIterator->sCustomDateFormat;

					if (VLIterator->ucDateFormat == 0)
						DateEdit->DateFormat = dfLong;
					else
						DateEdit->DateFormat = dfShort;

					try
					{
						VLIterator->sValue = DateToStr(StrToDate(VLIterator->sValue));
					}
					catch(...)
					{
						VLIterator->sValue ="";
					}
					DateEdit->Enabled =true;

					if(VLIterator->bColumnEditable)
					{
						DateEdit->ShowCheckbox =true;

						if(VLIterator->sValue!="")
						{
							DateEdit->Date =StrToDate(VLIterator->sValue);
							DateEdit->Checked =true;
						}
						else
							DateEdit->Checked =false;
					}
					else
					{
						DateEdit->ReadOnly =true;
						SetWindowLong(DateTime_GetMonthCal(DateEdit->Handle) , GWL_STYLE , GetWindowLong(DateTime_GetMonthCal(DateEdit->Handle) , GWL_STYLE) || MCS_NOTODAY || MCS_NOTODAYCIRCLE);

						if(VLIterator->sValue=="")
						{
							DateEdit->ShowCheckbox =false;
							DateEdit->Enabled =false;
							DateEdit->EditLabel->Enabled =true;
							DateTime_SetFormat(DateEdit->Handle  , "\'\'");
							DateEdit->Checked =false;
						}
						else
						{
							DateEdit->ShowCheckbox =false;
							DateEdit->Checked =false;
							DateEdit->Date =StrToDate(VLIterator->sValue);
						}
					}
					DateEdit->DoubleBuffered = true;
					DateEdit->Show();
				}
				else
				{
					if (VLIterator->ucColumnType == COL_TYPE_INTEGER)
						VLIterator->WorkControl = new TInfoToolIntEdit(this,INT_MIN,INT_MAX);
					else if (VLIterator->ucColumnType == COL_TYPE_SMALLINT)
						VLIterator->WorkControl = new TInfoToolIntEdit(this,SHRT_MIN,SHRT_MAX);
					else if (VLIterator->ucColumnType == COL_TYPE_DECIMAL)
					{
						VLIterator->WorkControl = new TInfoToolDecimalEdit(this, VLIterator->ValueWidth, VLIterator->ValueDecimals);
						static_cast<TInfoToolFloatEdit*>(VLIterator->WorkControl)->ToCorrectValue(VLIterator->sValue);
					}
					else if (VLIterator->ucColumnType == COL_TYPE_FLOAT)
					{
						VLIterator->WorkControl = new TInfoToolFloatEdit(this);
						static_cast<TInfoToolFloatEdit*>(VLIterator->WorkControl)->ToCorrectValue(VLIterator->sValue);
					}
					else if (VLIterator->ucColumnType == COL_TYPE_CHAR)
					{
						VLIterator->WorkControl = new TBorderEdit(this);
						static_cast<TBorderEdit *>(VLIterator->WorkControl)->MaxLength = VLIterator->ValueWidth;
					}
					else
						VLIterator->WorkControl = new TBorderEdit(this);

					TBorderEdit * EditText = static_cast<TBorderEdit *>(VLIterator->WorkControl);
					EditText->Parent =ScrollBox;
					EditText->OnKeyPress =AllKeyPress;
					siLineHeight =EditText->Height;
					EditText->TabStop =true;
					EditText->Text =VLIterator->sValue;

					if(!VLIterator->bColumnEditable)
						EditText->ReadOnly =true;
					EditText->EditLabel->Caption =VLIterator->sLineName+":";
					EditText->Anchors << akTop << akBottom << akLeft << akRight;
					EditText->Anchors >> akBottom;
					EditText->Top =siy;
					EditText->Left =six+3+FMaxCaptionLength;
					EditText->Width =ScrollBox->ClientWidth-EditText->Left;
					EditText->DoubleBuffered = true;
					EditText->Show();
				}
			}
			siy =siy+siLineHeight + 2;

			if((iStartFiledsCount == 0) || (std::distance(FViewLines.begin(),VLIterator)+1 <= iStartFiledsCount))
			{
				siFrameHeight = siy - 2;

				if(std::distance(FViewLines.begin(),VLIterator) < 2)
					siMinFrameHeight = siFrameHeight;
			}
			siMaxFrameHeight = siFrameHeight;
			++VLIterator;
		}
		//    
		if(siFrameHeight > 0)
			SetFrameHeight(siFrameHeight , siMinFrameHeight , siMaxFrameHeight);
		ScrollBox->AutoScroll =true;
		ScrollBox->VertScrollBar->Visible =true;
		ScrollBox->VertScrollBar->Increment =FAverageLineHeight+2;
		return true;
	}
	catch(Exception &e)
	{
		e.Message = sFuncErr + e.Message;
		throw;
	}
	catch(...)
	{
		throw;
	}
}

void TInfoToolWindow::SetFrameHeight(short siHeight,  short siMinHeight,  short siMaxHeight)
{
	short siOffsetY;

	if(siHeight <= 0)
		return;
	siOffsetY = Height - ScrollBox->Height;
	this->Constraints->MinHeight = siMinHeight + siOffsetY;
	this->Constraints->MaxHeight = siMaxHeight + siOffsetY;
	this->Height = siHeight + siOffsetY;
}

void TInfoToolWindow::ShowAt(int X, int Y,  TBeakPosition BP)
{
	static const unsigned char icOffset = 10;
	TBeakPosition BeakPosition;
	BeakPosition = BP;

	switch(BeakPosition)
	{
		case bpTopRight:
		{
			X = X + icOffset;
			Y = Y - icOffset - Height;
			break;
		}
		case bpTopLeft:
		{
			X = X -icOffset - Width;
			Y = Y - icOffset - Height;
			break;
		}
		case bpBottomRight:
		{
			X = X + icOffset;
			Y = Y + icOffset;
			break;
		}
		case bpBottomLeft:
		{
			X = X- icOffset - Width;
			Y = Y + icOffset;
			break;
		}
	}

	if(X < 0)
		X = 0;

	if(Y < 0)
		Y = 0;

	if((X + Width) > Screen->WorkAreaWidth)
		X = Screen->WorkAreaWidth - Width;

	if((Y + Height) > Screen->WorkAreaHeight)
		Y = Screen->WorkAreaHeight - Height;

	if(X < 0)
		X = 0;

	if(Y < 0)
		Y = 0;

	if((X + Width) > Screen->WorkAreaWidth)
		Width = Screen->WorkAreaWidth;

	if((Y + Height) > Screen->WorkAreaHeight)
		Height = Screen->WorkAreaHeight;

	Left = X;
	Top = Y;
	Show();
}
//---------------------------------------------------------------------------

extern "C" void APIENTRY __declspec(dllexport) DestroyInfoToolWindow()
//     
//  


// !        
//      FormClose (Action:=caFree)
//      ,   
//     ,      ,
//         
{
	try
	{
		if(IsInfoToolWindowCreated)
			InfoToolWindow->Free();
		InfoToolWindow = NULL;
	}
	catch(...)
	{
		InfoToolWindow = NULL;
	}
}

extern "C" bool APIENTRY __declspec(dllexport) IsInfoToolWindowOpened()
//       
{
const char * const sFuncErr = "   IsInfoToolWindowOpened.";
	try
	{
		if(IsInfoToolWindowCreated && InfoToolWindow->Showing)
			return true;
	}
	catch(Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	return false;
}

extern "C" bool APIENTRY __declspec(dllexport) IsFindingStarted()
//       
{
const char * const sFuncErr = "   IsFindingStarted.";
	try
	{
		if(IsInfoToolWindowCreated)
		{
			if (InfoToolWindow->FFindingStarted)
				return true;
			else
				return false;
		}
		else
			return false;
	}
	catch(Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
return false;
}

extern "C" bool APIENTRY __declspec(dllexport) IsSavingStarted()
//       
{
const char * const sFuncErr = "   IsSavingStarted.";
	try
	{
		if(IsInfoToolWindowCreated)
		{
			if (InfoToolWindow->FSavingStarted)
				return true;
			else
				return false;
		}
		else
			return false;
	}
	catch(Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	return false;
}

extern "C" void APIENTRY __declspec(dllexport) ViewInfoToolWindow
(short siScreenX,short siScreenY,  LPSTR lpstrTable,  int iRowID,
int iMapWindowId, HWND hMapWindow,int iDdeInstId,  HCONV hMapinfoDdeConv,
HCONV hApplicationDdeConv,  LPSTR lpstrOptionsSection)
//    
{
const char * const sFuncErr = "     . ";
	try
	{

		TBeakPositions ScreenQuarter;
		TBeakPosition WinPosition;
		HCURSOR WhaitCursor = LoadCursor(NULL,IDC_WAIT/*IDC_NO*/);//  

		if(iRowID <= 0
		|| (!lpstrTable && strlen(lpstrTable) == 0)
		|| !hMapinfoDdeConv
		|| !hApplicationDdeConv
		|| !iDdeInstId)
		//   ,    
		{
			throw Exception("      .");//      
		}
#ifdef _DEBUG
		DWORD StartTime=GetTickCount();
#endif
		try
		{
			if(IsInfoToolWindowCreated)
				InfoToolWindow->Hide(); //    
			LockWindowUpdate(Application->Handle); //     ,    :),       ,         ,    ,       , . .         ,        ,    ,      ,          ;)
			DestroyInfoToolWindow(); //    
		}
		catch(Exception & e)
		{
			InfoToolWindow = NULL;
			LockWindowUpdate(Application->Handle); //     ,    :),       ,         ,    ,       , . .         ,        ,    ,      ,          ;)
		}

		//   
		InfoToolWindow = new TInfoToolWindow(Application, hMapinfoDdeConv, hApplicationDdeConv, iDdeInstId);

		SetCursor(WhaitCursor);//  
		
		//      
		InfoToolWindow->FCurrentMapWindowId = iMapWindowId;
		InfoToolWindow->FTableName = lpstrTable;
		InfoToolWindow->FRowId = iRowID;
		//    
		InfoToolWindow->Caption = "     \'";
		InfoToolWindow->Caption = InfoToolWindow->Caption + lpstrTable;
		InfoToolWindow->Caption = InfoToolWindow->Caption + "\'";
		//  
		if(OptionsFile && OptionsFile->SectionExists(lpstrOptionsSection))
		{
			bToSelectObjectInMap = OptionsFile->ReadBool(lpstrOptionsSection, "select object", true);
			bToFindValueInBrowse = OptionsFile->ReadBool(lpstrOptionsSection, "find value", true);
			iStartFiledsCount = OptionsFile->ReadInteger(lpstrOptionsSection, "fields count", 0);
		}
		InfoToolWindow->StartInfoToolWindow(); //      

		//      
		WinPosition = bpTopLeft; //        
		ScreenQuarter << bpTopLeft << bpTopRight << bpBottomLeft << bpBottomRight; // 4  

		if(siScreenX < InfoToolWindow->Width)
			ScreenQuarter >> bpTopLeft >> bpBottomLeft;
		else
			ScreenQuarter >> bpTopRight >> bpBottomRight;

		if(siScreenY < InfoToolWindow->Height)
			ScreenQuarter >> bpTopLeft >> bpTopRight;
		else
			ScreenQuarter >> bpBottomLeft >> bpBottomRight;

		if((Screen->WorkAreaWidth - siScreenX) < InfoToolWindow->Width)
			ScreenQuarter >> bpTopRight >> bpBottomRight;

		if((Screen->WorkAreaHeight - siScreenY) < InfoToolWindow->Height)
			ScreenQuarter >> bpBottomLeft >> bpBottomRight;

		if(ScreenQuarter.Contains(bpTopLeft))
			WinPosition = bpTopLeft;
		else if(ScreenQuarter.Contains(bpTopRight))
			WinPosition = bpTopRight;
		else if(ScreenQuarter.Contains(bpBottomLeft))
			WinPosition = bpBottomLeft;
		else if(ScreenQuarter.Contains(bpBottomRight))
			WinPosition =bpBottomRight;
		else
		{
			if((siScreenX<(Screen->WorkAreaWidth-siScreenX)) && (siScreenY<(Screen->WorkAreaHeight-siScreenY)))
				ScreenQuarter << bpBottomRight;
			else if((siScreenX<(Screen->WorkAreaWidth-siScreenX)) && (siScreenY>(Screen->WorkAreaHeight-siScreenY)))
				ScreenQuarter << bpTopRight;
			else if((siScreenX>(Screen->WorkAreaWidth-siScreenX)) && (siScreenY<(Screen->WorkAreaHeight-siScreenY)))
				ScreenQuarter << bpBottomLeft;
			else if((siScreenX>(Screen->WorkAreaWidth-siScreenX)) && (siScreenY>(Screen->WorkAreaHeight-siScreenY)))
				ScreenQuarter << bpTopLeft;

			if(ScreenQuarter.Contains(bpTopLeft))
				WinPosition = bpTopLeft;
			else if(ScreenQuarter.Contains(bpTopRight))
				WinPosition = bpTopRight;
			else if(ScreenQuarter.Contains(bpBottomLeft))
				WinPosition = bpBottomLeft;
			else if(ScreenQuarter.Contains(bpBottomRight))
				WinPosition =bpBottomRight;
		}


		InfoToolWindow->ShowAt(siScreenX, siScreenY, WinPosition);
#ifdef _DEBUG
		StartTime=GetTickCount()-StartTime;
		InfoToolWindow->MapInfo.Execute("print \"      "+IntToStr(StartTime)+" . \"");
#endif

		LockWindowUpdate(0);
	}
	catch(DdeError & e)
	{
		LockWindowUpdate(0);
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(GetDdeMessageFormatErr(e.Message.c_str(),e.ErrorCode).c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(Exception & e)
	{
		LockWindowUpdate(0);
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
	catch(...)
	{
		LockWindowUpdate(0);
		Application->MessageBox(sFuncErr, sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
}

extern "C" void APIENTRY __declspec(dllexport) SetApplicationWindowHandle(int Handle)
{
const char * const sFuncErr = "    SetApplicationWindowHandle. ";
	try
	{
		if(Application)
			Application->Handle = reinterpret_cast<HWND>(Handle);
		return;
	}
	catch(Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
		return;
	}
	catch(...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
		return;
	}
}

extern "C" int APIENTRY __declspec(dllexport) GetCurrentAdditionalWindow()
//    ,
//     
{
const char * const sFuncErr = "    GetCurrentAdditionalWindow. ";
	try
	{
		if(IsInfoToolWindowCreated)
			return InfoToolWindow->FAdditionalWindowId;
		else
			return 0;
	}
	catch(Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
		return 0;
	}
	catch(...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
		return 0;
	}
}

extern "C" void APIENTRY __declspec(dllexport) UpdateValue(void)
// ,  ,   
//     
{
const char * const sFuncErr = "     . ";
	try
	{
		AnsiString sBuffer;
		AnsiString sSelTable;// 
		AnsiString sUpdatingRow;
		int iUpdatingRow;//  
		unsigned char ChangeableValueType;//  
		if(InfoToolWindow == NULL)
			return;
		if(InfoToolWindow->EditValueWindow == NULL)
			return;
		if(InfoToolWindow->CurrentComboBox == NULL)
			return;
		sBuffer = "CommandInfo(";
		sBuffer += CMD_INFO_ROWID;
		sBuffer +=")";
		sUpdatingRow = InfoToolWindow->MapInfo.Request(sBuffer);
		iUpdatingRow = StrToIntDef(sUpdatingRow,0);
		sBuffer = "SelectionInfo(";
		sBuffer += SEL_INFO_TABLENAME;
		sBuffer +=")";
		sSelTable = InfoToolWindow->MapInfo.Request(sBuffer, 31);

		if(IsWindow(InfoToolWindow->SelValueWnd)
		&&(InfoToolWindow->CurrentComboBox->CurrentValuesQuery == InfoToolWindow->MapInfo.Request("WindowInfo("+IntToStr(InfoToolWindow->SelValueWindowId)+","+WIN_INFO_TABLE+")", 31))
		&&(AnsiLowerCase(sSelTable) == AnsiLowerCase(InfoToolWindow->CurrentComboBox->SourceTable))
		&&(iUpdatingRow > 0)
		&&(InfoToolWindow->MapInfo.Execute("Fetch Rec " + sUpdatingRow +" From "+sSelTable)))
		{
			InfoToolWindow->EditValueWindow->Caption = " ";
			sBuffer = "Fetch Rec " + sUpdatingRow +" From Selectioninfo(";
			sBuffer += SEL_INFO_TABLENAME;
			sBuffer +=")";
			ChangeableValueType = InfoToolWindow->MapInfo.RequestInt("ColumnInfo(\""+sSelTable+"\",\""+InfoToolWindow->CurrentComboBox->ExpressionValue+"\","+COL_INFO_TYPE+")");
			if (ChangeableValueType == COL_TYPE_DATE)
			{
				InfoToolWindow->EditValueWindow->ShowDateEdit();
				sBuffer = InfoToolWindow->MapInfo.GetDateValue(sSelTable+"."+InfoToolWindow->CurrentComboBox->ExpressionValue);
				if (sBuffer.Length() == 0)
					InfoToolWindow->EditValueWindow->DateValue->Checked = false;
				else
					InfoToolWindow->EditValueWindow->DateValue->Date = StrToDate(sBuffer);
			}
			else
			{
				InfoToolWindow->EditValueWindow->ShowTextEdit();
				if (ChangeableValueType == COL_TYPE_DECIMAL)
					InfoToolWindow->EditValueWindow->Value->Text = InfoToolWindow->MapInfo.GetDecimalValue(sSelTable+"."+InfoToolWindow->CurrentComboBox->ExpressionValue);
				else if (ChangeableValueType == COL_TYPE_FLOAT)
					InfoToolWindow->EditValueWindow->Value->Text = InfoToolWindow->MapInfo.GetFloatValue(sSelTable+"."+InfoToolWindow->CurrentComboBox->ExpressionValue);
				else
					InfoToolWindow->EditValueWindow->Value->Text = InfoToolWindow->MapInfo.Request(sSelTable+"."+InfoToolWindow->CurrentComboBox->ExpressionValue);
			}
			InfoToolWindow->EditValueWindow->UpdatingRow = iUpdatingRow;
			EnableWindow(InfoToolWindow->SelValueWnd, false);
			InfoToolWindow->EditValueWindow->Show();
		}
	}
	catch(Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);

		try
		{
			if (IsWindow(InfoToolWindow->SelValueWnd))
				EnableWindow(InfoToolWindow->SelValueWnd,true);
		}
		catch(...)
		{
		}
	}
	catch(...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
}

extern "C" void APIENTRY __declspec(dllexport) NewValue(void)
{
const char * const sFuncErr = "     . ";
	try
	{
		if(InfoToolWindow == NULL)
			return;
		if(InfoToolWindow->EditValueWindow == NULL)
			return;
		if(InfoToolWindow->CurrentComboBox == NULL)
			return;
		if(IsWindow(InfoToolWindow->SelValueWnd) && (InfoToolWindow->CurrentComboBox->CurrentValuesQuery == InfoToolWindow->MapInfo.Request("WindowInfo("+IntToStr(InfoToolWindow->SelValueWindowId)+","+WIN_INFO_TABLE+")", 31)))
		{
			unsigned char ChangeableValueType = InfoToolWindow->MapInfo.RequestInt("ColumnInfo(\""+InfoToolWindow->CurrentComboBox->SourceTable+"\",\""+InfoToolWindow->CurrentComboBox->ExpressionValue+"\","+COL_INFO_TYPE+")");//  
			InfoToolWindow->EditValueWindow->Caption =" ";
			if (ChangeableValueType == COL_TYPE_DATE)
			{
				InfoToolWindow->EditValueWindow->ShowDateEdit();
				InfoToolWindow->EditValueWindow->DateValue->Checked = true;
				InfoToolWindow->EditValueWindow->DateValue->Date = Date();
			}
			else
			{
				InfoToolWindow->EditValueWindow->ShowTextEdit();
				InfoToolWindow->EditValueWindow->Value->Text ="";
			}
			InfoToolWindow->EditValueWindow->UpdatingRow =0;
			EnableWindow(InfoToolWindow->SelValueWnd, false);
			InfoToolWindow->EditValueWindow->Show();
		}
	}
	catch(Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);

		try
		{
			if (IsWindow(InfoToolWindow->SelValueWnd))
				EnableWindow(InfoToolWindow->SelValueWnd,true);
		}
		catch(...)
		{
		}
	}
	catch(...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
	}
}
//---------------------------------------------------------------------------


struct TIntoToolWindowModuleObject
{
	TIntoToolWindowModuleObject()
	{
		DecimalSeparator = '.';
	}
	~TIntoToolWindowModuleObject()
	{
	const char * const sFuncErr = "      \"IntoToolWindowUnit\". ";
		try
		{
			Application->Handle = 0;

			if(IsInfoToolWindowCreated)
				InfoToolWindow->Free();
			InfoToolWindow = NULL;
		}
		catch(Exception & e)
		{
			e.Message = sFuncErr + e.Message;
			Application->MessageBox(e.Message.c_str(), sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
		}
		catch(...)
		{
			Application->MessageBox(sFuncErr, sErrorCaption, MB_OK | MB_ICONERROR | MB_TASKMODAL);
		}
	}
};

TIntoToolWindowModuleObject IntoToolWindowModuleObject;


