//---------------------------------------------------------------------------

#include <vcl.h>
#include <typeinfo>
#pragma hdrstop

#include "SetupWindowUnit.h"
#include "CheckBoxSize.h"
//---------------------------------------------------------------------------
//#pragma package(smart_init)
#pragma resource "*.dfm"

TSetupWindow *SetupWindow = NULL;// 

const char * sErrorCaption = "";//   

HHOOK hSetupWindowHook = NULL;//handle  

bool IsSetupWindowCreated = false;//   

int iErrorMessageBoxFlags = MB_OK | MB_ICONERROR | MB_TASKMODAL;

void SetDB(TWinControl* wc)
//    TWinControl 
//  DoubleBuffere  true
{
	for (int i=0; i< wc->ControlCount; ++i)
	{
		TWinControl * childwc = dynamic_cast<TWinControl*>(wc->Controls[i]);
		if (childwc)
		{
			childwc->DoubleBuffered = true;
			SetDB(childwc);
		}
	}
}

//---------------------------------------------------------------------------
LRESULT CALLBACK SetupWindowHookProc(int code,WPARAM wParam,LPARAM lParam)
//  
{
const char *sFuncErr = "      . ";
	try
	{
		if (code < 0)
		{
			return CallNextHookEx(hSetupWindowHook , code , wParam, lParam);
		}

		PCWPSTRUCT PointWinMsg = reinterpret_cast<PCWPSTRUCT>(lParam);
		if (PointWinMsg->hwnd == Application->Handle
		&& PointWinMsg->message == WM_ENABLE
		&& PointWinMsg->wParam)
		{
			EnableWindow(Application->Handle , false);
			UnhookWindowsHookEx(hSetupWindowHook);
			hSetupWindowHook = NULL;
			return 0;
		}

		return CallNextHookEx(hSetupWindowHook , code , wParam , lParam);
	}
	catch (Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(),
								sErrorCaption,
								iErrorMessageBoxFlags);
		//return CallNextHookEx(hSetupWindowHook, code, wParam, lParam);
	}
	catch (...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, iErrorMessageBoxFlags);
		//return CallNextHookEx(hSetupWindowHook, code, wParam, lParam);
	}
	return 0;
}
//---------------------------------------------------------------------------
__fastcall TSetupWindow::TSetupWindow(TComponent* Owner,
									  HCONV NewMapInfoDDEConv,
									  HCONV NewApplicationDDEConv,
									  int NewDdeInstId)
						: TForm(Owner)
{
const char *sFuncErr = "     TSetupWindow. ";
	try
	{
		IsSetupWindowCreated = true;
		FMapInfo.SetValues(NewMapInfoDDEConv,
						   NewApplicationDDEConv,
						   NewDdeInstId);

		AnsiString sBuffer = "Dim ";
		sBuffer += MapInfo_CurrentRowId;
		sBuffer += " as Integer Dim ";
		sBuffer += MapInfo_CurrentTableName;
		sBuffer += " as String";
		FMapInfo.Execute(sBuffer);
	}
	catch (DdeError & e)
	{
		e.Message = GetDdeMessageFormatErr(sFuncErr, e.ErrorCode);
		Application->MessageBox(e.Message.c_str(),
								sErrorCaption,
								iErrorMessageBoxFlags);
	}
	catch (Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(),
								sErrorCaption,
								iErrorMessageBoxFlags);
	}
	catch (...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, iErrorMessageBoxFlags);
	}
}

//---------------------------------------------------------------------------
__fastcall TSetupWindow::TSetupWindow(TComponent* Owner)
		: TForm(Owner)
{
const char * sFuncErr = "     TSetupWindow. ";
	try
	{
		IsSetupWindowCreated = true;
		FMapInfo.SetValues(0, 0, 0);

		AnsiString sBuffer = "Dim ";
		sBuffer += MapInfo_CurrentRowId;
		sBuffer += " as Integer Dim ";
		sBuffer += MapInfo_CurrentTableName;
		sBuffer += " as String";
		FMapInfo.Execute(sBuffer);
	}
	catch (DdeError & e)
	{
		e.Message = GetDdeMessageFormatErr(sFuncErr, e.ErrorCode);
		Application->MessageBox(e.Message.c_str(),
								sErrorCaption,
								iErrorMessageBoxFlags);
	}
	catch (Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(),
								sErrorCaption,
								iErrorMessageBoxFlags);
	}
	catch (...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, iErrorMessageBoxFlags);
	}
}
//---------------------------------------------------------------------------
__fastcall TSetupWindow::~TSetupWindow()
{
const char * sFuncErr = "     TSetupWindow. ";
	try
	{
		IsSetupWindowCreated = false;

		SetActiveWindow(Application->Handle);//    

		bool bOldPrinting = PrintingMapInfoError(false);
		try
		{
			AnsiString sBuffer = "UnDim ";
			sBuffer += MapInfo_CurrentRowId;
			sBuffer += " UnDim ";
			sBuffer += MapInfo_CurrentTableName;

			FMapInfo.Execute(sBuffer);

		}
		catch (Exception & e)
		{
			e.Message =
				"       MapInfo. "
				+ e.Message;
			Application->MessageBox(e.Message.c_str(),
									sErrorCaption,
									iErrorMessageBoxFlags);
		}
		PrintingMapInfoError(bOldPrinting);

		FViewLines.clear(); //     
	}
	catch (DdeError & e)
	{
		e.Message = GetDdeMessageFormatErr(sFuncErr, e.ErrorCode);
		Application->MessageBox(e.Message.c_str(),
								sErrorCaption,
								iErrorMessageBoxFlags);
	}
	catch (Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(),
								sErrorCaption,
								iErrorMessageBoxFlags);
	}
	catch (...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, iErrorMessageBoxFlags);
	}
}
//---------------------------------------------------------------------------
void __fastcall TSetupWindow::AllKeyPress(TObject *Sender, char &Key)
{
	switch (Key)
	{
		case Char(VK_TAB): Key = NULL;
		break;
	}
}
//---------------------------------------------------------------------------
void __fastcall TSetupWindow::FormCreate(TObject *Sender)
{
const char * sFuncErr ="      . ";
	try
	{
		this->AutoSize = false;

		//    
		OldListBoxWindowProc = this->ListFields->WindowProc;
		//    
		this->ListFields->WindowProc = this->ListBoxWindowProc;

		FSelectTableWindow = new TSelectTableWindow(this);

		FSelectTableWindow->OkButton->OnClick =
			this->SelectTableWindow_OkButtonClick;
		FSelectTableWindow->CancelButton->OnClick =
			this->SelectTableWindow_CancelButtonClick;
		FSelectTableWindow->OnClose = this->ChildFormClose;

		FNewFieldWindow = new TNewFieldWindow(this);
		FNewFieldWindow->ColumnName->OnSelect =
			this->NewFieldWindow_SelectColumn;
		FNewFieldWindow->OkButton->OnClick = this->NewFieldWindow_OkButtonClick;
		FNewFieldWindow->OnClose = this->ChildFormClose;

		FEnterExpressionWindow = new TEnterExpressionWindow(FNewFieldWindow);
		FEnterExpressionWindow->OnClose = this->ChildFormClose;
		FEnterExpressionWindow->OkButton->OnClick =
			this->EnterExpressionWindow_OkButtonClick;
		FEnterExpressionWindow->CheckUp->OnClick =
			this->EnterExpressionWindow_CheckUpClick;

		FOldHintHidePause = Application->HintHidePause;
		Application->HintHidePause = 10000;
		FOldHintPause = Application->HintPause;
		Application->HintPause = 2000;

		this->FieldProperties->Enabled = false;
		this->TableFieldOptions->Visible = false;

		FieldType->Hint = "  -     \n" \
		"   \n" \
		"  (  \n" \
		" )";

		LabelFieldType->Hint = FieldType->Hint;
		FieldEnabled->Hint = " -    ,\n" \
		"    ( \n" \
		"  )  ,\n" \
		"  ,    \n" \
		",    \n" \
		"  ";

		ValuesTableName->Hint = "  - " \
		"   ,\n" \
		"    ,\n" \
		"     ( \n" \
		"  )";
		LabelTableName->Hint = ValuesTableName->Hint;

		ValueColumn->Hint = "   - " \
							"    ,\n" \
							"     ";
		LabelValue->Hint =ValueColumn->Hint;

		ViewedColumn->Hint = "   - " \
		"    \n" \
		"  (    ),\n" \
		"     ,\n" \
		"    (  \n" \
		" )";
		LabelViewedColumn->Hint = ViewedColumn->Hint;

		IdentifierColumn->Hint = "  - " \
		"    ,\n" \
		"     ,\n" \
		"    (  \n" \
		" )";
		LabelIdentifier->Hint = IdentifierColumn->Hint;

		AdditionalCondition->Hint = "  - " \
		"  \n" \
		" ,   \n" \
		"  , \n" \
		"   (    )";
		LabelCondition->Hint =AdditionalCondition->Hint;
		CheckUp->Hint ="  ";
		ValueList->Hint ="  -    :\n" \
		"   , \n" \
		" ,     ,\n" \
		"   \n" \
		"   (    )";
		CreateValue->Hint ="     ";
		DeleteValue->Hint ="     ";

		DateFormat->Hint = "  -    " \
						   "   ";
		LabelDateFormat->Hint=DateFormat->Hint;
		CustomDateFormat->Hint = "   -    " \
								 "    ";
		LabelCustomDateFormat->Hint =  CustomDateFormat->Hint;

		AnsiString sBuffer = LabelFieldType->Caption; //  

		int iLeft = LabelFieldType->Left; //  
		int iHeight = LabelFieldType->Height; // 

		LabelFieldType->AutoSize = true;
		LabelFieldType->Caption = FieldEnabled->Caption;

		//       ""
		int iCaptionWidth = LabelFieldType->Width;

		const char MaxLabelCaption[] = " :";

		//     
		LabelFieldType->Caption = MaxLabelCaption;
		LabelFieldType->Left = iLeft;
		LabelFieldType->AutoSize = false;
		LabelFieldType->Height = iHeight;
		LabelFieldType->Caption = sBuffer;
		iLeft = LabelFieldType->Left + LabelFieldType->Width+2;
		FieldType->Width = FieldType->Width - (iLeft - FieldType->Left);
		FieldType->Left = iLeft;

		FieldEnabled->Width = iCaptionWidth +DefaultCheckBoxSize.Width+4;
		FieldEnabled->Left = LabelFieldType->Left +
							 LabelFieldType->Width -
							 iCaptionWidth - 2;

		LabelTableName->Width = LabelFieldType->Width;
		iLeft = LabelTableName->Left + LabelTableName->Width+2;
		ValuesTableName->Width = ValuesTableName->Width -
								 (iLeft - ValuesTableName->Left);
		ValuesTableName->Left = iLeft;

		LabelValue->Width = LabelFieldType->Width;
		iLeft = LabelValue->Left + LabelValue->Width+2;
		ValueColumn->Width = ValueColumn->Width - (iLeft - ValueColumn->Left);
		ValueColumn->Left = iLeft;

		LabelViewedColumn->Width = LabelFieldType->Width;
		iLeft = LabelViewedColumn->Left + LabelViewedColumn->Width+2;
		ViewedColumn->Width = ValueColumn->Width - (iLeft - ValueColumn->Left);
		ViewedColumn->Left = iLeft;

		LabelIdentifier->Width = LabelFieldType->Width;
		iLeft = LabelIdentifier->Left + LabelIdentifier->Width+2;
		IdentifierColumn->Width = IdentifierColumn->Width -
								  (iLeft - IdentifierColumn->Left);
		IdentifierColumn->Left = iLeft;

		LabelCondition->Width = LabelFieldType->Width;
		iLeft = LabelCondition->Left + LabelCondition->Width+2;
		AdditionalCondition->Width = AdditionalCondition->Width -
									 (iLeft - AdditionalCondition->Left);
		AdditionalCondition->Left = iLeft;

		LabelDateFormat->Width = LabelFieldType->Width;
		iLeft = LabelDateFormat->Left + LabelDateFormat->Width+2;
		DateFormat->Width = DateFormat->Width - (iLeft - DateFormat->Left);
		DateFormat->Left = iLeft;

		LabelCustomDateFormat->Width = LabelFieldType->Width;
		iLeft = LabelCustomDateFormat->Left + LabelCustomDateFormat->Width+2;
		CustomDateFormat->Width = CustomDateFormat->Width -
								  (iLeft - CustomDateFormat->Left);
		CustomDateFormat->Left = iLeft;

		int siNumTables = FMapInfo.NumTables();

		if (siNumTables <= 0)
		{
			return;
		}

		for (int si = 1 ; si <= siNumTables ; ++si)
		{
			this->ValuesTableName->AddItem(FMapInfo.Request("TableInfo(" +
															IntToStr(si) + "," +
															TAB_INFO_NAME + ")",
															31), NULL);
		}
		this->FCurrentField = -1;

		if (hSetupWindowHook)
		{
			UnhookWindowsHookEx(hSetupWindowHook);
			hSetupWindowHook = NULL;
		}

		try
		{
			if (FTaskWindowList)
			{
				EnableTaskWindows(FTaskWindowList);
			}
			FTaskWindowList = DisableTaskWindows(this->Handle);
		}
		catch (...)
		{
			FTaskWindowList = DisableTaskWindows(this->Handle);
		}

		hSetupWindowHook = SetWindowsHookEx(WH_CALLWNDPROC,
			reinterpret_cast<HOOKPROC>(&SetupWindowHookProc),0 ,
			GetWindowThreadProcessId(this->Handle,NULL));

		DoubleBuffered = true;

		SetDB(this);
	}
	catch (DdeError & e)
	{
		e.Message = GetDdeMessageFormatErr(sFuncErr, e.ErrorCode);
		Application->MessageBox(e.Message.c_str(),
								sErrorCaption,
								iErrorMessageBoxFlags);
	}
	catch (Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(),
								sErrorCaption,
								iErrorMessageBoxFlags);
	}
	catch (...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, iErrorMessageBoxFlags);
	}
}
//---------------------------------------------------------------------------

void __fastcall TSetupWindow::FormClose(TObject *Sender,
	TCloseAction &Action)
{
const char * const sFuncErr = "      " \
							  " . ";
	try
	{
		Action = caFree;

		if (FTableName.Length() != 0)
		{
			int iMessageResult = Application->MessageBox(" ?",
														 " ",
														  MB_YESNO |
														  MB_ICONWARNING |
														  MB_TASKMODAL);

			if (iMessageResult == ID_YES)
			{
				SaveChangesClick(Sender);
			}
			else if (iMessageResult == ID_CANCEL)
			{
				Action = caNone;
			}
		}

		if (Action == caNone)
		{
			return;
		}
		SetActiveWindow(Application->Handle);
	}
	catch (DdeError & e)
	{
		e.Message = GetDdeMessageFormatErr(sFuncErr, e.ErrorCode);
		Application->MessageBox(e.Message.c_str(),
								sErrorCaption,
								iErrorMessageBoxFlags);
	}
	catch (Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(),
								sErrorCaption,
								iErrorMessageBoxFlags);
	}
	catch (...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, iErrorMessageBoxFlags);
	}
}
//---------------------------------------------------------------------------

void __fastcall TSetupWindow::WMSizing(TMessage & Message)
//  WM_SIZING
{
	TForm::Dispatch(&Message);
	PRECT PointToRect = reinterpret_cast<PRECT>(Message.LParam);

	if (PointToRect != NULL)
	{
		if (this->Constraints->MaxHeight > 0
		 && PointToRect->bottom - PointToRect->top
				>= this->Constraints->MaxHeight)
		{
			if (Message.WParam == WMSZ_TOP
			 || Message.WParam == WMSZ_TOPLEFT
			 || Message.WParam == WMSZ_TOPRIGHT)
			{
				PointToRect->top = PointToRect->bottom -
					this->Constraints->MaxHeight;
			}
			else
			{
				PointToRect->bottom =
					PointToRect->top + this->Constraints->MaxHeight;
			}
		}
		else if (this->Constraints->MinHeight > 0
			  && PointToRect->bottom - PointToRect->top <=
					this->Constraints->MinHeight)
		{
			if (Message.WParam == WMSZ_TOP
			 || Message.WParam == WMSZ_TOPLEFT
			 || Message.WParam == WMSZ_TOPRIGHT)
			{
				PointToRect->top =
					PointToRect->bottom - this->Constraints->MinHeight;
			}
			else
			{
				PointToRect->bottom =
					PointToRect->top + this->Constraints->MinHeight;
			}
		}

		if (this->Constraints->MaxWidth > 0
		 && PointToRect->right - PointToRect->left
				>= this->Constraints->MaxWidth)
		{
			if (Message.WParam == WMSZ_RIGHT
			 || Message.WParam == WMSZ_TOPRIGHT
			 || Message.WParam == WMSZ_BOTTOMRIGHT)
			{
				PointToRect->right = PointToRect->left +
					this->Constraints->MaxWidth;
			}
			else
			{
				PointToRect->left = PointToRect->right -
					this->Constraints->MaxWidth;
			}
		}
		else if (this->Constraints->MinWidth > 0
			  && PointToRect->right - PointToRect->left
					<= this->Constraints->MinWidth)
		{
			if (Message.WParam == WMSZ_RIGHT
			 || Message.WParam == WMSZ_TOPRIGHT
			 || Message.WParam == WMSZ_BOTTOMRIGHT)
			{
				PointToRect->right =
					PointToRect->left + this->Constraints->MinWidth;
			}
			else
			{
				PointToRect->left =
					PointToRect->right - this->Constraints->MinWidth;
			}
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TSetupWindow::SaveChangesClick(TObject *Sender)
//     
{
	ListFieldsClick(ListFields);
	ToSaveParametersOfAttributes(FMapInfo, FTableName, ListFields->Items);
}
//---------------------------------------------------------------------------

void __fastcall TSetupWindow::FormDestroy(TObject *Sender)
{
const char * sFuncErr = "      . ";
	try
	{
		SetActiveWindow(Application->Handle);

		//      
		//     , 
		if (hSetupWindowHook)
		{
			UnhookWindowsHookEx(hSetupWindowHook); //  
		}
		hSetupWindowHook = NULL; //  ,  handle 

		if (FTaskWindowList)
		{
			EnableTaskWindows(FTaskWindowList);
		}

		EnableWindow(Application->Handle, true);
		SetActiveWindow(Application->Handle);
		FTaskWindowList = NULL;

		for (int i=0; i < this->ListFields->Count; ++i)
		{
			if (this->ListFields->Items->Objects[i])
			{
				TViewLine* DelViewLine;
				DelViewLine = (TViewLine*)(this->ListFields->Items->Objects[i]);
				delete DelViewLine;
			}
		}

		//      , 
		if (FEnterExpressionWindow)
		{
			FEnterExpressionWindow->Free(); //   
		}

		FEnterExpressionWindow = NULL;

		//      , 
		if (FNewFieldWindow)
		{
			FNewFieldWindow->Free(); //   
		}
		FNewFieldWindow = NULL;

		//      , 
		if (FSelectTableWindow)
		{
			FSelectTableWindow->Free(); //   
		}
		FSelectTableWindow = NULL;

		//      
		Application->HintHidePause = FOldHintHidePause;
		Application->HintPause = FOldHintPause;
	}
	catch (DdeError & e)
	{
		e.Message = GetDdeMessageFormatErr(sFuncErr, e.ErrorCode);
		Application->MessageBox(e.Message.c_str(),
								sErrorCaption,
								iErrorMessageBoxFlags);
	}
	catch (Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(),
								sErrorCaption,
								iErrorMessageBoxFlags);
	}
	catch (...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, iErrorMessageBoxFlags);
	}
}
//---------------------------------------------------------------------------

void __fastcall TSetupWindow::ListFieldsClick(TObject *Sender)
//       
{
const char * const sFuncErr = "   ListFieldsClick. ";
	try
	{
		TViewLine* NewViewLine;

		if ((ListFields->ItemIndex < 0) || (ListFields->ItemIndex > (ListFields->Items->Count - 1)) || (ListFields->Items->Count < 2))
		{
			FieldProperties->Enabled =false;
			this->FieldUp->Enabled =false;
			this->FieldDown->Enabled =false;
			this->FieldType->ItemIndex =-1;
		}
		else
		{
			if (ListFields->ItemIndex == 0)
			{
				this->FieldUp->Enabled =false;
				this->FieldDown->Enabled =true;
			}
			else if (ListFields->ItemIndex == (ListFields->Items->Count - 1))
			{
				this->FieldUp->Enabled =true;
				this->FieldDown->Enabled =false;
			}
			else
			{
				this->FieldUp->Enabled =true;
				this->FieldDown->Enabled =true;
			}
		}

		if (this->FCurrentField <= (ListFields->Items->Count-1) && this->FCurrentField>=0)
		{
			NewViewLine = reinterpret_cast<TViewLine*>(ListFields->Items->Objects[this->FCurrentField]);
			if (NewViewLine->cViewType >=0)
			{
				if (NewViewLine->sLineName == ListFields->Items->Strings[this->FCurrentField])
				{
					NewViewLine->bColumnEditable =this->FieldEnabled->Checked;

					if (this->FieldType->ItemIndex==0)
					{
						NewViewLine->cViewType =0;

						if (NewViewLine->ucColumnType == COL_TYPE_DATE)
						{
							if (this->DateFormat->ItemIndex ==0)
								NewViewLine->ucDateFormat = 0;
							else
								NewViewLine->ucDateFormat = 1;
							NewViewLine->sCustomDateFormat = this->CustomDateFormat->Text;
						}
					}
					else if (this->FieldType->ItemIndex == 1)
					{
						NewViewLine->cViewType = 1;
						NewViewLine->sListTable = this->ValuesTableName->Text;
						NewViewLine->sExpressionValue = this->IdentifierColumn->Items->Strings[this->ValueColumn->ItemIndex];
						NewViewLine->sExpressionViewedValue = this->ViewedColumn->Text;
						NewViewLine->sExpressionIdentifier = this->IdentifierColumn->Items->Strings[this->IdentifierColumn->ItemIndex];
						NewViewLine->sAdditionalCondition = this->AdditionalCondition->Text;
						NewViewLine->bFullListValuesCreated = this->FullValuesVistCreated->Checked;
					}
					else if (this->FieldType->ItemIndex==2)
					{
						NewViewLine->cViewType =2;
						TListValue NewListValue;
						NewViewLine->ListValues.clear();

						for (int i = 1; i <= this->ValueList->Strings->Count ; ++i)
						{
							NewListValue.sSavedValue = this->ValueList->Cells[0][i];
							NewListValue.sViewedValue = this->ValueList->Cells[1][i];
							NewViewLine->ListValues.push_back(NewListValue);
						}
					}
				}
			}
			else //    
			{
				NewViewLine->bCaptionViewed = this->CaptionViewed->Checked;

				if (NewViewLine->bCaptionViewed)
					NewViewLine->ucJustify = CaptionJustify->ItemIndex;
			}
			ListFields->Repaint();
		}

		if (ListFields->ItemIndex < 0)
			return;

		NewViewLine = reinterpret_cast<TViewLine*>(ListFields->Items->Objects[ListFields->ItemIndex]);

		if (NewViewLine->sLineName==ListFields->Items->Strings[ ListFields->ItemIndex ])
		{
			this->FCurrentField =ListFields->ItemIndex;
			FieldProperties->Enabled =true;
			this->FieldEnabled->Checked = NewViewLine->bColumnEditable;

			if (this->FieldEnabled->OnClick)
				this->FieldEnabled->OnClick(this->FieldEnabled);
			if (NewViewLine->cViewType==-1)
			{
				this->FieldType->Items->Strings[0] = "";
				this->FieldType->ItemIndex = 0;
				this->CaptionViewed->Checked = NewViewLine->bCaptionViewed ;
				FieldType->Enabled = false;

				if (CaptionViewed->OnClick)
					CaptionViewed->OnClick(CaptionViewed);
				if (NewViewLine->bCaptionViewed)
					CaptionJustify->ItemIndex = NewViewLine->ucJustify;
			}
			else
			{
				if (NewViewLine->ucColumnType==COL_TYPE_LOGICAL)
					this->FieldType->Items->Strings[0] = " -  ";
				else if (NewViewLine->ucColumnType==COL_TYPE_DATE)
					this->FieldType->Items->Strings[0] =" +  ";
				else
					this->FieldType->Items->Strings[0] =" ";

				FieldType->Enabled = true;

				if (NewViewLine->cViewType==0)
				{
					if (NewViewLine->ucColumnType==COL_TYPE_DATE)
					{
						this->FieldType->Items->Strings[0] =" +  ";

						if (NewViewLine->ucDateFormat == 0)
							this->DateFormat->ItemIndex =0;
						else
							this->DateFormat->ItemIndex =1;
						this->CustomDateFormat->Text = NewViewLine->sCustomDateFormat;

						if (this->CustomDateFormat->OnSelect)
							this->CustomDateFormat->OnSelect(this->CustomDateFormat);
					}

					this->FieldType->ItemIndex =0;
					this->ValuesTableName->Text ="";

					if (this->ValuesTableName->OnSelect)
						this->ValuesTableName->OnSelect(this->ValuesTableName);
					this->ValueColumn->Text ="";
					this->ViewedColumn->Text ="";
					this->IdentifierColumn->Text ="";

					for (int i = this->ValueList->Strings->Count ; i >= 1 ; --i)
						this->ValueList->DeleteRow(i);
				}
				else if (NewViewLine->cViewType==1)
				{
					this->FieldType->ItemIndex =1;
                    this->FullValuesVistCreated->Checked = NewViewLine->bFullListValuesCreated;
					this->ValuesTableName->Text =NewViewLine->sListTable;

					if (this->ValuesTableName->OnSelect)
						this->ValuesTableName->OnSelect(this->ValuesTableName);
					this->ValueColumn->ItemIndex = this->ValueColumn->Items->IndexOf(NewViewLine->sExpressionValue);
					this->ViewedColumn->Text =NewViewLine->sExpressionViewedValue;
					this->IdentifierColumn->ItemIndex = this->IdentifierColumn->Items->IndexOf(NewViewLine->sExpressionIdentifier);

					for (int i = this->ValueList->Strings->Count ; i >= 1 ; --i)
						this->ValueList->DeleteRow(i);
					this->AdditionalCondition->Text =NewViewLine->sAdditionalCondition;
				}
				else if (NewViewLine->cViewType==2)
				{
					this->FieldType->ItemIndex =2;
					this->ValuesTableName->Text ="";

					if (this->ValuesTableName->OnSelect)
						this->ValuesTableName->OnSelect(this->ValuesTableName);

					for (int i = this->ValueList->Strings->Count ; i >= 1 ; --i)
						this->ValueList->DeleteRow(i);

					for (TListValues::iterator i = NewViewLine->ListValues.begin(); i != NewViewLine->ListValues.end() ; ++i)
						this->ValueList->InsertRow(i->sSavedValue, i->sViewedValue, true);
				}
			}

			if (this->FieldType->OnSelect)
				this->FieldType->OnSelect(this->FieldType);
		}
	}
	catch (DdeError & e)
	{
		Application->MessageBox(GetDdeMessageFormatErr(sFuncErr,e.ErrorCode).c_str(), sErrorCaption, iErrorMessageBoxFlags);
	}
	catch (Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, iErrorMessageBoxFlags);
	}
	catch (...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, iErrorMessageBoxFlags);
	}
}
//---------------------------------------------------------------------------

void __fastcall TSetupWindow::ListBoxWindowProc(TMessage &Message)
// ,  ,  
//   
{
	this->OldListBoxWindowProc(Message);

	if (Message.Msg == LB_ADDSTRING)
		this->ListFieldsClick(ListFields);
}
//---------------------------------------------------------------------------

void __fastcall TSetupWindow::SelectTableWindow_OkButtonClick(TObject *Sender)
//   OKButton   
{
const char * const sFuncErr = "   SelectTableWindow_OkButtonClick. ";
	try
	{
		AnsiString sNewTableName, sQueryExpressions, sBuffer;
		TViewLines NewViewLines;
		TWinControl * SenderControl;
		bool bOldPrinting;

		if (Sender == NULL)
			return;

	SenderControl = dynamic_cast<TWinControl*>(Sender);

		if (SenderControl == NULL)
			return;

		if (SenderControl->Owner == NULL)
			return;

		if (SenderControl->Owner != FSelectTableWindow)
			return;

	sNewTableName =this->FSelectTableWindow->ComboBox1->Text;

		if (FMapInfo.IsOpenedTab(sNewTableName)==false)
			throw Exception(" \""+sNewTableName+"\"  .");

		if (this->FTableName.Length() != 0)
		{
			this->Enabled =false;

			if (Application->MessageBox(" ?", " ", MB_YESNO | MB_ICONWARNING | MB_TASKMODAL)==IDYES)
				this->SaveChangesClick(Sender);
		}

		if (ToTakeParametersOfAttributes(FMapInfo, sNewTableName, 0, NewViewLines, sQueryExpressions, true))
		{
			if (sQueryExpressions.Length() != 0)
				FMapInfo.CloseTable(sQueryExpressions);
			this->FTableName ="";
			this->ListFields->Clear();
			this->FCurrentField =-1;
			this->FieldType->ItemIndex =-1;

			if (this->ValuesTableName->OnSelect)
				this->ValuesTableName->OnSelect(this->ValuesTableName);
			this->FieldEnabled->Checked =false;
			this->FieldProperties->Enabled =false;

			if (NewViewLines.size())
				for (TViewLines::iterator VLIterator = NewViewLines.begin(); VLIterator != NewViewLines.end(); ++VLIterator)
				{
					TViewLine * NewViewLine = new TViewLine(*VLIterator);
					ListFields->AddItem(VLIterator->sLineName,reinterpret_cast<TObject *>(NewViewLine));
				}

			FTableName = sNewTableName;

			try
			{
				//      MapInfo
				bOldPrinting = PrintingMapInfoError(false);
				sBuffer = MapInfo_CurrentRowId;
				sBuffer += "=TableInfo(\""+sNewTableName+"\","+TAB_INFO_NROWS+")";
				FMapInfo.Execute(sBuffer);

				sBuffer = MapInfo_CurrentTableName;
				sBuffer += "=\""+sNewTableName+"\"";
				FMapInfo.Execute(sBuffer);
				PrintingMapInfoError(bOldPrinting);
			}
			catch (Exception & e)
			{
				PrintingMapInfoError(bOldPrinting);
				e.Message = "        MapInfo " + e.Message;
				Application->MessageBox(e.Message.c_str(), sErrorCaption, iErrorMessageBoxFlags);
			}

			Caption = "  \'"+sNewTableName+"\'";
			Show();
			Enabled = true;
			SetActiveWindow(Handle);
		}
		else
			throw Exception("      .");
		FSelectTableWindow->Close();
	}
	catch (DdeError & e)
	{
		Application->MessageBox(GetDdeMessageFormatErr(sFuncErr,e.ErrorCode).c_str(), sErrorCaption, iErrorMessageBoxFlags);
	}
	catch (Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, iErrorMessageBoxFlags);
	}
	catch (...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, iErrorMessageBoxFlags);
	}
}

void __fastcall TSetupWindow::SelectTableWindow_CancelButtonClick(TObject *Sender)
//   CancelButton   
{
const char * const sFuncErr = "   SelectTableWindow_OkButtonClick. ";
	try
	{
		TWinControl * SenderControl;

		if (Sender == NULL)
			return;

		SenderControl = dynamic_cast<TWinControl*>(Sender);

		if (SenderControl == NULL)
			return;

		if (SenderControl->Owner == NULL)
			return;

		if (SenderControl->Owner != FSelectTableWindow)
			return;
		FSelectTableWindow->Close();
	}
	catch (DdeError & e)
	{
		Application->MessageBox(GetDdeMessageFormatErr(sFuncErr,e.ErrorCode).c_str(), sErrorCaption, iErrorMessageBoxFlags);
	}
	catch (Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, iErrorMessageBoxFlags);
	}
	catch (...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, iErrorMessageBoxFlags);
	}
}

void __fastcall TSetupWindow::ChildFormClose(TObject *Sender,   TCloseAction & Action)
//       
{
const char * const sFuncErr = "   ChildFormClose. ";
	try
	{
		TWinControl * SenderControl, * SenderOwner;

		if (Sender == NULL)
			return;
		SenderControl = dynamic_cast<TWinControl*>(Sender);

		if (SenderControl == NULL)
			return;
		if (IsWindow(SenderControl->ParentWindow))
		{
			SetActiveWindow(SenderControl->ParentWindow);
			EnableWindow(SenderControl->ParentWindow, true);
		}
		else if (SenderControl->Owner)
		{
			SenderOwner = dynamic_cast<TWinControl*>(SenderControl->Owner);

			if (SenderOwner)
			{
				SetActiveWindow(SenderOwner->Handle);
				SenderOwner->Enabled =true;
				SetActiveWindow(SenderOwner->Handle);
			}
			else
				SetActiveWindow(Application->Handle);
		}
		else
			SetActiveWindow(Application->Handle);

		if (this->FTableName.Length() == 0)
			this->Close();
	}
	catch (DdeError & e)
	{
		Application->MessageBox(GetDdeMessageFormatErr(sFuncErr,e.ErrorCode).c_str(), sErrorCaption, iErrorMessageBoxFlags);
	}
	catch (Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, iErrorMessageBoxFlags);
	}
	catch (...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, iErrorMessageBoxFlags);
	}
}

void __fastcall TSetupWindow::NewFieldWindow_SelectColumn(TObject *Sender)
//     /
// .
{
const char * const sFuncErr = "   NewFieldWindow_SelectColumn. ";
	try
	{
		TWinControl * SenderControl;

		if (Sender == NULL)
			return;
		SenderControl = dynamic_cast<TWinControl*>(Sender);

		if (SenderControl == NULL)
			return;
		if (SenderControl->Owner == NULL)
			return;
		if (SenderControl->Owner != FNewFieldWindow)
			return;
		if (FNewFieldWindow->ColumnName->ItemIndex==FNewFieldWindow->ColumnName->Items->Count-1)
		{
			FEnterExpressionWindow->FListOfExpressions = FNewFieldWindow->ColumnName;
			FNewFieldWindow->Enabled =false;
			FEnterExpressionWindow->Show();
		}
		else if ((FNewFieldWindow->ColumnName->ItemIndex+1)>FNewFieldWindow->FCountColumns)
			FEnterExpressionWindow->Expression->Text = FNewFieldWindow->ColumnName->Items[ FNewFieldWindow->ColumnName->ItemIndex ].Text;
	}
	catch (DdeError & e)
	{
		Application->MessageBox(GetDdeMessageFormatErr(sFuncErr,e.ErrorCode).c_str(), sErrorCaption, iErrorMessageBoxFlags);
	}
	catch (Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, iErrorMessageBoxFlags);
	}
	catch (...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, iErrorMessageBoxFlags);
	}
}

void __fastcall TSetupWindow::NewFieldWindow_OkButtonClick(TObject *Sender)
//   OKButton   /
// .
// / .
{
const char * const sFuncErr = "   NewFieldWindow_OkButtonClick. ";
	try
	{
		bool bNewValue;
		TViewLine * NewViewLine;

		TWinControl * SenderControl;

		if (Sender == NULL)
			return;
		SenderControl = dynamic_cast<TWinControl*>(Sender);

		if (SenderControl == NULL)
			return;
		if (SenderControl->Owner == NULL)
			return;
		if (SenderControl->Owner !=FNewFieldWindow)
			return;
		if (FNewFieldWindow->DividerCheck->Checked == false && TrimLeft(TrimRight(FNewFieldWindow->FieldName->Text)).Length() == 0)
		{
			Application->MessageBox("   .", " ", iErrorMessageBoxFlags);
			return;
		}
		if (FNewFieldWindow->DividerCheck->Checked ||
			(!FNewFieldWindow->DividerCheck->Checked && (FNewFieldWindow->ColumnName->ItemIndex+1)<FNewFieldWindow->ColumnName->Items->Count))
		{
			if (FNewFieldWindow->FChangeableField < 0)
			{
				NewViewLine = new TViewLine();
				bNewValue =true;
			}
			else
			{
				NewViewLine = (TViewLine*)ListFields->Items->Objects[FNewFieldWindow->FChangeableField];
				bNewValue = false;
			}

			NewViewLine->sLineName =FNewFieldWindow->FieldName->Text;

			if (FNewFieldWindow->DividerCheck->Checked)
				NewViewLine->cViewType = -1;
			else
			{
				if (NewViewLine->cViewType == -1)
					NewViewLine->cViewType = 0;

				if ((FNewFieldWindow->ColumnName->ItemIndex+1) > FNewFieldWindow->FCountColumns)
				{
					NewViewLine->sExpression =FNewFieldWindow->ColumnName->Items->Strings[ FNewFieldWindow->ColumnName->ItemIndex ];
					NewViewLine->sColumnName ="";
					NewViewLine->ucColumnType =FMapInfo.TypeTableExpression(FTableName, NewViewLine->sExpression);
					NewViewLine->bColumnEditable =FMapInfo.IsTableExpressionEditable(FTableName, NewViewLine->sExpression);
				}
				else
				{
					NewViewLine->sColumnName =FNewFieldWindow->ColumnName->Items->Strings[ FNewFieldWindow->ColumnName->ItemIndex];
					NewViewLine->ucColumnType = FMapInfo.RequestInt("ColumnInfo("+FTableName+","+NewViewLine->sColumnName+","+COL_INFO_TYPE+")");

					if (AnsiLowerCase(FMapInfo.Request("ColumnInfo("+FTableName+","+NewViewLine->sColumnName+","+COL_INFO_EDITABLE+")", 1))=="t")
						NewViewLine->bColumnEditable =true;
					else
						NewViewLine->bColumnEditable =false;
				}
			}

			if (bNewValue)
			{
				if (ListFields->ItemIndex >=0 && ListFields->ItemIndex < ListFields->Items->Count)
					ListFields->Items->InsertObject(ListFields->ItemIndex+1, NewViewLine->sLineName, (TObject*)NewViewLine);
				else
					ListFields->AddItem(NewViewLine->sLineName, (TObject*)NewViewLine);
			}
			else
				ListFields->Items->Strings[FNewFieldWindow->FChangeableField] = NewViewLine->sLineName;

			if (ListFields->OnClick)
				ListFields->OnClick(ListFields);
		}
		FNewFieldWindow->Close();
	}
	catch (DdeError & e)
	{
		Application->MessageBox(GetDdeMessageFormatErr(sFuncErr,e.ErrorCode).c_str(), sErrorCaption, iErrorMessageBoxFlags);
	}
	catch (Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, iErrorMessageBoxFlags);
	}
	catch (...)
	{
	Application->MessageBox(sFuncErr, sErrorCaption, iErrorMessageBoxFlags);
	}
}

void __fastcall TSetupWindow::EnterExpressionWindow_OkButtonClick(TObject * Sender)
//   OKButton    MapBasic 
//   ,       NewFiledWindow
{
const char * const sFuncErr = "   EnterExpressionWindow_OkButtonClick. ";
	try
	{
	TWinControl * SenderControl;

		if (Sender == NULL)
		return;

	SenderControl = dynamic_cast<TWinControl*>(Sender);

		if (SenderControl == NULL)
		return;

		if (SenderControl->Owner == NULL)
		return;

		if (SenderControl->Owner !=FEnterExpressionWindow)
		return;

		if (FEnterExpressionWindow->Expression->Text.Length() == 0)
		Application->MessageBox("  .", "  ", iErrorMessageBoxFlags);
		else
		if (FTableName.Length() > 0 || FMapInfo.IsOpenedTab(FTableName))
			if (FMapInfo.IsCorrectTableExpression(FTableName, FEnterExpressionWindow->Expression->Text)==false)
			Application->MessageBox("  .", "  ", iErrorMessageBoxFlags);
			else
			{
			FEnterExpressionWindow->FListOfExpressions->Items->Delete(FEnterExpressionWindow->FListOfExpressions->Items->Count -1);
			FEnterExpressionWindow->FListOfExpressions->Items->Add(FEnterExpressionWindow->Expression->Text);
			FEnterExpressionWindow->FListOfExpressions->Items->Add("...");
			FEnterExpressionWindow->FListOfExpressions->ItemIndex = FEnterExpressionWindow->FListOfExpressions->Items->Count-2;
			FEnterExpressionWindow->Close();
			}
	}
	catch (DdeError & e)
	{
	Application->MessageBox(GetDdeMessageFormatErr(sFuncErr,e.ErrorCode).c_str(), sErrorCaption, iErrorMessageBoxFlags);
	}
	catch (Exception & e)
	{
	e.Message = sFuncErr + e.Message;
	Application->MessageBox(e.Message.c_str(), sErrorCaption, iErrorMessageBoxFlags);
	}
	catch (...)
	{
	Application->MessageBox(sFuncErr, sErrorCaption, iErrorMessageBoxFlags);
	}
}

void __fastcall TSetupWindow::EnterExpressionWindow_CheckUpClick(TObject * Sender)
//   CheckUp    MapBasic 
//   
{
const char * const sFuncErr = "   EnterExpressionWindow_CheckUpClick. ";
	try
	{
		TWinControl * SenderControl;

		if (Sender == NULL)
			return;
		SenderControl = dynamic_cast<TWinControl*>(Sender);

		if (SenderControl == NULL)
			return;
		if (SenderControl->Owner == NULL)
			return;
		if (SenderControl->Owner !=FEnterExpressionWindow)
			return;
		if (FEnterExpressionWindow->Expression->Text.Length() == 0)
		{
			Application->MessageBox("  .", "  ", MB_OK | MB_ICONWARNING | MB_TASKMODAL);
			return;
		}
		if (FTableName.Length() != 0 || FMapInfo.IsOpenedTab(FTableName))
		{
			if (FMapInfo.IsCorrectTableExpression(FTableName, FEnterExpressionWindow->Expression->Text)==false)
				Application->MessageBox("  .", "  ", MB_OK | MB_ICONWARNING | MB_TASKMODAL);
			else
				Application->MessageBox(" .", " ", MB_OK | MB_ICONWARNING | MB_TASKMODAL);
		}
		else
			Application->MessageBox(AnsiString("   .  "+FTableName+"  .").c_str(),sErrorCaption, iErrorMessageBoxFlags);
	}
	catch (DdeError & e)
	{
		Application->MessageBox(GetDdeMessageFormatErr(sFuncErr,e.ErrorCode).c_str(), sErrorCaption, iErrorMessageBoxFlags);
	}
	catch (Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(), sErrorCaption, iErrorMessageBoxFlags);
	}
	catch (...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, iErrorMessageBoxFlags);
	}
}
//---------------------------------------------------------------------------

void TSetupWindow::SelectNewTable()
//       ,
//     
{

const char * const sFuncErr = "   SelectNewTable. ";
	try
	{
		short siNumTables;
		short siCountTables = 0;
		siNumTables = FMapInfo.NumTables();

		if (siNumTables <= 0)
		{
			Application->MessageBox("  ." , " " , MB_OK | MB_ICONWARNING | MB_TASKMODAL);
			return;
		}

		FSelectTableWindow->ComboBox1->Clear();

		for (short si = 1 ; si <= siNumTables ; ++si)
			if (FMapInfo.RequestInt("TableInfo("+IntToStr(si)+","+TAB_INFO_TYPE+")") == (TAB_TYPE_BASE || TAB_TYPE_LINKED))
			{
			FSelectTableWindow->ComboBox1->AddItem(FMapInfo.Request("TableInfo("+IntToStr(si)+","+TAB_INFO_NAME+")", 256), NULL);
			++siCountTables;
			}

		if (siCountTables <=0)
		{
			Application->MessageBox("       .", " ", MB_OK | MB_ICONWARNING | MB_TASKMODAL);
		}

		FSelectTableWindow->ComboBox1->ItemIndex = 0;

		if (this->Showing)
			FSelectTableWindow->Parent = NULL;
		else
		{
			FSelectTableWindow->Parent = NULL;
			FSelectTableWindow->ParentWindow = 0;
		}

		Enabled = false;
		FSelectTableWindow->Enabled = true;
		FSelectTableWindow->Show();
	}
	catch (Exception &e)
	{
		e.Message = sFuncErr + e.Message;
		throw;
	}
	catch (...)
	{
		throw;
	}
}

void __fastcall TSetupWindow::FieldTypeSelect(TObject *Sender)
{
	if ((ListFields->ItemIndex >= 0) && (ListFields->ItemIndex < ListFields->Items->Count))
	{
		TViewLine* ViewLine = reinterpret_cast<TViewLine*>(ListFields->Items->Objects[ListFields->ItemIndex]);

		if (this->FieldType->ItemIndex==0)
		{
			this->TableFieldOptions->Enabled =false;
			this->TableFieldOptions->Visible =false;
			this->StaticListOptions->Enabled =false;
			this->StaticListOptions->Visible =false;

			if (ViewLine->cViewType ==-1)
			{
				CaptionViewed->Enabled = true;
				CaptionViewed->Visible = true;
				CaptionJustify->Visible = true;
				FieldEnabled->Visible = false;
				FieldEnabled->Enabled = false;
				CaptionJustify->Top = TableFieldOptions->Top;
				this->DateFieldOptions->Enabled =false;
				this->DateFieldOptions->Visible =false;
			}
			else
			{
				CaptionViewed->Enabled = false;
				CaptionViewed->Visible = false;
				CaptionJustify->Visible = false;
				FieldEnabled->Visible = true;
				FieldEnabled->Enabled = true;

				if (ViewLine->ucColumnType==COL_TYPE_DATE)
				{
					this->DateFieldOptions->Enabled =true;
					this->DateFieldOptions->Visible =true;
					this->DateFieldOptions->Top =this->TableFieldOptions->Top;
					this->DateFieldOptions->Height = this->FieldProperties->Height - this->DateFieldOptions->Top - 2;

					if (this->CustomDateFormat->OnChange)
						this->CustomDateFormat->OnChange(CustomDateFormat);
				}
				else
				{
					this->DateFieldOptions->Enabled =false;
					this->DateFieldOptions->Visible =false;
				}
			}
		}
		else
		{
			if (ViewLine->cViewType ==-1)
				return;
			if (this->FieldType->ItemIndex==1)
			{
				FieldEnabled->Visible = true;
				FieldEnabled->Enabled = true;
				this->TableFieldOptions->Enabled =true;
				this->TableFieldOptions->Visible =true;
				this->StaticListOptions->Enabled =false;
				this->StaticListOptions->Visible =false;
				this->DateFieldOptions->Enabled =false;
				this->DateFieldOptions->Visible =false;
				CaptionViewed->Enabled = false;
				CaptionViewed->Visible = false;
				CaptionJustify->Visible = false;
			}
			else if (this->FieldType->ItemIndex == 2)
			{
				FieldEnabled->Visible = true;
				FieldEnabled->Enabled = true;
				this->TableFieldOptions->Enabled =false;
				this->TableFieldOptions->Visible =false;
				this->DateFieldOptions->Enabled =false;
				this->DateFieldOptions->Visible =false;
				CaptionViewed->Enabled = false;
				CaptionViewed->Visible = false;
				CaptionJustify->Visible = false;
				this->StaticListOptions->Enabled =true;
				this->StaticListOptions->Visible =true;
				this->StaticListOptions->Top =this->TableFieldOptions->Top;
				this->StaticListOptions->Height = this->FieldProperties->Height - this->StaticListOptions->Top - 2;
				ValueList->Height = CreateValue->Top - ValueList->Top - ValueList->Left;
			}
			else
			{
				FieldEnabled->Visible = true;
				FieldEnabled->Enabled = true;
				this->TableFieldOptions->Enabled =false;
				this->TableFieldOptions->Visible =false;
				this->DateFieldOptions->Enabled =false;
				this->DateFieldOptions->Visible =false;
				this->TableFieldOptions->Enabled =false;
				this->TableFieldOptions->Visible =false;
				this->StaticListOptions->Enabled =false;
				this->StaticListOptions->Visible =false;
				this->DateFieldOptions->Enabled =false;
				this->DateFieldOptions->Visible =false;
			}
		}
	}
}
//---------------------------------------------------------------------------


void __fastcall TSetupWindow::ValuesTableNameSelect(TObject *Sender)
{

	if (Sender == ((TObject*)ValuesTableName))
	{
		this->ValueColumn->Items->Clear();
		this->ViewedColumn->Items->Clear();
		this->IdentifierColumn->Items->Clear();

		if (FMapInfo.IsOpenedTab(ValuesTableName->Text))
		{
			AnsiString sNum;

			for (short si = 1 ; si <= FMapInfo.RequestInt("TableInfo("+ValuesTableName->Text+","+TAB_INFO_NCOLS+")") ; ++si)
			{
				sNum = IntToStr(si);
				this->ValueColumn->Items->Add(FMapInfo.Request("ColumnInfo("+ValuesTableName->Text+",\"COL"+sNum+"\","+COL_INFO_NAME+")", 256));
				this->ViewedColumn->Items->Add(FMapInfo.Request("ColumnInfo("+ValuesTableName->Text+",\"COL"+sNum+"\","+COL_INFO_NAME+")", 256));
				this->IdentifierColumn->Items->Add(FMapInfo.Request("ColumnInfo("+ValuesTableName->Text+",\"COL"+sNum+"\","+COL_INFO_NAME+")", 256));
			}
		}
  }
}
//---------------------------------------------------------------------------

void __fastcall TSetupWindow::CheckUpClick(TObject *Sender)
{
	if (AdditionalCondition->Text.Length() == 0)
		Application->MessageBox("  .", "  ", MB_OK | MB_ICONWARNING | MB_TASKMODAL);
	else if (FTableName.Length() != 0)
	{
		if (FMapInfo.IsOpenedTab(FTableName))
		{
			if (FMapInfo.IsCorrectSQLCondition(FTableName, AdditionalCondition->Text)==false)
				Application->MessageBox("  .", "  ", iErrorMessageBoxFlags);
			else
				Application->MessageBox(" .", " ", iErrorMessageBoxFlags);
		}
		else
			Application->MessageBox(AnsiString("   .  "+FTableName+"  .").c_str(),sErrorCaption, iErrorMessageBoxFlags);
	}
}
//---------------------------------------------------------------------------

void __fastcall TSetupWindow::CreateValueClick(TObject *Sender)
{
	ValueList->InsertRow("","",true);
}
//---------------------------------------------------------------------------

void __fastcall TSetupWindow::DeleteValueClick(TObject *Sender)
{
	if (ValueList->Selection.Top > 0)
		ValueList->DeleteRow(ValueList->Selection.Top);
}
//---------------------------------------------------------------------------


void __fastcall TSetupWindow::FieldDownClick(TObject *Sender)
{
	if (ListFields->ItemIndex >= ListFields->Items->Count)
		return;
	ListFields->Items->Exchange(ListFields->ItemIndex, ListFields->ItemIndex+1);
	++FCurrentField;

	if (ListFields->OnClick)
		ListFields->OnClick(ListFields);
}
//---------------------------------------------------------------------------

void __fastcall TSetupWindow::CreateFieldClick(TObject *Sender)
{
	short siNumColumns;
	FNewFieldWindow->FChangeableField =-1;

	siNumColumns = FMapInfo.RequestInt("TableInfo("+FTableName+","+TAB_INFO_NCOLS+")");

	if (siNumColumns <= 0)
		return;
	FNewFieldWindow->Parent = NULL;
	FNewFieldWindow->Caption =" ";
	FNewFieldWindow->FieldName->Text ="";
	FNewFieldWindow->ColumnName->Clear();

	for (short si = 1 ; si <= siNumColumns ; ++si)
		FNewFieldWindow->ColumnName->AddItem(FMapInfo.Request("ColumnInfo("+FTableName+",COL"+IntToStr(si)+","+COL_INFO_NAME+")", 256), NULL);
	FNewFieldWindow->FCountColumns = FNewFieldWindow->ColumnName->Items->Count;
	FNewFieldWindow->ColumnName->AddItem("...", NULL);
	FNewFieldWindow->ColumnName->ItemIndex = 0;
	Enabled=false;
	FNewFieldWindow->Show();
}
//---------------------------------------------------------------------------

void __fastcall TSetupWindow::DeleteFieldClick(TObject *Sender)
{
	int i = ListFields->ItemIndex;
	TViewLine * NewViewLine = reinterpret_cast<TViewLine*>(ListFields->Items->Objects[i]);
	delete NewViewLine;
	ListFields->Items->Delete(i);
	this->FCurrentField=-1;
	ListFields->ItemIndex =i;

	if (ListFields->OnClick)
		ListFields->OnClick(ListFields);
}
//---------------------------------------------------------------------------

void __fastcall TSetupWindow::CloseWindowClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------

void __fastcall TSetupWindow::SelectTableClick(TObject *Sender)
{
	SelectNewTable();
}
//---------------------------------------------------------------------------

void __fastcall TSetupWindow::FormResize(TObject *Sender)
{
	Fields->Width = ClientWidth / 2;
	FieldProperties->Left = this->Fields->Left + this->Fields->Width;
	FieldProperties->Width = this->ClientWidth - this->FieldProperties->Left - this->Fields->Left;
	int iInterval = 4;
	CreateField->Left = ListFields->Left;
	CreateField->Width = (ListFields->Width - iInterval) / 2;
	DeleteField->Left = CreateField->Left + CreateField->Width + iInterval;
	DeleteField->Width = ListFields->Width - iInterval - CreateField->Width;
	FieldUp->Top = Fields->Top + (Fields->Height - iInterval - FieldUp->Height - FieldDown->Height) / 2;
	FieldDown->Top = FieldUp->Top + iInterval + FieldUp->Height;
	this->ListFields->Repaint();
}
//---------------------------------------------------------------------------


void __fastcall TSetupWindow::FormKeyPress(TObject *Sender, char &Key)
{
	switch (Key)
	{
		case VK_ESCAPE: Key = NULL;
		break;
		default:
		AllKeyPress(Sender,Key);
		break;
	}
}
//---------------------------------------------------------------------------


void __fastcall TSetupWindow::FormKeyDown(TObject *Sender, WORD &Key,
	TShiftState Shift)
{
	switch (Key)
	{
		case VK_ESCAPE: Key = NULL;
		break;
	}
}
//---------------------------------------------------------------------------

void __fastcall TSetupWindow::CustomDateFormatChange(TObject *Sender)
{
	if (CustomDateFormat->Text.Length() > 0)
		DateFormat->Enabled = false;
	else
		DateFormat->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TSetupWindow::CustomDateFormatSelect(TObject *Sender)
{
	CustomDateFormatChange(Sender);
}
//---------------------------------------------------------------------------


void __fastcall TSetupWindow::CaptionViewedClick(TObject *Sender)
{
	if (CaptionViewed->Checked)
		CaptionJustify->Enabled = true;
	else
		CaptionJustify->Enabled = false;
}
//---------------------------------------------------------------------------


void __fastcall TSetupWindow::ListFieldsDblClick(TObject *Sender)
{
	short siNumColumns;
	int iItemIndex = -1;

	FNewFieldWindow->Caption =" ";
	FNewFieldWindow->FChangeableField = ListFields->ItemIndex;
	siNumColumns = FMapInfo.RequestInt("Tableinfo("+FTableName+","+TAB_INFO_NCOLS+")");

	if (siNumColumns <=0)
		return;
	FNewFieldWindow->Parent =NULL;
	FNewFieldWindow->ColumnName->Clear();
	TViewLine * NewViewLine = reinterpret_cast<TViewLine*>(ListFields->Items->Objects[this->FCurrentField]);
	FNewFieldWindow->FieldName->Text = NewViewLine->sLineName;

	for (short si = 1 ; si <= siNumColumns ; ++si)
	{
		FNewFieldWindow->ColumnName->AddItem(FMapInfo.Request("ColumnInfo("+FTableName+",COL"+IntToStr(si)+","+COL_INFO_NAME+")", 256), NULL);

		if (NewViewLine->sColumnName == FNewFieldWindow->ColumnName->Items->Strings[ FNewFieldWindow->ColumnName->Items->Count-1 ])
			iItemIndex = FNewFieldWindow->ColumnName->Items->Count-1;
	}

	FNewFieldWindow->FCountColumns = FNewFieldWindow->ColumnName->Items->Count;
	FNewFieldWindow->ColumnName->ItemIndex = iItemIndex;

	if (NewViewLine->cViewType >= 0)
	{
		if (iItemIndex < 0)
		{
			FNewFieldWindow->ColumnName->AddItem(NewViewLine->sExpression, NULL);
			FNewFieldWindow->ColumnName->ItemIndex = FNewFieldWindow->ColumnName->Items->Count-1;
		}
	}
	else
	{
		iItemIndex = 0;
		FNewFieldWindow->ColumnName->ItemIndex = iItemIndex;
	}

	FNewFieldWindow->ColumnName->AddItem("...", NULL);

	if (NewViewLine->cViewType >= 0)
	{
		if ((FNewFieldWindow->ColumnName->ItemIndex+1)>(FNewFieldWindow->FCountColumns))
		FEnterExpressionWindow->Expression->Text =FNewFieldWindow->ColumnName->Items->Strings[ FNewFieldWindow->ColumnName->ItemIndex ];
	}
	else
		FNewFieldWindow->DividerCheck->Checked = true;
	Enabled=false;
	FNewFieldWindow->Show();
}
//---------------------------------------------------------------------------

void __fastcall TSetupWindow::ListFieldsDrawItem(TWinControl *Control,
		int Index, TRect &Rect, TOwnerDrawState State)
{
	if (Control != ListFields)
		return;

	TViewLine * ViewLine = reinterpret_cast<TViewLine*>(ListFields->Items->Objects[Index]);

	if (ViewLine->cViewType == -1)
	{
		ListFields->Canvas->FillRect(Rect);
		TRect CalcRect(Rect),TextRect(Rect);
		CalcRect.bottom = CalcRect.bottom - (CalcRect.bottom - CalcRect.top) / 2;

		if (ViewLine->bCaptionViewed)
		{
			int iTextWidth(ListFields->Canvas->TextWidth(ListFields->Items->Strings[Index]));
			TextRect.left = (((TextRect.right - TextRect.left) - iTextWidth) / 2);
			TextRect.right = TextRect.left + iTextWidth;
			ListFields->Canvas->TextOut(TextRect.left,TextRect.top,ListFields->Items->Strings[Index]);
			CalcRect.left=TextRect.right+1;
			DrawEdge(ListFields->Canvas->Handle,&CalcRect,EDGE_ETCHED,BF_BOTTOM);
			CalcRect.left=0;
			CalcRect.right = TextRect.left-2;
			DrawEdge(ListFields->Canvas->Handle,&CalcRect,EDGE_ETCHED,BF_BOTTOM);
		}
		else
			DrawEdge(ListFields->Canvas->Handle,&CalcRect,EDGE_ETCHED,BF_BOTTOM);
	}
	else
	{
		ListFields->Canvas->FillRect(Rect);
		ListFields->Canvas->TextOut(Rect.left+2,Rect.top,ListFields->Items->Strings[Index]);
	}
}
//---------------------------------------------------------------------------


void __fastcall TSetupWindow::FieldUpClick(TObject *Sender)
{
	if (ListFields->ItemIndex == 0)
		return;

	ListFields->Items->Exchange(ListFields->ItemIndex, ListFields->ItemIndex-1);
	--FCurrentField;

	if (ListFields->OnClick)
		ListFields->OnClick(ListFields);
}
//---------------------------------------------------------------------------


void __fastcall TSetupWindow::FieldEnabledClick(TObject *Sender)
{
	if (FieldEnabled->Checked)
	{
		ValueColumn->Enabled = true;
		LabelValue->Enabled = true;
	}
	else
	{
		ValueColumn->Enabled = false;
		LabelValue->Enabled = false;
	}
}
//---------------------------------------------------------------------------

extern "C" void APIENTRY __declspec(dllexport) DestroySetupWindow()
//     
//  
// !       
//      FormClose (Action:=caFree)
//      ,   
//     ,      ,
//         
{
	try
	{
		if (IsSetupWindowCreated)
			SetupWindow->Free();
		SetupWindow = NULL;
	}
	catch (...)
	{
		SetupWindow = NULL;
	}
}

extern "C" void APIENTRY __declspec(dllexport)
ViewSetupTable(int iDdeInstId,  HCONV hMapinfoDdeConv,
			   HCONV hApplicationDdeConv)
//     ,
//      
//   
{
const char * const sFuncErr = "      . ";
	try
	{
	//   ,    
	//      
		if ((hMapinfoDdeConv == NULL)
		 || (hApplicationDdeConv == NULL)
		 || (iDdeInstId == 0))
			throw Exception("      .");

		DestroySetupWindow();
		SetupWindow = new TSetupWindow(Application, hMapinfoDdeConv,
									   hApplicationDdeConv, iDdeInstId);
		SetupWindow->SelectNewTable();
	}
	catch (DdeError & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(
			GetDdeMessageFormatErr(e.Message.c_str(),
				e.ErrorCode).c_str(), sErrorCaption, iErrorMessageBoxFlags);
	}
	catch (Exception & e)
	{
		e.Message = sFuncErr + e.Message;
		Application->MessageBox(e.Message.c_str(),
								sErrorCaption, iErrorMessageBoxFlags);
	}
	catch (...)
	{
		Application->MessageBox(sFuncErr, sErrorCaption, iErrorMessageBoxFlags);
	}
}

