#include "InfoToolParametersUnit.h"

// TMyTableRowBoundLabel

void __fastcall TInfoToolComboBox::TBoundLabel::CMMouseEnter(TMessage & Message)
//  ,      
{
	inherited::Dispatch(&Message);

	if(SelectNewTableRow)
		this->Font->Style = TFontStyles() << fsUnderline ;
}

void __fastcall TInfoToolComboBox::TBoundLabel::CMMouseLeave(TMessage & Message)
//  ,     
{
	inherited::Dispatch(&Message);
	if(SelectNewTableRow)
		this->Font->Style = TFontStyles() >> fsUnderline ;
}

// TInfoToolComboBox

__fastcall TInfoToolComboBox::TInfoToolComboBox(Classes::TComponent* AOwner) : inherited(AOwner),ValueType(0)
{
	if(FEditLabel != NULL)
		FEditLabel->Free();
	FEditLabel = new TInfoToolComboBox::TBoundLabel(this);
	FEditLabel->FreeNotification(this);
	FEditLabel->FocusControl = this;
}

// TInfoToolIntEdit


bool TInfoToolIntEdit::IsNegativeCurrentValue(AnsiString & Value)
{
	if (Value.Length() > 0 && Value[1] == '-')
		return true;
	return false;
}

int TInfoToolIntEdit::DeleteFirstNulls(AnsiString & Value)
//   ,     
{
	int FirstPosition = 1;// ,     
	int NullsCount = 0;//   

	if (Value.Length() > 1 && Value[1] == '-')
	//       
	//    , ...
		FirstPosition = 2;//     

	while (Value.Length()>FirstPosition && Value[FirstPosition] == '0')
	//  ,     
	{
		Value.Delete(FirstPosition,1); // 
		++NullsCount;
	}
	return NullsCount;
}

void TInfoToolIntEdit::DeleteNoDigitSymbols(AnsiString & Value)
//   ,   
{
	int LastMinusPosition = 0;//   ,  

	for (int i = Value.Length(); i >0 ; --i)
	//    ,
	//   
		if (Value[i] == '-')
		//    ,   
		//     , ...
		{
			Value.Delete(i,1);//   
			LastMinusPosition = i;//    
		}
		else if (!isdigit(Value[i]))
		//    , ...
			Value.Delete(i,1); //  

	int FirstNullsCount = DeleteFirstNulls(Value);//    
	if (LastMinusPosition >0 && (LastMinusPosition - FirstNullsCount) <= 1)
	//       ,
	//    -    , ...
		Value.Insert('-',1);//     
}

bool TInfoToolIntEdit::ToCheckValue(AnsiString & Value)
//       
{
	int CheckValue = StrToIntDef(Value,0);
//MessageBox(0,Value.c_str(),IntToStr(CheckValue).c_str(),0);
	if (!(CheckValue == 0 && Value != "0")
	 && !(FMinValue <= 0 && CheckValue < FMinValue)
	 && !(CheckValue > FMaxValue)
	   )
	{
//MessageBox(0,IntToStr(FMaxValue).c_str(),IntToStr(CheckValue).c_str(),0);
///MessageBox(0,IntToStr(FMinValue).c_str(),IntToStr(CheckValue).c_str(),0);
		return true;
	}
return false;
}

void TInfoToolIntEdit::ToCorrectValue(AnsiString & Value)
//       
{
	DeleteNoDigitSymbols(Value);//  ,   
//MessageBox(0,CurValue.c_str(),"    ",0);

	if (Value.Length() == 0)
	//   , ...
		return;//   

	int CheckValue = StrToIntDef(Value,0); //    

	if (CheckValue == 0 && Value != "0")
	//         ,
	//      ,    ,
	//    Value   
	// (     ),  
	// 
		while (CheckValue == 0 && Value.Length() > 0)
		//   :
		//       
		//     ...
		{
			Value.Delete(Value.Length(),1); //   
			CheckValue = StrToIntDef(Value,0); //    
		}

	if (Value.Length() == 0)
	//   , ...
		return;//   

	while (CheckValue > FMaxValue)
		//   :
		//      ...
		{
			Value.Delete(Value.Length(),1); //   
			CheckValue = StrToIntDef(Value,0); //    
		}

	if (CheckValue < FMinValue)//     , ...
		Value = IntToStr(FMinValue);
}

int TInfoToolIntEdit::InsertChar(AnsiString & Value,const char NewChar,int StartPosition,int FinishPosition)
//     Value   
//StartPosition,int FinishPosition       NewChar
{
	int InsertPosition = 0; //   
	if (StartPosition != FinishPosition) //     , ...
		Value.Delete(StartPosition+1,FinishPosition-StartPosition);//   
	if (!(Value.Length() > 0 && StartPosition == 0 && NewChar == '0')
	 && !(Value.Length() > 1 && Value[1] == '-' && StartPosition == 1 && NewChar == '0')
	   )
	//       ,   ,
	//      ,
	//       ,
	//  ,   ,    , ...
	{
		if (Value == "0")
		//    , ...
		{
			InsertPosition = 1;
			Value[1] = NewChar;
		}
		else
		{
			InsertPosition = StartPosition+1;
			Value.Insert(AnsiString::StringOfChar(NewChar,1),InsertPosition);//      
		}
		return InsertPosition;
	}
return 0;
}

__fastcall TInfoToolIntEdit::TInfoToolIntEdit(Classes::TComponent* AOwner,int NewMinValue,int NewMaxValue): inherited(AOwner),
FMinValue(NewMinValue),FMaxValue(NewMaxValue)
{
	if (FMinValue > FMaxValue)
		FMinValue = FMaxValue;
};

void __fastcall TInfoToolIntEdit::CorrectValueOnMessage(TMessage & Message)
//   ,  
//  
{
	inherited::Dispatch(&Message);
	AnsiString CurValue = Text;//    
	DWORD StartSelPosition,FinishSelPosition; //     

	SendMessage(Handle,EM_GETSEL,reinterpret_cast<UINT>(&StartSelPosition),reinterpret_cast<UINT>(&FinishSelPosition));//   
	//MessageBox(0,CurValue.c_str()," ",0);
	ToCorrectValue(CurValue);//  
//MessageBox(0,CurValue.c_str(),"  ",0);
	Text = CurValue;//  
//	MessageBox(0,IntToStr(SelPosition).c_str(),"SelPosition",0);
//	MessageBox(0,IntToStr(Fin).c_str(),"Fin",0);

	SendMessage(Handle,EM_SETSEL,StartSelPosition,FinishSelPosition);//    

}

void __fastcall TInfoToolIntEdit::WMKeyDown(TWMKey & Message)
{
	int StartSelChar,FinishSelChar,InsertPosition; //     
	AnsiString CurValue = Text;//    
	SendMessage(Handle,EM_GETSEL,reinterpret_cast<UINT>(&StartSelChar),reinterpret_cast<UINT>(&FinishSelChar));//          

	if (Message.CharCode == VK_DELETE || Message.CharCode == VK_BACK)
	//    delete  backspace, ...
	{
		if (StartSelChar != FinishSelChar)
		//   , ...
			CurValue.Delete(StartSelChar+1,FinishSelChar-StartSelChar);//   
		else
		//    , ...
			switch (Message.CharCode)
			{
				case VK_DELETE:
				{
					if (!(StartSelChar == CurValue.Length()));
						CurValue.Delete(StartSelChar+1,1);//  
				}
				break;
				case VK_BACK:
				{
					if (StartSelChar > 0);
					{
						CurValue.Delete(StartSelChar,1);//  
						--StartSelChar;
					}
				}
				break;
			}
//MessageBox(0,CurValue.c_str(),"CurValue",0);
		if (CurValue.Length() == 0 || ToCheckValue(CurValue))
		//   , ...
		{
			Text = CurValue;//  
			SendMessage(Handle,EM_SETSEL,StartSelChar,StartSelChar);//    
		}
	}
	else
		inherited::Dispatch(&Message);//     
}

void __fastcall TInfoToolIntEdit::WMChar(TWMKey & Message)
{
	DWORD StartSelChar,FinishSelChar,InsertPosition; //     
	AnsiString CurValue = Text;//    
	bool CorrectSelectPositions = (SendMessage(Handle,EM_GETSEL,reinterpret_cast<UINT>(&StartSelChar),reinterpret_cast<UINT>(&FinishSelChar)) >= 0);//          
	if (isdigit(Message.CharCode)
	 && CorrectSelectPositions
	 && (
		 !(StartSelChar == 0 && FinishSelChar == 0 && (CurValue.Length()>1 && CurValue[1] == '-'))
		)
	   )
	//      
	//        , ...
	{
		InsertPosition = InsertChar(CurValue,Message.CharCode,StartSelChar,FinishSelChar);//     
		if (InsertPosition > 0)
		//     , ...
			StartSelChar = InsertPosition;//   

		if (ToCheckValue(CurValue))
		//   , ...
		{
			Text = CurValue;//  
			SendMessage(Handle,EM_SETSEL,StartSelChar,StartSelChar);//    
		}
	}
	else if (Message.CharCode == '-' && FMinValue < 0 && StartSelChar == 0 && (!(Text.Length()>1 && Text[1] == Message.CharCode) || Text != "0"))
	//     ,        , ...
	{
		InsertPosition = InsertChar(CurValue,Message.CharCode,StartSelChar,FinishSelChar);//     
		if (InsertPosition > 0)
		//     , ...
			StartSelChar = InsertPosition;//   
		if (CurValue == "-" || (CurValue != "-" && ToCheckValue(CurValue)))
		//   , ...
		{
			Text = CurValue;//  
			SendMessage(Handle,EM_SETSEL,StartSelChar,StartSelChar);//    
		}
	}
	else if (Message.CharCode == VK_TAB) //     TAB, ...
		inherited::Dispatch(&Message);//     
}

// TInfoToolDecimalEdit
__fastcall TInfoToolDecimalEdit::TInfoToolDecimalEdit(Classes::TComponent* AOwner, int NewWidth, int NewDecplaces, double NewMinValue, double NewMaxValue)
: inherited(AOwner), FDigitsWidth(NewWidth), FDecimals(NewDecplaces),
FMinValue(NewMinValue),FMaxValue(NewMaxValue)
{
//MessageBox(0,AnsiString("FDigitsWidth = "+IntToStr(FDigitsWidth)+", FDecimals = " +IntToStr(FDecimals)).c_str()," ",0);
	if (FMinValue > FMaxValue)
		FMinValue = FMaxValue;
	if (FDigitsWidth < 0)
	//   -   , ...
		FDigitsWidth = 18;//  -  -
	if (FDigitsWidth < 3) //   -   , ...
		FDecimals = 0;//   
	if (FDecimals > (FDigitsWidth - 2))
	//  -     -
	//        
	//  , ...
		FDecimals = FDigitsWidth - 2;//   
	if (FDecimals < -1)
	//  -     , ...
		FDecimals = - 1;//    
};

int TInfoToolDecimalEdit::InsertChar(AnsiString & Value,const char NewChar,int StartPosition, int FinishPosition)
//     Value   
//StartPosition,int FinishPosition       NewChar
{

	int InsertPosition = 0; //   

	if (StartPosition != FinishPosition) //     , ...
	{
		Value.Delete(StartPosition+1,FinishPosition-StartPosition);//   
        FinishPosition = StartPosition;
	}
	int SeparatorPosition = DecimalSeparatorPosition(Value);
//MessageBox(0,IntToStr(SeparatorPosition).c_str(),"SeparatorPosition",0);
	if (!(Value.Length() > 0 && StartPosition == 0 && NewChar == '0' && SeparatorPosition != 1)
	 && !(Value.Length() > 1 && Value[1] == '-' && StartPosition == 1 && NewChar == '0' && SeparatorPosition != 2)
	 && !(NewChar == DecimalSeparator && ((Value.Length() > 0 && Value[1] == '-' && StartPosition == 0) || SeparatorPosition > 0 || FDecimals == 0))
	   )
	//       ,   ,
	//  ,      
	//     ,
	//       ,
	//  ,   ,    ,
	//        
	//         
	// ...
	{
		int WidthValue = GetCurrentValueWidth(Value); //  
//MessageBox(0,IntToStr(WidthValue).c_str(),IntToStr(FDigitsWidth).c_str(),0);
		if (WidthValue < FDigitsWidth)//     , ...
		{
			bool IsNegativeValue = IsNegativeCurrentValue(Value);
			int PossibleIntegersWidth = (FDecimals >= 0) ? FDigitsWidth-FDecimals-1 : FDigitsWidth-2;//   
			int CurrentIntegersWidth = (SeparatorPosition > 0) ? SeparatorPosition-1 : WidthValue;//   

			InsertPosition = StartPosition+1;
			if (NewChar == DecimalSeparator && (FDecimals > 0 || FDecimals < 0))
			//   , ...
			{
//MessageBox(0," ","",0);
				InsertPosition = StartPosition+1;
//MessageBox(0,IntToStr(InsertPosition).c_str(),"InsertPosition",0);
//MessageBox(0,IntToStr(FIntegers).c_str(),"FIntegers",0);
//MessageBox(0,IntToStr(FDecimals).c_str(),IntToStr(WidthValue - StartPosition).c_str(),0);
				if ((WidthValue - StartPosition <= FDecimals) || FDecimals < 0)
				// && (Value.Length() > 0 && FDecimals > 0 && (Value.Length() - InsertPosition) < FDecimals)
				//   )
				//    ,
				//    -    
				//  , 
				{
					if ((IsNegativeValue && InsertPosition == 2) || InsertPosition ==1)
					{
						Value.Insert(AnsiString::StringOfChar('0',1),InsertPosition);//      
						++InsertPosition;
					}
					Value.Insert(AnsiString::StringOfChar(NewChar,1),InsertPosition);//      
//MessageBox(0,Value.c_str(),"Value",0);
					return InsertPosition;//  ,    
				}
			}
			else if (NewChar == '-' && !IsNegativeValue)
			//   ,     ,
			{
//MessageBox(0," ",Value.c_str(),0);
				if ((CurrentIntegersWidth < PossibleIntegersWidth && FDecimals >=0)
				 || (CurrentIntegersWidth <= PossibleIntegersWidth && FDecimals <0)
				   )
				//     ,
				//        
				//         , ...
					return inherited::InsertChar(Value,NewChar,StartPosition,FinishPosition);
//MessageBox(0," ",Value.c_str(),0);

			}
			else
			//   , ...
			{
//MessageBox(0," ","",0);

//MessageBox(0,IntToStr(InsertPosition).c_str(),"InsertPosition",0);
//MessageBox(0,IntToStr(SeparatorPosition).c_str(),"SeparatorPosition",0);
				if ((SeparatorPosition > 0 && InsertPosition <= SeparatorPosition) || SeparatorPosition == 0)
				//      , 
				{
//MessageBox(0,"   ","222",0);

//MessageBox(0,IntToStr(CurrentIntegersWidth).c_str(),"CurrentIntegersWidth",0);
					if (CurrentIntegersWidth == 1)
					{
					//       
					// 
						if (IsNegativeValue && InsertPosition == 3 && Value[2] == '0')
						{
							Value[2] = NewChar;
							return 2;
						}
						else if (InsertPosition == 2 && Value[1] == '0')
						{
							Value[1] = NewChar;
							return 1;
						}
					}
//MessageBox(0,IntToStr(CurrentIntegersWidth).c_str(),IntToStr(PossibleIntegersWidth).c_str(),0);
//MessageBox(0,IntToStr(WidthValue).c_str(),IntToStr(FIntegers).c_str(),0);
					if (CurrentIntegersWidth < PossibleIntegersWidth)
					//         , ...
					{
						Value.Insert(AnsiString::StringOfChar(NewChar,1),InsertPosition);//      
						return InsertPosition;//  ,    
					}
				}
				else
				//      , 
				{
					int CurrentDecimalsCount = WidthValue - SeparatorPosition;//   

//MessageBox(0,IntToStr(CurrentDecimalsCount).c_str(),"CurrentDecimalsCount",0);
					if (CurrentDecimalsCount > 0)
					{
						if (Value.Length() <= (SeparatorPosition+1) && InsertPosition == (SeparatorPosition+1) && Value[SeparatorPosition+1] == '0')
						{
							Value[SeparatorPosition+1] = NewChar;
							return SeparatorPosition+1;
						}
					}
					if ((FDecimals >= 0 && (CurrentDecimalsCount < FDecimals))
					 || (FDecimals < 0 && WidthValue < FDigitsWidth)
					   )
					//    
					//      ,
					//    , ...
					{
						if  (!(NewChar == '0' && (InsertPosition-1) != SeparatorPosition && InsertPosition >= Value.Length()))
						//        , ...
						{
							Value.Insert(AnsiString::StringOfChar(NewChar,1),InsertPosition);//      
							return InsertPosition;//  ,    
						}
					}
				}
			}
		}
	}
	return 0;
}

int TInfoToolDecimalEdit::GetCurrentValueWidth(AnsiString & Value)
{
//	if (IsNegativeCurrentValue(Value))
//		return Value.Length() - 1;
	return Value.Length();
}

bool TInfoToolDecimalEdit::IsNullCurrentValue(AnsiString & Value)
{
	if (Value.Length() > 0)
	//     
	{
		bool IsNullValue = false;//     
		AnsiString ValueBuffer = Value;
		if (IsNegativeCurrentValue(ValueBuffer))
			ValueBuffer.Delete(1,1);
		IsNullValue ^= (ValueBuffer == "0");
		IsNullValue ^= (ValueBuffer == AnsiString("0"+AnsiString::StringOfChar(DecimalSeparator,1)+"0"));
		IsNullValue ^= (ValueBuffer == AnsiString("0"+AnsiString::StringOfChar(DecimalSeparator,1)));
		IsNullValue ^= (ValueBuffer == AnsiString(AnsiString::StringOfChar(DecimalSeparator,1)+"0"));
		return IsNullValue;
	}
	else
		return false;
}

bool TInfoToolDecimalEdit::IsCorrectCharCountCurrentValue(AnsiString & Value)
//     
{
	int SeparatorPosition = DecimalSeparatorPosition(Value);// 
	int WidthValue = GetCurrentValueWidth(Value); //  
MessageBox(0,Value.c_str(),"IsCorrectCharCountCurrentValue",0);
MessageBox(0,IntToStr(FDigitsWidth).c_str(),IntToStr(WidthValue).c_str(),0);

	if (FDecimals<0 && IsNegativeCurrentValue(Value) && WidthValue-1 > FDigitsWidth)
		return false;
	else if (WidthValue > FDigitsWidth)
		return false;

//MessageBox(0,"111","IsCorrectCharCountCurrentValue",0);
	if (FDecimals < 0)
		return true;
//MessageBox(0,IntToStr(FDigitsWidth-FDecimals-1).c_str(),IntToStr(WidthValue - SeparatorPosition <= FDecimals).c_str(),0);
	if (FDecimals > 0)
		if ((SeparatorPosition >0 && WidthValue - SeparatorPosition <= FDecimals)
		 || (SeparatorPosition == 0 && WidthValue <= (FDigitsWidth-FDecimals-1))
		   )
			return true;
//MessageBox(0,"333","IsCorrectCharCountCurrentValue",0);
return false;
}

bool TInfoToolDecimalEdit::ToCheckValue(AnsiString & Value)
//       
{
	double CheckValue = StrToFloatDef(Value,0);

	if (!(CheckValue == 0 && !IsNullCurrentValue(Value))
	 && IsCorrectCharCountCurrentValue(Value)
	 && !(FMinValue <= 0 && CheckValue < FMinValue)
	 && !(CheckValue > FMaxValue)
	   )
		return true;
return false;
}

int TInfoToolDecimalEdit::DeleteFirstNulls(AnsiString & Value)
//   ,     
{
//MessageBox(0,Value.c_str(),"Value.c_str()",0);

	int FirstPosition = 1;// ,     
	int NullsCount = 0;//   

	if (Value.Length() > 1 && Value[1] == '-')
	//       
	//    , ...
		FirstPosition = 2;//     
	while (Value.Length()>FirstPosition && Value[FirstPosition] == '0')
	//  ,     
	//       
	{
//MessageBox(0,IntToStr(FirstPosition).c_str(),AnsiString::StringOfChar(Value[FirstPosition+1],1).c_str(),0);


		if (Value[FirstPosition+1] == DecimalSeparator)
			break;

		Value.Delete(FirstPosition,1); // 
		++NullsCount;
	}
//MessageBox(0,Value.c_str(),"Value.c_str() ",0);

	return NullsCount;
}

int TInfoToolDecimalEdit::DeleteLastNulls(AnsiString & Value)
//   ,     
{
	int Position = DecimalSeparatorPosition(Value); //  
	int NullsCount = 0;//   

	if (Position == 0) //    
		return 0; //  ,  

	for (int i = Value.Length(); i>Position;--i)
		if (Value[i] == '0')
		{
			Value.Delete(i,1); // 
			++NullsCount;
		}
		else
			break;
	return NullsCount;
}

int TInfoToolDecimalEdit::DecimalSeparatorPosition(AnsiString & Value)
{
	for (int i = 1; i <= Value.Length(); ++i)
		if (Value[i] == DecimalSeparator)
			return i;
return 0;
}

void TInfoToolDecimalEdit::DeleteNoDigitSymbols(AnsiString & Value)
//   ,   
{
	int LastMinusPosition = 0;//   ,  
	int LastDecimalSeparatorPosition = 0;//  ,  

	for (int i = Value.Length(); i >0 ; --i)
	//    ,
	//   
		if (Value[i] == '-')
		//    , ...
		{
			Value.Delete(i,1);//   
				if (LastDecimalSeparatorPosition > 0);
					--LastDecimalSeparatorPosition;
			LastMinusPosition = i;//    
		}
		else if (Value[i] == DecimalSeparator)
		//    , ...
		{
			if (LastDecimalSeparatorPosition > 0)
			{
				Value.Delete(LastDecimalSeparatorPosition,1); //   
				if (LastMinusPosition > 0);
					--LastMinusPosition;
			}
			LastDecimalSeparatorPosition = i;//   
		}
		else if (!isdigit(Value[i]))
		//    , ...
			Value.Delete(i,1); //  
//MessageBox(0,Value.c_str(),"  ",0);
	int FirstNullsCount = DeleteFirstNulls(Value);//    
//MessageBox(0,Value.c_str(),"  ",0);
	if (LastMinusPosition > 0 && (LastMinusPosition - FirstNullsCount) <= 1)
	//       ,
	//    -    , ...
		Value.Insert('-',1);//     
	DeleteLastNulls(Value);//   
	if (Value.Length() > 0 && Value[Value.Length()] == DecimalSeparator)
		Value.Delete(Value.Length(),1); // 
}

void TInfoToolDecimalEdit::ToCorrectValue(AnsiString & Value)
//       
{

	DeleteNoDigitSymbols(Value);//  ,   
//MessageBox(0,Value.c_str(),"    ",0);

	if (Value.Length() == 0)
	//   , ...
		return;//   

	int ValueWidth = GetCurrentValueWidth(Value);
	bool IsNegativeValue = IsNegativeCurrentValue(Value);

	if (ValueWidth > FDigitsWidth)
	//     ,
	//   , ..
	{
		if (IsNegativeValue)//  , ...
			Value.SetLength(FDigitsWidth+1);//    ( )
		else
			Value.SetLength(FDigitsWidth);//   
		ValueWidth = FDigitsWidth;
	}
	int DecimalPosition = DecimalSeparatorPosition(Value);//  
//MessageBox(0,Value.c_str()," 11",0);

	if (DecimalPosition >0 && FDecimals >0 && (Value.Length() - DecimalPosition) > FDecimals)
	//   ,  -    , 
	//  -  , ...
		Value.SetLength(DecimalPosition + FDecimals);// -    
	else if (DecimalPosition >0 && FDecimals == 0)
	{
		Value.SetLength(DecimalPosition - 1);// -  c  
		DecimalPosition = 0; //   
	}
	double CheckValue = StrToFloatDef(Value,0); //    
//MessageBox(0,Value.c_str()," 22",0);

	if (!(CheckValue == 0 && IsNullCurrentValue(Value)))
	//         ,
	//    Value   
	// (     ),  
	// 
		while (CheckValue == 0 && Value.Length() > 0)
		//   :
		//       
		//     ...
		{
			Value.Delete(Value.Length(),1); //   
			CheckValue = StrToIntDef(Value,0); //    
		}
//MessageBox(0,Value.c_str()," 33",0);
	if (Value.Length() == 0)
	//   , ...
		return;//   

	while (CheckValue > FMaxValue)
		//   :
		//      ...
		{
			if (DecimalPosition > 0 && static_cast<int>(CheckValue) > static_cast<int>(FMaxValue))
			//         , ...
				Value.Delete(DecimalPosition - 1,1); //      
			else
			{
				if (DecimalPosition > 0 && DecimalPosition == Value.Length())
				//   ,      , ...
					DecimalPosition = 0; //   
				Value.Delete(Value.Length(),1); //   
			}
			CheckValue = StrToIntDef(Value,0); //    
		}
	if (FMinValue > CheckValue)//     , ...
		Value = FloatToStr(FMinValue);
		
	if (IsNullCurrentValue(Value))
		Value = "0";
}

void __fastcall TInfoToolDecimalEdit::WMChar(TWMKey & Message)
{
	DWORD StartSelChar,FinishSelChar; //     
	AnsiString CurValue = Text;//    
	SendMessage(Handle,EM_GETSEL,reinterpret_cast<UINT>(&StartSelChar),reinterpret_cast<UINT>(&FinishSelChar));//          

	if (Message.CharCode == DecimalSeparator)
	//         , ...
	{
		int InsertPosition = InsertChar(CurValue,Message.CharCode,StartSelChar,FinishSelChar);//     
		if (InsertPosition > 0)
		//     , ...
			StartSelChar = InsertPosition;//   

		if (ToCheckValue(CurValue))
		//   , ...
		{
			Text = CurValue;//  
			SendMessage(Handle,EM_SETSEL,StartSelChar,StartSelChar);//    
		}
	}
	else
		inherited::Dispatch(&Message);//     
}

bool ToSaveParametersOfAttributes(TMapInfo & MapInfo, AnsiString sTable, TStrings * ItemViewLines)
//         
{
const char * const sFuncErr = "   ToSaveParametersOfAttributes. ";
	try
	{
		if(ItemViewLines->Count == 0)
			return false;

		AnsiString sMetaData = "\\InfoTool";
		AnsiString sNum;
		TViewLine * SavedViewLine;

		sTable = TrimLeft(TrimRight(sTable));
		AnsiString sLTable = LowerCase(sTable);

		MapInfo.Execute("Metadata Table \""+sTable+"\" DropKey \""+sMetaData+"\" Hierarchical");
		MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\" To format$("+IntToStr(ItemViewLines->Count)+",\"0\")");

		for(int i = 0; i < ItemViewLines->Count; ++i)
		{
			SavedViewLine = reinterpret_cast<TViewLine *>(ItemViewLines->Objects[i]);
			if (SavedViewLine != NULL)
			{
				sNum = IntToStr(i+1);
				MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\\" To \""+AnsiReplaceStr(SavedViewLine->sLineName, "\"", "\"\"")+"\"");
				MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\\" To Format$("+IntToStr(SavedViewLine->cViewType)+",\"0\")");

				if(SavedViewLine->cViewType >= 0)
				{
					MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\\" To Format$("+IntToStr((int)SavedViewLine->bColumnEditable)+",\"0\")");
					if(SavedViewLine->sColumnName != "")
					MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\\" To \""+AnsiReplaceStr(SavedViewLine->sColumnName, "\"", "\"\"")+"\"");
					else
					MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\\" To \""+AnsiReplaceStr(SavedViewLine->sExpression, "\"", "\"\"")+"\"");
				}
				else
				{
					MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\_\" To Format$("+IntToStr((int)SavedViewLine->bCaptionViewed)+",\"0\")");

					if (SavedViewLine->bCaptionViewed)
						MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\_\" To \""+IntToStr((int)SavedViewLine->ucJustify)+"\"");
				}

				if(SavedViewLine->cViewType==0)
				{
					if (SavedViewLine->ucColumnType == COL_TYPE_DATE)
					{
						if (SavedViewLine->sCustomDateFormat.Length() != 0)
							MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\__\" To \""+AnsiReplaceStr(SavedViewLine->sCustomDateFormat, "\"", "\"\"")+"\"");
						else
							MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\_\" To \""+IntToStr((int)SavedViewLine->ucDateFormat)+"\"");
					}
				}
				else if(SavedViewLine->cViewType==1)
				{
					MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\\\\" To \""+AnsiReplaceStr(SavedViewLine->sExpressionIdentifier, "\"", "\"\"")+"\"");
					MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\\\\" To \""+AnsiReplaceStr(SavedViewLine->sExpressionValue, "\"", "\"\"")+"\"");
					MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\_\\\" To \""+AnsiReplaceStr(SavedViewLine->sExpressionViewedValue, "\"", "\"\"")+"\"");
					if(MapInfo.CorrectConditionForTheTable(SavedViewLine->sListTable, SavedViewLine->sAdditionalCondition))
					MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\_\" To \""+AnsiReplaceStr(SavedViewLine->sAdditionalCondition, "\"", "\"\"")+"\"");

					if(LowerCase(TrimLeft(TrimRight(SavedViewLine->sListTable))) == sLTable)
						MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\\" To \""+AnsiReplaceStr(MapInfo_ThisTable, "\"", "\"\"")+"\"");
					else
						MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\\" To \""+AnsiReplaceStr(SavedViewLine->sListTable, "\"", "\"\"")+"\"");
				}
				else if(SavedViewLine->cViewType==2)
				{
					MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\\" To format$("+IntToStr(SavedViewLine->ListValues.size())+",\"0\")");

					for(TListValues::iterator iNumValue = SavedViewLine->ListValues.begin() ; iNumValue != SavedViewLine->ListValues.end(); ++iNumValue)
					{
						MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\\\"+IntToStr(std::distance(SavedViewLine->ListValues.begin(),iNumValue)+1)+"\\\" To \""+AnsiReplaceStr(iNumValue->sViewedValue , "\"", "\"\"")+"\"");
						MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\\\"+IntToStr(std::distance(SavedViewLine->ListValues.begin(),iNumValue)+1)+"\\\" To \""+TrimLeft(TrimRight(AnsiReplaceStr(iNumValue->sSavedValue, "\"", "\"\"")))+"\"");
					}
				}
			}
		}
		return true;
	}
	catch(Exception &e)
	{
		e.Message = sFuncErr + e.Message;
		throw;
	}
	catch(...)
	{
		throw;
	}
}

bool ToSaveParametersOfAttributes(TMapInfo & MapInfo, AnsiString sTable,const TViewLines & ViewLines)
//         
{
const char * const sFuncErr = "   ToSaveParametersOfAttributes. ";
	try
	{
		if(ViewLines.size() == 0)
			return false;

		AnsiString sMetaData = "\\InfoTool";
		AnsiString sNum;

		sTable = TrimLeft(TrimRight(sTable));
		AnsiString sLTable = LowerCase(sTable);

		MapInfo.Execute("Metadata Table \""+sTable+"\" DropKey \""+sMetaData+"\" Hierarchical");
		MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\" To format$("+IntToStr(ViewLines.size())+",\"0\")");

		for(TViewLines::const_iterator iLine = ViewLines.begin() ; iLine <= ViewLines.end(); ++iLine)
			{
			sNum = IntToStr(std::distance(ViewLines.begin(),iLine));
			MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\\" To \""+AnsiReplaceStr(iLine->sLineName, "\"", "\"\"")+"\"");
			MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\\" To Format$("+IntToStr((int)iLine->bColumnEditable)+",\"0\")");

			if(iLine->cViewType >= 0)
			{
				MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\\" To Format$("+IntToStr((int)iLine->bColumnEditable)+",\"0\")");
					if(iLine->sColumnName != "")
						MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\\" To \""+AnsiReplaceStr(iLine->sColumnName, "\"", "\"\"")+"\"");
					else
						MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\\" To \""+AnsiReplaceStr(iLine->sExpression, "\"", "\"\"")+"\"");
			}
			else
			{
				MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\_\" To Format$("+IntToStr((int)iLine->bCaptionViewed)+",\"0\")");
				if (iLine->bCaptionViewed)
					MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\_\" To \""+IntToStr(iLine->ucJustify)+"\"");
			}

			if(iLine->cViewType==0)
			{
				if (iLine->ucColumnType == COL_TYPE_DATE)
				{
					if (iLine->sCustomDateFormat.Length() != 0)
						MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\__\" To \""+AnsiReplaceStr(iLine->sCustomDateFormat, "\"", "\"\"")+"\"");
					else
						MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\_\" To \""+IntToStr((int)iLine->ucDateFormat)+"\"");
				}
			}

			if(iLine->cViewType==1)
			{
				MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\\\\" To \""+AnsiReplaceStr(iLine->sExpressionIdentifier, "\"", "\"\"")+"\"");
				MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\\\\" To \""+AnsiReplaceStr(iLine->sExpressionValue, "\"", "\"\"")+"\"");
				MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\_\\\" To \""+AnsiReplaceStr(iLine->sExpressionViewedValue, "\"", "\"\"")+"\"");
				if(MapInfo.CorrectConditionForTheTable(iLine->sListTable, iLine->sAdditionalCondition))
					MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\_\" To \""+AnsiReplaceStr(iLine->sAdditionalCondition, "\"", "\"\"")+"\"");

				if(LowerCase(TrimLeft(TrimRight(iLine->sListTable))) == sLTable)
					MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\\" To \""+AnsiReplaceStr(MapInfo_ThisTable, "\"", "\"\"")+"\"");
				else
					MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\\" To \""+AnsiReplaceStr(iLine->sListTable, "\"", "\"\"")+"\"");
			}
			else if(iLine->cViewType==2)
			{
				MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\\" To format$("+IntToStr(iLine->ListValues.size())+",\"0\")");

				for(TListValues::const_iterator iNumValue = iLine->ListValues.begin() ; iNumValue != iLine->ListValues.end(); ++iNumValue)
				{
					MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\\\"+IntToStr(std::distance(iLine->ListValues.begin(),iNumValue)+1)+"\\\" To \""+AnsiReplaceStr(iNumValue->sViewedValue , "\"", "\"\"")+"\"");
					MapInfo.Execute("Metadata Table \""+sTable+"\" SetKey \""+sMetaData+"\\"+sNum+"\\\\"+IntToStr(std::distance(iLine->ListValues.begin(),iNumValue)+1)+"\\\" To \""+TrimLeft(TrimRight(AnsiReplaceStr(iNumValue->sSavedValue, "\"", "\"\"")))+"\"");
				}
			}
		}
		return true;
	}
	catch(Exception &e)
	{
		e.Message = sFuncErr + e.Message;
		throw;
	}
	catch(...)
	{
		throw;
	}
}

bool ToTakeParametersOfAttributes(TMapInfo & MapInfo, const AnsiString & sTable,const int iRowID, TViewLines & ViewLines, AnsiString & sQueryExpressions,const bool bForCorrection)
//         
{
const char * const sFuncErr = "   ToTakeParametersOfAttributes. ";
	try
	{
		TViewLine NewViewLine;
		TListValue NewListValue;
		std::vector<unsigned int> ExpressionLines;
		AnsiString sMetaData = "\\InfoTool";	//    
		AnsiString sSelName;
		AnsiString sSelTemp;
		AnsiString sTempSelectExpression;
		AnsiString sFisrtBeginningQueryString, sSecondBeginningQueryString,
		sThirdBeginningQueryString,sFourthBeginningQueryString,sNum;
		unsigned int iCountLines, iDisplacement;
		short siCountColumns = 0, si , siColumnDisplacement = 0;

		short siSelColumnNumber = 0; //      ,
		//          
		//   ,       -
		//   ,    ,    
		//      
		bool bCorrectLine;
		bool bSelectExpression = false;

		//   ;
		ViewLines.clear();
		//    
		sQueryExpressions ="";
		sFisrtBeginningQueryString = "GetMetadata$(\""+sTable+"\",\""+sMetaData; //   , !    
		iCountLines = MapInfo.RequestInt(sFisrtBeginningQueryString+"\")"); //     

		if(iCountLines>0)
		{
			for(unsigned int i = 1 ; i < (iCountLines+1) ; ++i)
			//    ,   
			{
				bCorrectLine = false;
				NewViewLine.clear(); //    

				//   
				sNum = IntToStr(i);
				sSecondBeginningQueryString = sFisrtBeginningQueryString+"\\"+sNum; //        i, !    
				NewViewLine.cViewType = MapInfo.RequestInt(sSecondBeginningQueryString+"\\\")");

				NewViewLine.sLineName=TrimLeft(MapInfo.Request(sSecondBeginningQueryString+"\\\")", 256));

				if((NewViewLine.sLineName.Length() == 0) && (bForCorrection) && NewViewLine.cViewType >=0)
					MapInfo.Execute("print \"  \'"+sNum+"\'   \"");

				if (NewViewLine.cViewType < 0)
				{
					bCorrectLine = true;
					NewViewLine.bCaptionViewed = (MapInfo.RequestInt(sSecondBeginningQueryString+"\\_\")") == 1); //   

					if (NewViewLine.bCaptionViewed)
						NewViewLine.ucJustify = MapInfo.RequestInt(sSecondBeginningQueryString+"\\_\")") ;
				}
				else
				{
					//       ,     
					//   
					//   
					NewViewLine.bColumnEditable = (MapInfo.RequestInt(sSecondBeginningQueryString+"\\\")") == 1);
					//    
					NewViewLine.sColumnName = TrimLeft(TrimRight(MapInfo.Request(sSecondBeginningQueryString + "\\\")", 31)));
						//    
					if(NewViewLine.sColumnName.Length() == 0)
					//     ,   
					{
						NewViewLine.sExpression = TrimLeft(TrimRight(MapInfo.Request(sSecondBeginningQueryString + "\\\")", 256)));

						if(NewViewLine.sExpression.Length() > 0)
						//   ,      
							bCorrectLine = true;
						else
						//   ,      
							bCorrectLine = false;
					}
					else
					//    ,    
					{
//					MessageBox(0,NewViewLine.sColumnName.c_str(),COL_INFO_NUM,0);
//					MessageBox(0,AnsiString("ColumnInfo(\"" + sTable + "\",\"" + NewViewLine.sColumnName + "\"," + COL_INFO_NUM + ")").c_str(),"",0);

					NewViewLine.siColumnNumber = MapInfo.RequestInt("ColumnInfo(\"" + sTable + "\",\"" + NewViewLine.sColumnName + "\"," + COL_INFO_NUM + ")");

						if(NewViewLine.siColumnNumber <= 0)
						//     ,       ,
						//     ,    .
						//          
						{
							NewViewLine.sExpression = NewViewLine.sColumnName;
							NewViewLine.sColumnName = "";
							bCorrectLine = true;
						}
						else
						//    ,     
						{
							NewViewLine.ucColumnType = MapInfo.RequestInt("ColumnInfo(\""+sTable+"\",\""+NewViewLine.sColumnName+"\","+COL_INFO_TYPE+")");

							if(NewViewLine.ucColumnType > 0)
							//    ,     
								bCorrectLine = true;
							else
							//     ,         
							{
								bCorrectLine =false;
								NewViewLine.sColumnName ="";
							}
						}
					}

					NewViewLine.sCustomDateFormat = MapInfo.Request(sSecondBeginningQueryString+"\\__\")",256);
					if (NewViewLine.sCustomDateFormat.Length() == 0)
						NewViewLine.ucDateFormat = MapInfo.RequestInt(sSecondBeginningQueryString+"\\_\")");
					if((NewViewLine.sExpression=="") && (NewViewLine.sColumnName==""))
					//       ,      
					if(bForCorrection)
					{
						bCorrectLine =true;
						if (NewViewLine.sLineName.Length() == 0)
							NewViewLine.sLineName = sNum;
						MapInfo.Execute("print \"  \'"+NewViewLine.sLineName+"\'    \"");
					}
					else
						bCorrectLine =false;

					if(bCorrectLine)
					//    ,        
					{
						if(NewViewLine.sColumnName.Length() > 0)
					//     ,        
						{
							if(NewViewLine.sLineName.Length()==0)
							//    ,      
								NewViewLine.sLineName =NewViewLine.sColumnName;
						}
						else
						//     ,      
						{
							//      ,     
							++siSelColumnNumber;
							NewViewLine.siColumnNumber =siSelColumnNumber;
							//    ,     
							if(NewViewLine.sLineName.Length()==0)
								NewViewLine.sLineName =NewViewLine.sExpression;
							//       
							bSelectExpression =true;

							//    
							//       ,         = ViewLines.size()
							ExpressionLines.push_back(ViewLines.size());

							//       
							//        
							if(sTempSelectExpression.Length()==0)
								sTempSelectExpression =NewViewLine.sExpression;
							else
								sTempSelectExpression =sTempSelectExpression+","+NewViewLine.sExpression;
						}

						if(NewViewLine.cViewType==1)
						//        ,    ,
						//   ,     
						{
							//   ,     
							NewViewLine.sListTable =TrimLeft(TrimRight(MapInfo.Request(sSecondBeginningQueryString+"\\\")", 256)));
							if(NewViewLine.sListTable==MapInfo_ThisTable)
								NewViewLine.sListTable =TrimLeft(TrimRight(sTable));

							if(NewViewLine.sListTable.Length() > 0)
							//    ,      
							{
								NewViewLine.sExpressionIdentifier =TrimLeft(TrimRight(MapInfo.Request(sSecondBeginningQueryString+"\\\\\")", 256)));
								NewViewLine.sExpressionValue =TrimLeft(TrimRight(MapInfo.Request(sSecondBeginningQueryString+"\\\\\")", 256)));
								NewViewLine.sExpressionViewedValue =TrimLeft(TrimRight(MapInfo.Request(sSecondBeginningQueryString+"\\_\\\")", 256)));
								NewViewLine.sAdditionalCondition =TrimLeft(TrimRight(MapInfo.Request(sSecondBeginningQueryString+"\\_\")", 256)));

								if (NewViewLine.sExpressionValue.Length() > 0 && NewViewLine.sExpressionViewedValue.Length() == 0)
									NewViewLine.sExpressionViewedValue = NewViewLine.sExpressionValue;
								else if (NewViewLine.sExpressionValue.Length() == 0 && NewViewLine.sExpressionViewedValue.Length() > 0)
									NewViewLine.sExpressionValue = NewViewLine.sExpressionViewedValue;

								if(((NewViewLine.sExpressionIdentifier.Length()==0) || NewViewLine.sExpressionViewedValue.Length()==0))
								//        ,           
								{
									if(bForCorrection)
										MapInfo.Execute("print \"  \'"+NewViewLine.sLineName+"\'           \"");
									else
										NewViewLine.cViewType =0;
								}
							}
							else if(bForCorrection)
								MapInfo.Execute("print \"  \'"+NewViewLine.sLineName+"\'    ,      \"");
							else
							//    ,           
								NewViewLine.cViewType =0;
						}
						else if(NewViewLine.cViewType==2)
						//         ,
						//   ,     
						{
							sThirdBeginningQueryString = sSecondBeginningQueryString+"\\";
							for(int i2 = 1 ; i2 <= MapInfo.RequestInt(sThirdBeginningQueryString+"\")"); ++i2)
							{
								sFourthBeginningQueryString = sThirdBeginningQueryString + "\\" + IntToStr(i2);
								NewListValue.sViewedValue = MapInfo.Request(sFourthBeginningQueryString+"\\\")", 256);
								NewListValue.sSavedValue = MapInfo.Request(sFourthBeginningQueryString+"\\\")", 256);
								NewViewLine.ListValues.push_back(NewListValue);
							}
						}
					}
				}

				if (bCorrectLine || (!bCorrectLine && bForCorrection))
					ViewLines.push_back(NewViewLine);
			}

			if(bSelectExpression)
			//        ,
			//    
			{
				//    
				sSelName = MapInfo.SelCustomTemp("SelValues");

				if(MapInfo.Execute("Select "+sTempSelectExpression+" from \""+sTable+"\" where RowId="+IntToStr(iRowID)+" into \""+sSelName+"\" noselect"))
				//    ,      
				{
/*MessageBox(0,IntToStr(siSelColumnNumber).c_str(),MapInfo.Request("TableInfo("+sSelName+","+TAB_INFO_NROWS+")").c_str(),0);
MessageBox(0,AnsiString("TableInfo("+sSelName+","+TAB_INFO_NROWS+")").c_str(),MapInfo.Request("TableInfo("+sSelName+","+TAB_INFO_NROWS+")").c_str(),0);
MessageBox(0,TAB_INFO_NROWS,"TAB_INFO_NROWS",0);
*/
					if (siSelColumnNumber != MapInfo.RequestInt("TableInfo("+sSelName+","+TAB_INFO_NROWS+")")) //  -     
					//   ,    
					//      ,      
					{
						sSelTemp = MapInfo.SelCustomTemp("SelColsExpr");
						siColumnDisplacement = 0; //  

						if(ExpressionLines.size()>0)
							for(std::vector<unsigned int>::iterator i = ExpressionLines.begin(); i != ExpressionLines.end() ; ++i)
							//    
							{
								if((*i) <= ViewLines.size()-1)
								// ,           
								{
									if (siColumnDisplacement != 0) //     ,  ...
										ViewLines[ (*i) ].siColumnNumber = ViewLines[ (*i) ].siColumnNumber + siColumnDisplacement; //     

									//   
									if(MapInfo.Execute("Select "+ViewLines[ (*i) ].sExpression+" from \""+sTable+"\" where RowId=0 into \""+sSelTemp+"\" noselect"))
									//   ,  ...
									{
										siCountColumns = MapInfo.RequestInt("TableInfo("+sSelTemp+","+TAB_INFO_NCOLS+")"); //     
										if (siCountColumns>1) //    
											siColumnDisplacement = siColumnDisplacement + (siCountColumns - 1); //     ,        ,        
										MapInfo.CloseTable(sSelTemp);
									}
									else
									//   ...
									{
									//     ,          
									}
								}
							}
					}

					//            
					if(ExpressionLines.size()>0)
						for(std::vector<unsigned int>::iterator i = ExpressionLines.begin(); i != ExpressionLines.end() ; ++i)
						//    
						{
							ViewLines[ (*i) ].ucColumnType = MapInfo.RequestInt("ColumnInfo(\""+sSelName+"\",\"COL"+IntToStr(ViewLines[ (*i) ].siColumnNumber)+"\","+COL_INFO_TYPE+")");
						}
				}
				else
				//     ,     
				{
					//    ,     
					sTempSelectExpression ="";
					//   
					sSelName ="";
					//  ,   
					//     , , ,   
					//     ,      , 
					//      ,    .
					//   ,    . .     ,
					//    
					iDisplacement =0; //  
					siSelColumnNumber =0; //   
					sSelTemp = MapInfo.SelCustomTemp("SelColsExpr");

					if(ExpressionLines.size()>0)
						for(std::vector<unsigned int>::iterator i = ExpressionLines.begin(); i != ExpressionLines.end() ; ++i)
						//    
						{
							if(iDisplacement>0)
							//    ,   
								(*i) = (*i) - iDisplacement;
							// ,           
							if((*i) <= ViewLines.size()-1)
							//      
							//   
								if(MapInfo.Execute("Select "+ViewLines[ (*i) ].sExpression+" from \""+sTable+"\" where RowId=0 into \""+sSelTemp+"\" noselect"))
								//   ,  ...
								{
									// ...    
									++siSelColumnNumber;
									// ...     
									ViewLines[(*i)].siColumnNumber =siSelColumnNumber;
									// ..      
									//        
									if(sTempSelectExpression.Length() == 0)
										sTempSelectExpression = ViewLines[(*i)].sExpression;
									else
										sTempSelectExpression = sTempSelectExpression+","+ViewLines[(*i)].sExpression;
									siCountColumns = MapInfo.RequestInt("TableInfo("+sSelTemp+","+TAB_INFO_NCOLS+")"); //     

									if (siCountColumns>1) //    
										siSelColumnNumber = siSelColumnNumber + (siCountColumns - 1); //     ,        ,        
									MapInfo.CloseTable(sSelTemp);
								}
								else
								//   ...
								{
									if(bForCorrection)
									//     
										MapInfo.Execute("print \"  \'"+ViewLines[ (*i) ].sLineName+"\'   \"");
									else
									//      
									{
										// ...  ,        
										for(std::vector<unsigned int>::iterator i2 =  i  ; i2 != (ExpressionLines.end() - 1) ; ++i2)
										{
										std::vector<unsigned int>::iterator i3 = i2;
										++i3;
										ViewLines[(*i2)] = ViewLines[*(i3)];
										}
									ViewLines.pop_back();
									// ...  
									++iDisplacement;
									}
								}
						}

					if(iDisplacement>0)
					//    ,    
						ExpressionLines.resize(ExpressionLines.size()-iDisplacement);

					if(!bForCorrection && (sTempSelectExpression.Length() >0))
					//           ...
					{
						//    
						sSelName =MapInfo.SelCustomTemp("SelValues");
						//  
						if(!MapInfo.Execute("Select "+sTempSelectExpression+" from \""+sTable+"\" where RowId="+IntToStr(iRowID)+" into \""+sSelName+"\" noselect"))
						//     ,    
						{
							sTempSelectExpression ="";
							sSelName ="";
							iDisplacement =0;

							for(std::vector<unsigned int>::iterator i= ExpressionLines.begin() ; i != ExpressionLines.end() ; ++i)
							//    , ,   
							{
								if(iDisplacement>0)
									(*i) = (*i)-iDisplacement;

								if((*i) <= ViewLines.size()-1)
								{
									for(std::vector<unsigned int>::iterator i2 = i ; i2 != ExpressionLines.end() ; ++i2)
									{
										std::vector<unsigned int>::iterator i3 = i2;
										++i3;
										ViewLines[ (*i2) ] = ViewLines[ *i3];
									}
									ViewLines.pop_back();
									++iDisplacement;
								}
							}
						}
						else
						//    
						{
							if(ExpressionLines.size()>0)
							for(std::vector<unsigned int>::iterator i = ExpressionLines.begin(); i != ExpressionLines.end() ; ++i)
							//    
							{
								ViewLines[ (*i) ].ucColumnType = MapInfo.RequestInt("ColumnInfo(\""+sSelName+"\",\"COL"+IntToStr(ViewLines[ (*i) ].siColumnNumber)+"\","+COL_INFO_TYPE+")");
							}
						}
					}
				}
			}
			else
				sSelName = "";

			if(sSelName.Length() > 0)
				sQueryExpressions = sSelName;

			if(ViewLines.size()>0)
				return true;
		}
		//     ,     
		siCountColumns = MapInfo.RequestInt("Tableinfo("+sTable+","+TAB_INFO_NCOLS+")");

		if(siCountColumns <=0)
			return false;
		for(si = 1 ; si <= siCountColumns ; ++si)
		{
			NewViewLine.clear();
			NewViewLine.sColumnName = MapInfo.Request("Columninfo(\""+sTable+"\",\"COL"+IntToStr(si)+"\","+COL_INFO_NAME+")", 256);
			NewViewLine.siColumnNumber =si;
			NewViewLine.sLineName =NewViewLine.sColumnName;
			NewViewLine.ucColumnType =MapInfo.RequestInt("Columninfo(\""+sTable+"\",\"COL"+IntToStr(si)+"\","+COL_INFO_TYPE+")");
			NewViewLine.bColumnEditable = static_cast<bool>(MapInfo.RequestInt("format$(Columninfo(\""+sTable+"\",\"COL"+IntToStr(si)+"\","+COL_INFO_EDITABLE+"),\"0\")"));
			ViewLines.push_back(NewViewLine);
		}
		return true;
	}
	catch(Exception &e)
	{
		e.Message = sFuncErr + e.Message;
		throw;
	}
	catch(...)
	{
		throw;
	}
}
//END


















